m_objects_for_buy={}
m_rewards_objects={}
objects_table_delegate = {}


function on_init_dialog()

	dialog.theme_flags = 2

	dialog:load_content('action_four_plus_n_dlg')
	
	create_dialog_elements()
	
end

function update_content()
    m_table:update_content()
    local enable_take_reward = true
    for i = 0, #m_objects_for_buy-1 do
        if is_object_bought(i) == false then
            enable_take_reward = false
        end
    end
    local take_present_button = dialog:find_child("take_present_button", true, false)
    if take_present_button then
        take_present_button.active = enable_take_reward
    end

end


function read_sale_data()

    print("[FOUR_N] ####READ DATA#####")
    m_storage=framework:four_n_sales_info_storage()
    print("[FOUR_N] sale name ",m_sale_name);
    m_sale=m_storage:get_four_n_info(m_sale_name)

    local is_payer=framework:game().is_payer

    if(is_payer) then
        m_reward_key="reward_payer"
    else
        m_reward_key="reward_free"
    end

    m_action_set_name=m_sale:get_action_set_name()

    m_action_name=m_sale:get_action_id()

    m_action_time=m_sale:get_action_time()/1000
    
    action_object_info = framework:object_factory():get_object_info_by_type_name(m_action_set_name)
    
    local objects_for_buy
    
    objects_for_buy=action_object_info:get_consumes()
    
    
    for i=1,#objects_for_buy do
       m_objects_for_buy[i]=framework:object_factory():get_object_info_by_type_name(objects_for_buy[i])
    end
    
    
    m_rolls=action_object_info:get_drop_rolls(m_reward_key)
    
    local rewards
    
    if(2<=#m_rolls) then
       rewards=m_rolls[2]:get_items()
    end
    
    
    for i=1,#rewards do
       m_rewards_objects[i]=framework:object_factory():get_object_info_by_type_name(rewards[i].type_name)
    end
    
    if(0 == #m_rolls) then
       print("[FOUR_N] empty rolls")
    end

    print("[FOUR_N] m_action_name ",m_action_name,"action_set_name ",m_action_set_name,"num rolls=",#m_rolls,"num objects_for_buy ",#m_objects_for_buy)

end


function check_object_existence(type_name)
    return misc_functions.find_object_on_field(type_name) ~= nill or misc_functions.find_object_in_barn(type_name, false) == true 
end


function create_dialog_elements()
    print("[FOUR_N] create dialog elements")
    read_sale_data() 
    set_dialog_images()
    m_table = dialog:find_child("objects_table", true, false)
    m_table.delegate = objects_table_delegate
    m_table:on_create()
    
    m_table.enable_vertical_scroll=false
    local timer_label = dialog:find_child("time_label", true, false)
    local timer_label_old = dialog:find_child("time_label_old", true, false)

    if timer_label then
        if timer_label_old then
            timer_label_old.visible = false
        end
        m_timer_label = timer_label
    else
        m_timer_label = timer_label_old
    end

    m_timer_label.time = m_action_time 
    
 
    local dialog_title = dialog:find_child("dialog_title", true, false)

    if dialog_title then
        dialog_title.caption=framework:get_client_string( m_action_name..":title")
        --if(#dialog_title.caption <= 0) then
        --   dialog_title.caption=framework:strings():load("*FourNActionDlgTitle","Action 4+N")
        --end
    end
    
    local action_description = dialog:find_child("action_four_plus_description_label", true, false)
    if action_description then
        action_description.caption = m_sale.action_dlg_description
    end
    
    local balance_widget = dialog:find_child("balance_widget", true, false)
    if balance_widget then
        balance_widget.composition = "gold"
        balance_widget.use_standart_size = "no"
        balance_widget:layout_controls()
    end
    

    if(3<=#m_rewards_objects) then
        local rare_object_image_texture = dialog:find_child("rare_object_image_texture", true, false)
        if rare_object_image_texture then
            local rare_object_image = m_rewards_objects[3].shop_image_path
            rare_object_image_texture.texture_name = rare_object_image
        end
        
        if(check_object_existence(m_rewards_objects[3].type_name)) then
	        local rare_chance_object_check = dialog:find_child("rare_chance_object_check", true, false)
	        if(rare_chance_object_check) then
	            rare_chance_object_check.visible=true
	        end
	    end
	
    
        local middle_chance_object_image_texture = dialog:find_child("middle_chance_object_image_texture", true, false)
        if middle_chance_object_image_texture then
            local middle_object_image = m_rewards_objects[2].shop_image_path
            middle_chance_object_image_texture.texture_name = middle_object_image
        end
        
        if(check_object_existence(m_rewards_objects[2].type_name)   ) then
	        local middle_chance_object_check = dialog:find_child("middle_chance_object_check", true, false)
	        if(middle_chance_object_check) then
	            middle_chance_object_check.visible=true
	        end
	    end
    
        local high_chance_object_image_texture = dialog:find_child("high_chance_object_image_texture", true, false)
        if high_chance_object_image_texture then
            local high_object_image = m_rewards_objects[1].shop_image_path
            high_chance_object_image_texture.texture_name = high_object_image
        end
        
        if(check_object_existence(m_rewards_objects[1].type_name)) then
	        local high_chance_object_check = dialog:find_child("high_chance_object_check", true, false)
	        if(high_chance_object_check) then
	            high_chance_object_check.visible=true
	        end
	    end
   
    else 
        print("[FOUR_N] RECEIVED LESS THEN 3 reward args from FOUR_N INFO")
    end
   
    local take_present_button = dialog:find_child("take_present_button", true, false)
    enable_take_reward = true
    if take_present_button then
        take_present_button.active = enable_take_reward
    end
    update_content()
end

function on_take_present_button_action()
    print("[FOUR_N] get rewards btn pressed")
    get_rewards()

    local take_present_button = dialog:find_child("take_present_button", true, false)
    if take_present_button then
        take_present_button.active = false
    end
    
end

function on_take_present_button_unactive_action()
  show_info_message()
  print("[FOUR_N] show info message")
end

function show_object_info_dialog(object_info)
    local info_dlg = cclasses.sqc_scriptable_dialog.create(framework:windows().desktop, "object_info_msgbox.lua")
    
	if info_dlg and object_info then
	    info_dlg.scripting_object.m_object_info = object_info	
	    info_dlg:do_modal()
	end
end


function add_image_name_prefix_postfix(image_name)
    local image_name2=image_name

    if not g_device.is_phone then
        image_name2=image_name2 .. "_ipad"
    end

    local prefix="actions/".. "four_n_actions" .."/" 

    image_name2=prefix .. image_name2

    print("image_name ",image_name2)
    return image_name2
end


function set_dialog_images()

    local presents_bg=dialog:find_child("presents_bg", true, false)

    if(presents_bg) then
       presents_bg.image_name=add_image_name_prefix_postfix("prizes")
    else
        print("presents_bg not found")
    end
   
 
    local rare_object_button=dialog:find_child("rare_object_button", true, false)

    if(rare_object_button) then
        rare_object_button.image_name=add_image_name_prefix_postfix("blue_btn_0")
    else
        print("rare_object_button not found")
    end
 

    local middle_chance_object_button=dialog:find_child("middle_chance_object_button", true, false)

    if(middle_chance_object_button) then
        middle_chance_object_button.image_name=add_image_name_prefix_postfix("green_btn_0")
    else
        print("middle_chance_object_button not found")
    end


    local high_chance_object_button=dialog:find_child("high_chance_object_button", true, false)

    if(high_chance_object_button) then
        high_chance_object_button.image_name=add_image_name_prefix_postfix("orange_btn_0")
    else
        print("high_chance_object_button not found")
    end


    local table_bg=dialog:find_child("table_bg", true, false)

    if(table_bg) then
       table_bg.image_name=add_image_name_prefix_postfix("four_plus_n_table_bg")
    else
        print("table_bg not found")
    end

    local arrow_img=dialog:find_child("arrow_img", true, false)

    if(arrow_img) then
        arrow_img.image_name=add_image_name_prefix_postfix("action_four_plus_n_arrow")
    else
        print("action_four_plus_n_arrow not found")
    end
    
    local description_bg=dialog:find_child("description_bg", true, false)

    if(description_bg) then
        description_bg.image_name=add_image_name_prefix_postfix("four_n_info")
    else
        print("four_n_info not found")
    end
    

end



function set_cell_images(cell_parent)

    local grey_item = cell_parent:find_child("gray_bg_image", true, false)
    if(grey_item) then
        grey_item.image_name=add_image_name_prefix_postfix("four_plus_n_item_grey")
    else
        print("grey_item not found")
    end

    local grey_item = cell_parent:find_child("green_bg_image", true, false)
    if(grey_item) then
        grey_item.image_name=add_image_name_prefix_postfix("four_plus_n_item_green")
    else
        print("green_bg_image not found")
    end
    
    local object_image_bg=cell_parent:find_child("object_image_bg", true, false)
    
    if(object_image_bg) then
        object_image_bg.image_name=add_image_name_prefix_postfix("item_ico_bg")
    else
       print("object_image_bg not found")
    end
    
    local object_image_top_plate=cell_parent:find_child("object_image_top_plate", true, false)
    
    if(object_image_top_plate) then
        object_image_top_plate.image_name=add_image_name_prefix_postfix("item_ico_bg")
    else
       print("object_image_top_plate not found")
    end
    
    
    local was_bought_bg=cell_parent:find_child("was_bought_bg", true, false)
    
    if(was_bought_bg) then
        was_bought_bg.image_name=add_image_name_prefix_postfix("item_ico_bg")
    else
       print("was_bought_bg not found")
    end
                
end

function show_prize_info_dialog(reward_info)
    local info_dlg = cclasses.sqc_scriptable_dialog.create(framework:windows().desktop, "prize_object_info_msgbox.lua")
	if info_dlg and reward_info then
		info_dlg.scripting_object.m_reward_info = reward_info
		info_dlg.scripting_object.m_sale_name = m_sale_name
		
		info_dlg:do_modal()
	end
end

function on_high_chance_object_image_button_action()
     show_object_info_dialog(m_rewards_objects[1])
end

function on_middle_chance_object_image_button_action()
     show_object_info_dialog(m_rewards_objects[2])
end

function on_rare_object_image_button_action()
     show_object_info_dialog(m_rewards_objects[3])
end

function objects_table_delegate:create_cell(idx, rect)

    local cell_parent = framework:json_ui_manager():create_widget(self.table, "milk_touch_widget",rect)

    framework:json_ui_manager():build_from_resource("action_four_plus_n_cell", cell_parent)
    set_cell_images(cell_parent)
    cell_parent.rect = rect
    
    if idx > #m_objects_for_buy then
        return cell_parent
    end

    local object = m_objects_for_buy[idx+1]
    
    if object == nil then
        return cell_parent
    end

    local is_object_bought = is_object_bought(idx)
    
    local cell_bg
    if is_object_bought then
        cell_bg = cell_parent:find_child('green_bg_image', true, false)
    else
        cell_bg = cell_parent:find_child('gray_bg_image', true, false)
    end
    cell_bg.visible = true
        
    local object_image = cell_parent:find_child('object_image_texture', true, false)
    if object_image then
        object_image.texture_name = object.shop_image_path
    end
        
    local object_name = cell_parent:find_child('object_name', true, false)
    if object_name then
        object_name.caption = object.description
    end

    local was_bought_bg = cell_parent:find_child('was_bought_bg', true, false)
    
    
        
    local buy_button = cell_parent:find_child('buy_button', true, false)
    
    if(buy_button) then
        buy_button.action = function()
			on_buy_button(idx)
        end
     
    end
   
        
    local buy_label = cell_parent:find_child('buy_button_label', true, false)
    if buy_label then
        buy_label.caption = string.format(buy_label.caption, object.cost_buy_real)
        buy_label.image_name = buy_label.image_name
    end
   
    
    --local info_button = cell_parent:find_child('info_button', true, false)
    --if info_button then
    --    info_button.action = function()
    --        on_info_button(idx)
    --    end
    --end
    
    local object_image_button = cell_parent:find_child('object_image_button', true, false)
    if object_image_button then
        object_image_button.action = function()
            on_info_button(idx)
        end
    end
    
    local object_image_top_plate = cell_parent:find_child('object_image_top_plate', true, false)

    if is_object_bought then
        buy_button.visible = false
        was_bought_bg.visible = true
        object_image_top_plate.visible = true
    else
        buy_button.visible = true
        was_bought_bg.visible = false
        object_image_top_plate.visible = false
    end
    
    return cell_parent
        
end
    
function objects_table_delegate:get_cell_count()
    return #m_objects_for_buy
end

function on_timer(tick)
    if(m_sale) then
        m_action_time=m_sale:get_action_time()/1000
    
        if m_action_time <= 0 then
            dialog:end_dialog()
        end
     
        m_timer_label.time = m_action_time
    end
    
end

function check_is_enough_resources_for_object(idx,resource_enough_table)
    local water =framework:game().water
    local max_water =framework:game().max_water
    local power=framework:game().power
    local max_power=framework:game().max_power
    local object=m_objects_for_buy[idx+1]
    
    
    local water_consume=object.water_consume
    local power_consume=object.power_consume
		
	if((max_water - (water+water_consume) ) < 0) then
        resource_enough_table.is_enough_water=false
    end
    
    if((max_power - (power+power_consume) ) < 0 ) then
        resource_enough_table.is_enough_power=false
    end
   
end

function on_buy_button(idx)

    local object=m_objects_for_buy[idx+1]
    print("object_type ",object.type_name,"index ",idx+1)
    local gold = framework:game().gold
        
    if gold < object.cost_buy_real then
        framework:dialogs():show_show_not_enough_bucks_dialog(3)
    elseif framework:settings_controller().gold_warning_enabled then
        local params = { }
        params.product = object.description
        params.price = object.cost_buy_real
        params.ok_callback = function() on_buy_button_pressed(object, idx) end
        params.no_callback = function() end
        
        framework:dialogs():show_buy_for_megabucks_dialog(params)
    else
        on_buy_button_pressed(object, idx)
    end
end

function on_info_button(idx)
    show_object_info_dialog(m_objects_for_buy[idx+1])
end

function  on_buy_button_pressed(object, idx)
	local resource_enough_table={}
    resource_enough_table.is_enough_water=true
    resource_enough_table.is_enough_power=true
    check_is_enough_resources_for_object(idx,resource_enough_table)
            
    if(not resource_enough_table.is_enough_water or not resource_enough_table.is_enough_power) then
        show_not_enough_dialog(resource_enough_table)
    else
		local obj_coordinates=scene_view_routine.get_field_view_center( framework:scene_view() )
		framework:country_view():on_object_purchased(object.type_name,obj_coordinates)
		framework:windows():close_all_modals()
	end
end


function  show_not_enough_dialog(resource_enough_table)
   if(not resource_enough_table.is_enough_water) then
      city_notenough_dialogs.show_not_enough_water_dialog()
   elseif (not resource_enough_table.is_enough_power) then
      city_notenough_dialogs.show_not_enough_energy_dialog()
   end
end

function is_object_bought(idx)
    print("index ",idx) 
    local object=m_objects_for_buy[idx+1]
    
    local type_name=object.type_name .. "_pseudo"
    
    print("is_object_buy ",type_name)
    
    if(framework:game():check_barn_item(type_name)) then
        return true;
    else
        return false;
    end
end


function get_rewards()
    local reward=framework:game():check_drop_rolls(m_rolls)

    local cmd_name = "sqc_four_n_action_reward_command"
    local cmd_meta = cclasses[cmd_name]
    if not cmd_meta then
	error('not found command class ' .. cmd_name)
    end    
    
    local reward_info
    local cmd

    if(reward) then
       print("congratilations! received reward ",reward)
       reward_info = framework:object_factory():get_object_info_by_type_name(reward)
       cmd = cmd_meta.new(m_action_name,m_action_set_name,game.native.room_id)

       local callbacks={}

       callbacks["success"] = function()
                                  if(reward_info) then
                                      dialog:end_dialog()
                                      show_prize_info_dialog(reward_info)
                                  end
			      end

        callbacks["error"] = function()
           print("command complete error")
        end
        
        send_cmd(cmd,callbacks) 
    else
       print("[FOUR_N]Returned empty rewards")
    end

end

function send_cmd(cmd,callbacks)
    local cb = callbacks

    if cb.success then
       cmd:append_complete_callback(cb.success)
    end

    if cb.error then
       cmd:append_error_callback(cb.error)
    end

    framework:cmd_processor():schedule(cmd)
end




function show_info_message()
    local params={}
    -- 0: sqc_message_box_type_default
    -- 1: sqc_message_box_type_local_error
    -- 2: sqc_message_box_type_server_error
    params.type = 1
    params.dlg_text=framework:get_client_string( "four_n_action:cant_get_reward")
    params.button_text=framework:strings():load("*CityOKButton","OK" )
    framework:dialogs():show_message_box( params );
end
