function on_init_dialog( )
    print("competition_rewards_lua_v_1.02")         -- for controlling of old script using

    dialog.theme_flags = 34
    dialog.bevel_type = 0

    if competition_controller then
        m_controller = competition_controller
    end

    dialog:load_content('city_competition_rewards_dlg')

    m_top_rewards = m_controller:get_top_rewards()
    --print(#m_top_rewards)
    --for i = 1,  #m_top_rewards do
    --    print(m_top_rewards[i].position_min)
    --    print(m_top_rewards[i].position_max)
    --    print(m_top_rewards[i].object_type_name)
    --end

    m_score_rewards = m_controller:get_score_rewards()
    --print(#m_score_rewards)
    --for i = 1,  #m_score_rewards do
    --    print(m_score_rewards[i].points)
    --    print(m_score_rewards[i].is_taken)
    --end

    --test_score_rewards = {{points=10, is_taken=false}, {points=20, is_taken=false}, {points=30, is_taken=false}}
    --m_score_rewards = test_score_rewards

    --test_top_rewards = {{position_min=1001, position_max=4000, object_type_name="night_club_real"}, 
    --                    {position_min=101, position_max=1000, object_type_name="night_club_real"}, 
    --                    {position_min=11, position_max=100, object_type_name="night_club_real"}, 
    --                    {position_min=1, position_max=10, object_type_name="night_club_real"}, 
    --                    {position_min=0, position_max=1, object_type_name="night_club_real"}}
    --m_top_rewards = test_top_rewards

    create_dialog_elements()

    if m_controller.data_source_bool then
        on_tab_theme_button_world_action()
    else
        on_tab_theme_button_local_action()
    end
    
end

function on_post_init_dialog( )
    local info_button = dialog:find_child( "info_button", true, false )
    if info_button then
        info_button.action = 
            function( tick )
				on_info_button_action()
            end
    end
end

function end_dialog( )
end

function notify_callback(s_provider_id, s_event_id)
    print ("notify_callback from lua: " .. s_provider_id.."  "..s_event_id)
    if s_provider_id == "command_processor_provider_id" then
        if s_event_id == "command_processor_initial_xml_complete_event" then 
            update_content()
        end
    end
end

function on_info_button_action()
	
    print ("on_info_button_action()")
    
    if m_controller:on_info_button_pressed() then
        -- dialog:end_dialog()
    end
    
end

function create_dialog_elements()

    local tab_theme_button_world = dialog:find_child( "tab_theme_button_world", true, false )
    if tab_theme_button_world then
        
        tab_theme_button_world.button_type = sqc.framework.city_theme_button_type.tab
        
        tab_theme_button_world.action = 
            function( tick )
				on_tab_theme_button_world_action()
            end
        
    end

    local tab_theme_button_local = dialog:find_child( "tab_theme_button_local", true, false )
    if tab_theme_button_local then
        
        tab_theme_button_local.button_type = sqc.framework.city_theme_button_type.tab
        
        tab_theme_button_local.action = 
            function( tick )
				on_tab_theme_button_local_action()
            end
        
    end
    

   m_bevel = dialog:find_child( "main_bevel", true, false ) 
   
    ---- bottom panel
    local panel_bottom = m_bevel:find_child( "panel_bottom", true, false )
    if panel_bottom then

        ---- need created "progress_bottom" widget
        local progress_group = panel_bottom:find_child( "progress_group", true, false)
        if progress_group then
            competition_progress_ns:create_progress_elements(progress_group, m_score_rewards, m_controller.player_points)
        end

        --
        local get_reward_button = panel_bottom:find_child( "get_reward_button", true, false )
        if get_reward_button then
            get_reward_button.action = on_get_reward_button_pressed
        end
    end
end

function has_not_taken_score_reward(score_reward, player_points)
    for ii=1, #score_reward do
        if (player_points >= score_reward[ii].points) and (not score_reward[ii].is_taken) then 
            return true
        end
    end

    return false
end

function update_content()


    m_bevel = dialog:find_child( "main_bevel", true, false )
    
    local title_label = m_bevel:find_child( "title", true, false )

    local player_position = m_controller.player_position

    local s_default = framework:strings():load( "*CityCompetitionRewardsTitle", "Rise to the top and get the rewards:")
    
    if player_position<0 then
        local str = framework:strings():load( "*CityCompetitionRewardsCaptionUnknown", "Unknown position")
        title_label.caption = str .. " " .. s_default
    else
        local str = string.format( framework:strings():load( "*CityCompetitionRewardsCaption_d", "Your position: %d") , player_position)
        title_label.caption = str .. " " .. s_default
    end

    ---- spinboard
    m_rewards_spinboard = m_bevel:find_child("rewards_spinboard",true,false)
    if m_rewards_spinboard then
        m_rewards_spinboard:update_content()    
    end
    
    local player_points = m_controller.player_points

    m_top_rewards = m_controller:get_top_rewards()
    m_score_rewards = m_controller:get_score_rewards()

    local has_not_taken = has_not_taken_score_reward(m_score_rewards, player_points)
    local hide_progress = (not has_not_taken) and (player_points > competition_progress_ns:get_max_points_score_rewards(m_score_rewards))

    -- UPDATE PROGRESS and POINTS
    local panel_bottom = m_bevel:find_child( "panel_bottom", true, false )
    if panel_bottom then
        local progress_group = panel_bottom:find_child( "progress_group", true, false)
        if progress_group then
            progress_group.visible = (not hide_progress)
            competition_progress_ns:update_content_progress(progress_group, player_points, m_score_rewards)
        end

        local panel_player_points = panel_bottom:find_child( "panel_player_points", true, false )
        if panel_player_points then
            panel_player_points.visible = (not has_not_taken)

            local label_player_points = panel_player_points:find_child( "label_player_points", true, false )
            if label_player_points then
                label_player_points.caption = tostring(player_points)
                label_player_points.visible = (not has_not_taken)
            end
        end

        local label_player_points_desc = panel_bottom:find_child( "label_player_points_desc", true, false )
        if label_player_points_desc then
            label_player_points_desc.visible = (not has_not_taken)
        end

        local get_reward_button = panel_bottom:find_child( "get_reward_button", true, false )
        if get_reward_button then
            get_reward_button.visible = has_not_taken
        end

    
        local label_get_more_points = panel_bottom:find_child( "label_get_more_points", true, false)
        if label_get_more_points then
    
            if hide_progress then    
        
        
        
                if m_controller.player_position == 1 then
                    local str = framework:strings():load( "*CityCompetitionRewardsPanelBestPosition", "Congratulations, you are on first place!")
                    label_get_more_points.caption = str
                    label_get_more_points.visible = true
                else 
                    local str = framework:strings():load( "*CityCompetitionRewardsPanelMorePoints_d_d", "Get %d points more for getting up to TOP %d and receive gift.")

                    local next_top = m_controller.nearest_top
                    local more_points = m_controller.nearest_top_points
                    
                    --print("next_top="..next_top)
                    --print("more_points="..more_points)

                    if next_top > 0 then 
                        label_get_more_points.caption = string.format(str, more_points, next_top)
                        label_get_more_points.visible = true
                    else 
                        label_get_more_points.caption = framework:strings():load( "*CityCompetitionRewardsCellDescription_error", "Failed to load the correct list of players")
                        label_get_more_points.visible = true
                    end
                end
                
            else
                label_get_more_points.visible=false
            end
        end
       

        local _label_progress = panel_bottom:find_child( "panel_text_with_progress", true, false)
        if _label_progress then
            _label_progress.visible = (not hide_progress)
        end
    end
end

function on_get_reward_button_pressed()
    m_controller:on_get_reward_button_pressed()
    dialog:end_dialog()
end

rewards_spinboard_delegate  = {}
function rewards_spinboard_delegate:create_cell ( idx, rect )
    local player_position = m_controller.player_position
    ---- DEBUG
    -- player_position = 98
    ---- DEBUG

    local w = self.spinboard:create_child(rect)
    framework:json_ui_manager():build_from_resource("city_competition_rewards_cell", w)
    w.rect = rect

    -- set title
    local title = w:find_child("cell_title",true,false)
    if title then
        if m_top_rewards[idx+1].position_max == 999999 then 
            title.caption = framework:strings():load( "*CityCompetitionRewardsCellDescription_first", "For participation\nin competition")
        else
            local str = framework:strings():load( "*CityCompetitionRewardsCellDescription_d", "TOP\n%u")
            title.caption = string.format(str, m_top_rewards[idx+1].position_max)
        end
    end

    -- set background
    local cell_bg = w:find_child("cell_bg",true,false)
    if cell_bg then
        local bg_image_name = "gift_info_item_";

        if m_top_rewards[idx+1].position_min == 999999 then
            bg_image_name = bg_image_name .. "green"
        elseif player_position == -1 then
            bg_image_name = bg_image_name .. "grey"
        elseif player_position < m_top_rewards[idx+1].position_min then
            bg_image_name = bg_image_name .. "green"
        elseif player_position > m_top_rewards[idx+1].position_max then
            bg_image_name = bg_image_name .. "grey"
        else
            bg_image_name = bg_image_name .. "yellow"
        end

        if g_device.is_tablet then
            bg_image_name = bg_image_name .. "_ipad"
        end

        cell_bg.image_name = bg_image_name
    end

    -- hide check_image for all TOP n
    local cell_check_image = w:find_child("competition_cell_check",true,false)
    if cell_check_image then
        if m_top_rewards[idx+1].position_min ~= 999999 then
            cell_check_image.visible = false
        end
    end
    

    ---- cell item proxy image
    local cell_reward_image = w:find_child("cell_reward_image", true, false)
    if cell_reward_image then
        local info_provider = framework:object_factory()
        local object_info = info_provider:get_object_info_by_type_name( m_top_rewards[idx+1].object_type_name )
        if object_info then
            cell_reward_image.texture_name = object_info.shop_image_path
            cell_reward_image:set_ready_progress_as_indicator()
        end
    end

    --
    local cell_info_bt = w:find_child("cell_info_button",true,false)
    if cell_info_bt then
        local cell_info_bt_title = cell_info_bt:find_child("cell_info_button_title",true,false)
        cell_info_bt_title.caption = framework:strings():load( "*CityCompetitionRewardsCellInfo", "Info")

        cell_info_bt.action = function() rewards_spinboard_delegate:on_cell_info_button_pressed(idx) end
    end

    local cell_top_bt = w:find_child("cell_button_on_top", true, false)
    if cell_top_bt then
        cell_top_bt.action = function() rewards_spinboard_delegate:on_cell_info_button_pressed(idx) end
    end

    return w
end

function rewards_spinboard_delegate:get_cell_count ( )
    if m_controller then
        return m_controller.top_rewards_count
    end
    return 0
end

function rewards_spinboard_delegate:on_cell_info_button_pressed(idx)
    print(idx)
    m_controller:on_cell_info_button_pressed(idx)
end



function on_tab_theme_button_world_action()
	
    m_controller.data_source_bool=true
    
    local tab_bevel_world = dialog:find_child("tab_bevel_world",true,false)
    if tab_bevel_world then
        tab_bevel_world.visible=true
	end
    
    local tab_bevel_local = dialog:find_child("tab_bevel_local",true,false)
    if tab_bevel_local then
        tab_bevel_local.visible=false
	end
    
    update_content()
    
end

function on_tab_theme_button_local_action()
	
    m_controller.data_source_bool=false
    
    local tab_bevel_world = dialog:find_child("tab_bevel_world",true,false)
    if tab_bevel_world then
        tab_bevel_world.visible=false
	end
    
    local tab_bevel_local = dialog:find_child("tab_bevel_local",true,false)
    if tab_bevel_local then
        tab_bevel_local.visible=true
	end
    
    update_content()
    
end
