competition_progress_ns  = {}

format = [[
            {
                "type": "milk_label",
                "text_halign": "center",
                "text_valign": "center",
                "caption": "100",
                "font": {"face": "Arial-BoldMT.otf", "size": %u},
                "text_shadow": true,
                "shadow_size": [-1, 1],
                "shadow_color": [0, 0, 0, 76],
                "color": [0, 0, 0, 255],
                "visible": true
            }
        ]]

function competition_progress_ns:set_format_without_color()
    format = [[
                {
                    "type": "milk_label",
                    "text_halign": "center",
                    "text_valign": "center",
                    "caption": "100",
                    "text_shadow": true,
                    "shadow_size": [-1, 1],
                    "shadow_color": [0, 0, 0, 76],
                    "font": {"face": "Arial-BoldMT.otf", "size": %u},
                    "visible": true
                }
            ]]
end

function competition_progress_ns:get_max_points_score_rewards(score_rewards)
    local max_val = 0
    for i = 1,  #score_rewards do
        if score_rewards[i].points > max_val then
            max_val = score_rewards[i].points
        end
    end

    return max_val
end

function competition_progress_ns:create_progress_elements(parent, score_rewards, player_points)
    local progress_bottom = parent:find_child( "progress_bottom", true, false )
    if progress_bottom then
        local progress_top = progress_bottom:find_child( "progress_top", true, false )

        -- COUNTERS 100, 200, ..., 900
        local max_progress_top_width = progress_bottom.rect[3] - 2 * progress_top.rect[1] - 1
        
        local max_score = competition_progress_ns:get_max_points_score_rewards(score_rewards)
        local num_of_deltas = max_score / 200

        local width_nums = max_progress_top_width / num_of_deltas
        local step = max_score / num_of_deltas

        for num=1,num_of_deltas do
            local rc_num = {progress_bottom.rect[1] + progress_top.rect[1] + num*width_nums, 10, 40, 30};

            local format_json_string = format
            
            local font_size = 14
            
            if g_device.is_tablet then      -- TABLET
                rc_num[1] = rc_num[1] - 22
            else                            -- PHONE
                rc_num[1] = rc_num[1] - 20  --x
                rc_num[2] = rc_num[2] - 13   --y
                font_size = 10
                rc_num[4] = 20              --height
            end

            -- prepare json string
            local init_json_string = string.format(format_json_string, font_size)

            -- create label            
            local label_num = framework:json_ui_manager():create_from_string(init_json_string, "label_num_", parent)

            label_num.caption = tostring( num * step )
            label_num.rect = rc_num
        end

        -- grey separators
        for num=1,num_of_deltas do
            local rc_spr = {num * width_nums, 0, 2, 17};

            local format_json_string = [[
                                            {
                                                "type": "milk_image",
                                                "halign": "left",
                                                "valign": "bottom",
                                                "image_name": "%s",
                                                "rect": [0, 0, 2, 17],
                                                "visible": true
                                            }
                                        ]]

            local spr_bg_image_name = "gift_info_progress_bg_spr_ipad"
            if g_device.is_tablet then      -- TABLET
                rc_spr[2] = rc_spr[2] + 4
            else                            -- PHONE
                rc_spr[2] = rc_spr[2] + 3
                rc_spr[1] = rc_spr[1]
                spr_bg_image_name = "gift_info_progress_bg_spr"
                rc_spr[3] = 2
                rc_spr[4] = 10
            end

            -- prepare json string
            local init_json_string = string.format(format_json_string, spr_bg_image_name)

            -- create label            
            local image_spr = framework:json_ui_manager():create_from_string(init_json_string, "spr_grey_"..num, progress_bottom)
            image_spr.rect = rc_spr
        end

        progress_top:raise()

        -- active separators
        for num=1,num_of_deltas do
            local rc_spr = {num * width_nums, 0, 1, 16};

            local format_json_string = [[
                                            {
                                                "type": "milk_image",
                                                "halign": "left",
                                                "valign": "bottom",
                                                "image_name": "%s",
                                                "rect": [0, 0, 1, 16],
                                                "visible": true
                                            }
                                        ]]

            local spr_bg_image_name = "gift_info_progress_spr_ipad"
            if g_device.is_tablet then      -- TABLET
                rc_spr[2] = rc_spr[2] + 5
            else                            -- PHONE
                rc_spr[2] = rc_spr[2] + 3
                rc_spr[3] = 2
                rc_spr[4] = 10
                spr_bg_image_name = "gift_info_progress_spr"
            end

            -- prepare json string
            local init_json_string = string.format(format_json_string, spr_bg_image_name)

            -- create label            
            local image_spr = framework:json_ui_manager():create_from_string(init_json_string, "spr_active_"..num, progress_bottom)
            image_spr.rect = rc_spr
        end
    end

    competition_progress_ns:create_progress_gifts(parent, score_rewards, player_points)
end

function competition_progress_ns:create_progress_gifts(parent, score_rewards, player_points)
    local progress_bottom = parent:find_child( "progress_bottom", true, false )
    if progress_bottom then
        local progress_top = progress_bottom:find_child( "progress_top", true, false )

        -- counters
        local max_score = competition_progress_ns:get_max_points_score_rewards(score_rewards)
        local max_progress_top_width = progress_bottom.rect[3] - 2 * progress_top.rect[1] - 1
        
        for ii=1, #score_rewards do
            local x = progress_bottom.rect[1] + (max_progress_top_width*score_rewards[ii].points)/max_score
            local rc_gift = {x, 0, 36, 39};

            local format_json_string = [[
                                            {
                                                "type": "milk_image",
                                                "halign": "left",
                                                "valign": "bottom",
                                                "image_name": "%s",
                                                "rect": [0, 0, 0, 0],
                                                "visible": true
                                            }
                                        ]]

            -- CREATE DISABLED GIFT
            local _image_name = "gift_info_progress_counter_gift_1_dis_ipad"
            if g_device.is_tablet then      -- TABLET
                rc_gift[2] = progress_bottom.rect[2] - 6
            else                            -- PHONE
                rc_gift[2] = progress_bottom.rect[2] - 8
                _image_name = "gift_info_progress_counter_gift_1_dis"
                rc_gift[3] = 28
                rc_gift[4] = 30
            end

            -- here we know real image width for tablet/phone
            rc_gift[1] = rc_gift[1] - rc_gift[3]/2

            local init_json_string = string.format(format_json_string, _image_name)
            local image_gift_dis = framework:json_ui_manager():create_from_string(init_json_string, "gift_dis_"..ii, parent)
            image_gift_dis.rect = rc_gift
            
            -- CREATE ACTIVE GIFT
            local _image_name = "gift_info_progress_counter_gift_1_ipad"
            if g_device.is_tablet then      -- TABLET
                rc_gift[2] = progress_bottom.rect[2] - 6
            else                            -- PHONE
                rc_gift[2] = progress_bottom.rect[2] - 8
                _image_name = "gift_info_progress_counter_gift_1"
            end

            local init_json_string = string.format(format_json_string, _image_name)
            local image_gift = framework:json_ui_manager():create_from_string(init_json_string, "gift_"..ii, parent)
            image_gift.rect = rc_gift

            -- CREATE green counter
            local rc_counter = {rc_gift[1], rc_gift[2], 20, 23};

            local _image_name = "gift_info_progress_counter_ipad"
            if g_device.is_tablet then      -- TABLET
                rc_counter[1] = rc_counter[1] + 20
                rc_counter[2] = rc_counter[2] + 20
            else                            -- PHONE
                rc_counter[1] = rc_counter[1] + 18
                rc_counter[2] = rc_counter[2] + 20
                _image_name = "gift_info_progress_counter"
                rc_counter[3] = 14
                rc_counter[4] = 16
            end

            local init_json_string = string.format(format_json_string, _image_name)
            local image_counter = framework:json_ui_manager():create_from_string(init_json_string, "gift_counter_"..ii, parent)
            image_counter.rect = rc_counter

            -- CREATE red counter
            local rc_counter = {rc_gift[1], rc_gift[2], 21, 24};

            local _image_name = "top_competition_counter_ipad"
            if g_device.is_tablet then      -- TABLET
                rc_counter[1] = rc_counter[1] + 20
                rc_counter[2] = rc_counter[2] + 20
            else                            -- PHONE
                rc_counter[1] = rc_counter[1] + 18
                rc_counter[2] = rc_counter[2] + 20
                _image_name = "top_competition_counter"
                rc_counter[3] = 14
                rc_counter[4] = 16
            end

            local init_json_string = string.format(format_json_string, _image_name)
            local image_counter = framework:json_ui_manager():create_from_string(init_json_string, "gift_red_counter_"..ii, parent)
            image_counter.rect = rc_counter

            -- CREATE label on red counter
            local format_gift_label_json_string = [[
                                                    {
                                                        "type": "milk_label",
                                                        "text_halign": "center",
                                                        "text_valign": "center",
                                                        "caption": "8",
                                                        "font": {"face": "Arial-BoldMT.otf", "size": %u},
                                                        "color": [255, 255, 255, 255],
                                                        "visible": true
                                                    }
                                                ]]
            
            local font_size = 13
            if g_device.is_tablet then      -- TABLET
                rc_counter[2] = rc_counter[2] + 1
            else                            -- PHONE
                font_size = 10
                rc_counter[2] = rc_counter[2] + 1
            end

            local init_json_string = string.format(format_gift_label_json_string, font_size)
            local label_num = framework:json_ui_manager():create_from_string(init_json_string, "label_gift_num_"..ii, parent)
            label_num.rect = rc_counter

            -- CREATE transparent button on top of gifts
            local button_init_json_string = [[
                                                {
                                                    "type": "milk_button",
                                                    "rect": [0, 0, 0, 0],
                                                    "halign": "left",
                                                    "valign": "bottom",
                                                    "visible": true
                                                }
                                            ]]
            local rc_btn = rc_gift;
            rc_btn[1] = rc_btn[1] - rc_btn[3]/2
            rc_btn[2] = rc_btn[2] - rc_btn[4]/2
            rc_btn[3] = 2*rc_btn[3]
            rc_btn[4] = 2*rc_btn[4]

            local button_gift = framework:json_ui_manager():create_from_string(button_init_json_string, "button_gift_"..ii, parent)
            button_gift.rect = rc_btn

            button_gift.action = function() competition_progress_ns:on_get_gift_button_pressed(ii) end
        end
    end
end

function competition_progress_ns:update_content_progress(parent, player_points, score_rewards)
    local max_points = competition_progress_ns:get_max_points_score_rewards(score_rewards)
    if player_points > max_points then
        player_points = max_points
    end

    local progress_bottom = parent:find_child( "progress_bottom", true, false )
    if progress_bottom then
        local progress_top = progress_bottom:find_child( "progress_top", true, false)
        if progress_top then
            local max_progress_top_width = progress_bottom.rect[3] - 2 * progress_top.rect[1] - 1
            local progress_top_width = (max_progress_top_width * player_points) / max_points

            local max_score = competition_progress_ns:get_max_points_score_rewards(score_rewards)
            local num_of_deltas = max_score / 200
            local step = max_score / num_of_deltas

            local tmp_rect = progress_top.rect
            tmp_rect[3] = progress_top_width
            progress_top.rect = tmp_rect

            -- separators
            for num=1,num_of_deltas do
                if num*step > player_points then
                    -- hide active
                    local spr_to_hide = progress_bottom:find_child( "spr_active_"..num, true, false)
                    if spr_to_hide then
                        spr_to_hide.visible = false
                    end
                else
                    local spr_to_show = progress_bottom:find_child( "spr_active_"..num, true, false)
                    if spr_to_show then
                        spr_to_show.visible = true
                    end
                end
            end
        end

        ---- update gifts
        local int_gift_counter = 1
        for ii=1, #score_rewards do
            local less_points = (player_points < score_rewards[ii].points)
            local taken = score_rewards[ii].is_taken

            local gift_img = parent:find_child( "gift_"..ii, true, false)
            if gift_img then
                gift_img.visible = not less_points
            end

            local gift_img = parent:find_child( "gift_dis_"..ii, true, false)
            if gift_img then
                gift_img.visible = less_points
            end

            local gift_counter = parent:find_child( "gift_counter_"..ii, true, false)
            if gift_counter then
                gift_counter.visible = (not less_points) and taken
            end

            local gift_counter = parent:find_child( "gift_red_counter_"..ii, true, false)
            if gift_counter then
                gift_counter.visible = (not less_points) and (not taken)
            end

            local gift_label = parent:find_child( "label_gift_num_"..ii, true, false)
            if gift_label then
                gift_label.visible = (not less_points) and (not taken)
                if gift_label.visible then
                    if gift_label.caption ~= tostring(int_gift_counter) then
                        gift_label.caption = tostring(int_gift_counter)

                        -- sdvig for '1', call only once
                        if int_gift_counter == 1 then
                            local rect_tmp = gift_label.rect
                            rect_tmp[1] = rect_tmp[1]-1
                            gift_label.rect = rect_tmp
                        end
                    end

                    int_gift_counter = int_gift_counter+1
                end
            end
            
        end
    end
end

function competition_progress_ns:on_get_gift_button_pressed(idx)
    print("on_get_gift_button_pressed"..idx)
    m_controller:on_get_gift_button_pressed(idx)
end