function on_init_dialog( )
    dialog.theme_flags = 34
    dialog.bevel_type = 0

    if competition_controller then
        m_controller = competition_controller
    end
	
	dialog:load_content('city_competition_rules_dlg')

	m_score_rewards = m_controller:get_score_rewards()

	create_scrolling_elements()
end

function on_post_init_dialog( )
    create_back_button()
end

function end_dialog( )
end

function create_scrolling_elements()
    local label_caption = dialog:find_child("city_competition_rules_caption", true, false)
    if label_caption then
        local str_caption = framework:get_client_string("competition:title_help")
        label_caption.caption = str_caption
    end
    
	m_bevel = dialog:find_child("rules_comp_main_bevel", true, false)
	m_table = m_bevel:find_child("table", true, false);
	if m_table then
		m_table:update_content()
		m_table:scroll_to_first_cell_top()
	end
end

function create_back_button()
    local m_btn = dialog:find_child("info_button", true, false)
    if m_btn then
        m_btn.visible = false    
    end
    local m_back_btn = dialog:find_child("back_btn", true, false)
    if m_back_btn then
        m_back_btn.action = on_back_btn
    end
end

function on_build_btn()
    dialog:end_dialog()
    m_controller:show_extra()
end

function on_goto_btn()
    m_controller:close_all_competition_dialogs()
    dialog:end_dialog()
end

function on_goto_tax_btn()
    m_controller:close_all_competition_dialogs()
    dialog:end_dialog()
    m_controller:goto_tax()
end

function on_goto_pick_btn()
    m_controller:close_all_competition_dialogs()
    dialog:end_dialog()
    m_controller:goto_pick()
end

function on_goto_clear_btn()
    m_controller:close_all_competition_dialogs()
    dialog:end_dialog()
    m_controller:goto_clear()
end

function on_back_btn()
    dialog:end_dialog()
end

function disable_pick(parent)
    local sliceimage_work_panel = parent:find_child("slice_image_work_panel", true, false)
    if sliceimage_work_panel then
        local pick_widget = sliceimage_work_panel:find_child("widget_pick", true, false)
        if pick_widget then
            pick_widget.visible = false
        end

        local pick_build = sliceimage_work_panel:find_child("widget_build", true, false)
        if pick_build then
            local rect = pick_build.rect
            rect[2] = rect[2] - 10
            pick_build.rect = rect
        end

        local pick_tax = sliceimage_work_panel:find_child("widget_tax", true, false)
        if pick_tax then
            local r = sliceimage_work_panel.rect
            local d1 = math.floor(r[4]/2)
            local rect = pick_tax.rect
            local d2 = math.floor(rect[4]/2)
            rect[2] = d1 - d2
            pick_tax.rect = rect
        end


        local pick_clear = sliceimage_work_panel:find_child("widget_clear", true, false)
        if pick_clear then
            local rect = pick_clear.rect
            rect[2] = rect[2] + 10
            pick_clear.rect = rect
        end
    end
end

table_delegate  = {

create_cell = function (self, idx, rect )
    local w = self.table:create_child(rect)
    framework:json_ui_manager():build_from_resource("city_competition_rules_scrolling_area", w)
    w.rect = rect

	local m_sliceimage_progress_panel = w:find_child("slice_image_progress_panel", true, false)
    
    local progress_group = m_sliceimage_progress_panel:find_child( "progress_group", true, false)
    if progress_group then
        competition_progress_ns:set_format_without_color()
        competition_progress_ns:create_progress_elements(progress_group, m_score_rewards)
        competition_progress_ns:update_content_progress(progress_group, m_controller.player_points, m_score_rewards)
    end


    local m_sliceimage_work_panel = w:find_child("slice_image_work_panel", true, false);

    local label_rules_build = m_sliceimage_work_panel:find_child("city_competitions_rules_build", true, false);
    local label_rules_tax = m_sliceimage_work_panel:find_child("city_competitions_rules_tax", true, false);
    local label_rules_pick = m_sliceimage_work_panel:find_child("city_competitions_rules_pick", true, false);
    local label_rules_clear = m_sliceimage_work_panel:find_child("city_competitions_rules_clear", true, false);

    if label_rules_build then
        label_rules_build.caption = framework:get_client_string(m_controller:get_competition_descr() .. ":help_upgrades")
    end
    
    if label_rules_tax then
        label_rules_tax.caption = framework:get_client_string(m_controller:get_competition_descr() .. ":help_taxes")
    end
    
    if label_rules_pick then
        label_rules_pick.caption = framework:get_client_string(m_controller:get_competition_descr() .. ":help_population")
    end
    
    if label_rules_clear then
        label_rules_clear.caption = framework:get_client_string(m_controller:get_competition_descr() .. ":help_contracts")
    end

    local m_btn_build = m_sliceimage_work_panel:find_child("button_build", true, false);
    local m_btn_tax = m_sliceimage_work_panel:find_child("button_tax", true, false);
    local m_btn_pick = m_sliceimage_work_panel:find_child("button_pick", true, false);
    local m_btn_clear = m_sliceimage_work_panel:find_child("button_clear", true, false);

    if m_btn_build then
        m_btn_build.action = on_build_btn
    end

    if m_btn_tax then
        m_btn_tax.action = on_goto_tax_btn
    end

    if m_btn_pick then
        m_btn_pick.action = on_goto_pick_btn
    end

    if m_btn_clear then
        m_btn_clear.action = on_goto_clear_btn
    end 

    local m_sliceimage_where_descr = w:find_child("slice_image_where_descr", true, false);
    local m_btn_extra = m_sliceimage_where_descr:find_child("button_open_extra", true, false);
    if m_btn_extra then
        m_btn_extra.action = on_build_btn
    end

    local m_sliceimage_intro = w:find_child("slice_image_intro", true, false);

    local str_intro = framework:get_client_string(m_controller:get_competition_descr() .. ":help_top")
    
    local str_intro_reverse=string.reverse(str_intro)

    local i_intro_reverse_found=string.find(str_intro_reverse, "\n", 1, true)


    local m_intro12 = m_sliceimage_intro:find_child("city_competitions_rules_intro12", true, false);
    local m_intro3 = m_sliceimage_intro:find_child("city_competitions_rules_intro3", true, false);
    

    if i_intro_reverse_found ~= nill then
        print("i_intro_reverse_found: " .. i_intro_reverse_found)
        
        print("string.len(str_intro): " .. string.len(str_intro))

        local str_intro12 = string.sub(str_intro, 1, string.len(str_intro) - i_intro_reverse_found )
            print("[" .. str_intro12 .. "]")
        m_intro12.caption=str_intro12

        
        local str_intro3 = string.sub(str_intro, -i_intro_reverse_found+1)
            print("[" .. str_intro3 .. "]")
        m_intro3.caption = str_intro3
    else
        m_intro3.caption = ""
    end

    local str_moments = framework:get_client_string(m_controller:get_competition_descr() .. ":help_bottom")

    print("str_moments="..str_moments)
    local i_moment1_found=string.find(str_moments, "\n", 1, true)
    if i_moment1_found ~= nill then
        local str_moment1 = string.sub(str_moments, 1, i_moment1_found-1)
        print("str_moment1: " .. "[" .. str_moment1 .. "]")
    
        local label_moment1 = w:find_child("city_competitions_rules_where", true, false);
        if label_moment1 then
            label_moment1.caption=str_moment1
        end

        str_moments=string.sub(str_moments, i_moment1_found+1, -1)
    end
    
    local i_moment2_found=string.find(str_moments, "\n", 1, true)
    if i_moment2_found ~= nill then
        local str_moment2 = string.sub(str_moments, 1, i_moment2_found-1)
        print("str_moment2: " .. "[" .. str_moment2 .. "]")

        local label_moment2 = w:find_child("city_competitions_rules_about_top", true, false);
        if label_moment2 then
            label_moment2.caption=str_moment2
        end

        str_moments=string.sub(str_moments, i_moment2_found+1, -1)
    end
    
    local i_moment3_found=string.find(str_moments, "\n", 1, true)
    if i_moment3_found ~= nill then
        local str_moment3 = string.sub(str_moments, 1, i_moment3_found-1)
        print("str_moment3: " .. "[" .. str_moment3 .. "]")
        
        local label_moment3 = w:find_child("city_competitions_rules_about_players", true, false);
        if label_moment3 then
            label_moment3.caption=str_moment3
        end

        str_moments=string.sub(str_moments, i_moment3_found+1, -1)
    end

    local i_moment4_found=string.find(str_moments, "\n", 1, true)
    if i_moment4_found ~= nill then
        local str_moment4 = string.sub(str_moments, 1, i_moment4_found-1)
        print("str_moment4: " .. "[" .. str_moment4 .. "]")

        local label_moment4 = w:find_child("city_competitions_rules_time", true, false);
        if label_moment4 then
            label_moment4.caption=string.format(string.gsub(str_moment4, "{.?}", "%%s"), m_controller:get_date_begin(), m_controller:get_date_expired())
        end
    end

    if i_moment4_found ~= nill then 
        local str_moment5 = string.sub(str_moments, i_moment4_found+1, -1)
        print("str_moment5: " .. "[" .. str_moment5 .. "]")

        local label_moment5 = w:find_child("city_competitions_rules_score", true, false);
        if label_moment5 then
            label_moment5.caption=string.format(string.gsub(str_moment5, "{.?}", "%%d"), m_controller.player_points)
        end
    end


--    local m_sliceimage_where_descr = w:find_child("slice_image_where_descr", true, false);

--    local m_rules_time = m_sliceimage_where_descr:find_child("city_competitions_rules_time", true, false)
--    local str_rules_time = framework:strings():load("*CityCompetitionRulesTime", "Competition \"%s\" passes from %s on %s.")
--    m_rules_time.caption = string.format(str_rules_time, m_controller:get_competition_descr(), m_controller:get_date_begin(), m_controller:get_date_expired())

    if g_application.is_international ~= nill then
        if not g_application.is_international then
            disable_pick(w)
        end
    else
        -- disable_pick(w)
    end

    return w
end,

get_cell_count = function ( )
    return 1
end

}
