function is_lock_interface()
    return competition_top_controller.global_last_error==1 or competition_top_controller.regional_last_error==1
end

function on_init_dialog()
    dialog:lock_interface()
    
    m_b_need_scroll_to_top_world=true
    m_b_need_scroll_to_top_local=true
    
    m_pt_scroll_pos_world = {-1, -1};
    m_pt_scroll_pos_local = {-1, -1};
        

    m_i_last_ticked_periods_count=0

    m_user_id=framework:networks():get_user_id()
    print("m_user_id: " .. m_user_id)

    dialog:load_content('city_competition_top')
    
    if competition_top_controller.calculated then
	print("competition_top_controller.calculated==true")
	dialog.theme_flags = 0
	dialog.theme_flags = dialog.theme_flags + 2 --close button
	dialog.theme_flags = dialog.theme_flags + 4 --back button
    else
	print("competition_top_controller.calculated==false")
	dialog.theme_flags = 0
	dialog.theme_flags = dialog.theme_flags + 2 --close button
	dialog.theme_flags = dialog.theme_flags + 32 --info button

        local table = dialog:find_child("table",true,false)
        local table_short = dialog:find_child("table_short",true,false)
	if table and table_short then
	    table.rect=table_short.rect
	end
    end
    
    dialog.bevel_type = 0


    
    local main_holder_widget = dialog:find_child("main_holder_widget", true, false)
    if main_holder_widget then
	main_holder_widget.visible = not competition_top_controller.calculated
    end

    local calculated_holder_widget = dialog:find_child("calculated_holder_widget", true, false)
    if calculated_holder_widget then
	calculated_holder_widget.visible = competition_top_controller.calculated
    end
    
    local calculated_info_label = dialog:find_child("calculated_info_label", true, false)
    if calculated_info_label then
	calculated_info_label.caption = framework:get_client_string(competition_top_controller.event_name .. ":archive_text")
    end
    
    local top_light_bottom_fream_image = dialog:find_child("top_light_bottom_fream_image", true, false)
    if top_light_bottom_fream_image then
	top_light_bottom_fream_image.visible = not competition_top_controller.calculated
    end
    
    m_timer_date_time_label = dialog:find_child("timer_date_time_label", true, false)
    m_timer_holder_widget = dialog:find_child("timer_holder_widget", true, false)
    
    m_gifts_count_image = dialog:find_child("gifts_count_image",true,false)
    m_gifts_count_label = dialog:find_child("gifts_count_label",true,false)
    
    update_time_related_widgets()
    update_gifts_count()
    
    local top_light_position_image_button = dialog:find_child("top_light_position_image_button",true,false)
    if top_light_position_image_button then
            m_top_light_position_image_button_caption=top_light_position_image_button.caption
	end
    
    local info_label = dialog:find_child("info_label",true,false)
    if info_label then
            m_info_label_caption= info_label.caption
    end

   
       
    local tab_theme_button_world = dialog:find_child( "tab_theme_button_world", true, false )
    if tab_theme_button_world then
        
        tab_theme_button_world.button_type = sqc.framework.city_theme_button_type.tab
        
        tab_theme_button_world.action = 
            function( tick )
				on_tab_theme_button_world_action()
            end
        
    end

    local tab_theme_button_local = dialog:find_child( "tab_theme_button_local", true, false )
    if tab_theme_button_local then
        
        tab_theme_button_local.button_type = sqc.framework.city_theme_button_type.tab
        
        tab_theme_button_local.action = 
            function( tick )
				on_tab_theme_button_local_action()
            end
        
    end
   
   
    local gifts_button = dialog:find_child( "gifts_button", true, false )
    if gifts_button then
        gifts_button.action = 
            function( tick )
				on_gifts_button_action()
            end
    end
    
    local top_light_bottom_arrow_image_button = dialog:find_child( "top_light_bottom_arrow_image_button", true, false )
    if top_light_bottom_arrow_image_button then

        top_light_bottom_arrow_image_button.action = 
            function( tick )
                on_top_light_bottom_action_arrow()
            end
    end

    update_arrow_shift()
    
   on_tab_theme_button_world_action()
  
end

function update_arrow_shift()

    local top_light_bottom_label = dialog:find_child( "top_light_bottom_label", true, false )
    if top_light_bottom_label then

        print( "top_light_bottom_label.width_of_caption: " .. top_light_bottom_label.width_of_caption)
    
    
        local top_light_bottom_arrow_image_button = dialog:find_child( "top_light_bottom_arrow_image_button", true, false )
        if top_light_bottom_arrow_image_button then
            
            local shift_of_arrow = {math.ceil(top_light_bottom_label.rect[1+0]+0.5*(2*top_light_bottom_label.rect[1+0] + top_light_bottom_label.rect[1+2] + top_light_bottom_label.width_of_caption)),  top_light_bottom_arrow_image_button.shift[2+0]};
            
            print( "shift_of_arrow.x: " .. shift_of_arrow[1+0])
            
            top_light_bottom_arrow_image_button.shift=shift_of_arrow
    	

        end
    end
    
end

function update_gifts_count()
    local score_rewards = competition_top_controller:get_score_rewards()    
    
    local i_rewards_count=0;
    
    local i_rating = competition_top_controller.rating
    
    for i_reward=1, #score_rewards do
         local b_less=i_rating < score_rewards[i_reward].points
         local b_taken = score_rewards[i_reward].is_taken
         
         if (not b_less) and (not b_taken) then
            i_rewards_count=i_rewards_count+1
         end
    end
   
    if m_gifts_count_image then
        m_gifts_count_image.visible=i_rewards_count > 0
    end
   
    if m_gifts_count_label then
        m_gifts_count_label.caption=i_rewards_count
    end
    
end

function on_tab_theme_button_world_action()
	
    local tab_bevel_world = dialog:find_child("tab_bevel_world",true,false)
    if tab_bevel_world then
        tab_bevel_world.visible=true
    end
    
    local tab_bevel_local = dialog:find_child("tab_bevel_local",true,false)
    if tab_bevel_local then
        tab_bevel_local.visible=false
    end
    
    competition_top_controller.manager_instance="world"
    fill(true, false)
    
end

function on_tab_theme_button_local_action()
	
    local tab_bevel_world = dialog:find_child("tab_bevel_world",true,false)
    if tab_bevel_world then
        tab_bevel_world.visible=false
	end
    
    local tab_bevel_local = dialog:find_child("tab_bevel_local",true,false)
    if tab_bevel_local then
        tab_bevel_local.visible=true
	end
    
    competition_top_controller.manager_instance="local"
    fill(false, true)
    
end

function on_top_light_position_image_button_action(i_index)
	
    print ("on_top_light_position_image_button_action(), i_index: " .. i_index)
    
    local table = dialog:find_child("table",true,false)
	if table then
        table:center_on_cell(i_index-1, false)
	end
    
end


function on_gifts_button_action()
	
    print ("on_gifts_button_action()")
    
    if competition_top_controller:on_gifts_button_pressed() then
        -- dialog:end_dialog()
    end
    
end

function on_top_light_bottom_action_arrow()
	
    print ("on_top_light_bottom_action_arrow()")
    
    if competition_top_controller:on_show_extra_pressed() then
        dialog:end_dialog()
    end
    
end

function on_info_button_action()

    print ("on_info_button_action()")

    if competition_top_controller:on_info_button_pressed() then
        -- dialog:end_dialog()
    end
end

function on_back_button_action()

    print ("on_back_button_action()")

    if competition_top_controller:on_back_button_pressed() then
        dialog:end_dialog()
    end
end

function fill(b_world, b_local)

    m_user_competition_top = competition_top_controller:get_user_competition_top()
    
    local i_position = competition_top_controller.position;
    local i_index = -1
    
    print ("i_position from controller: " ..  i_position )
    
    print("#m_user_competition_top: " .. #m_user_competition_top)
    
    print ("m_user_id: " .. m_user_id)
    
    local i_maximum_xml_user =-1
    
    for i = 1,  #m_user_competition_top do
        
        if m_user_competition_top[i].player_id == m_user_id then
            i_position=m_user_competition_top[i].player_position
            i_index=i
            
            break
        end
        
    end
    

    if i_index > 0 then
        for j = #m_user_competition_top, i_index+1, -1 do
            
            if m_user_competition_top[j].player_id == m_user_id then
                table.remove(m_user_competition_top, j)
            end
            
        end 
    end
    

    if #m_user_competition_top > 0 then
        if m_user_competition_top[#m_user_competition_top].source_type==1 then
	    table.remove(m_user_competition_top,  #m_user_competition_top)
        end
    end
    
    
    for i = 1,  #m_user_competition_top do
        
        if m_user_competition_top[i].source_type == 0 then
            i_maximum_xml_user=i
        end
        
    end
    
    print ("i_maximum_xml_user: " ..  i_maximum_xml_user)
    
    print ("i_position after local search: " ..  i_position)
    print ("i_index: " .. i_index)
    
    local i_nearest_position_at_nearest_top = competition_top_controller:get_nearest_position_at_nearest_top(i_position)
    print ( "case1: nearest_position_at_nearest_top: " .. i_nearest_position_at_nearest_top)
    
    local i_rating = competition_top_controller.rating
    print ( "rating: " .. i_rating)
    
    
    local i_need_to_collect=0
    
    if i_nearest_position_at_nearest_top>=1 and i_nearest_position_at_nearest_top <= i_maximum_xml_user  then
        
        i_need_to_collect=1+m_user_competition_top[i_nearest_position_at_nearest_top].rating-i_rating
        print ("case1: i_need to collect:" .. i_need_to_collect)

    else
    
        if i_nearest_position_at_nearest_top > 0 then -- check for case i_position !=1
        
            if i_maximum_xml_user > 0 then        
            
                i_nearest_position_at_nearest_top=competition_top_controller:get_place_max(i_maximum_xml_user)
                print ( "case2: nearest_position_at_nearest_top: " .. i_nearest_position_at_nearest_top)

                i_need_to_collect=1+m_user_competition_top[i_maximum_xml_user].rating-i_rating
                print ("case2: i_need to collect:" .. i_need_to_collect)
            end
        
        else
        
            print ("case3: we are the champions - first place!!!")
            
        end
        
    end
    
    
    
    local table = dialog:find_child("table",true,false)
	if table then
    
        
        if b_world then
            m_pt_scroll_pos_local=table.scroll_pos
            print (" m_pt_scroll_pos_local.x: " .. m_pt_scroll_pos_local[1] .. " m_pt_scroll_pos_local.y: " ..  m_pt_scroll_pos_local[2])
        end
        
        if b_local then
            m_pt_scroll_pos_world=table.scroll_pos
            print (" m_pt_scroll_pos_world.x: " .. m_pt_scroll_pos_world[1] .. " m_pt_scroll_pos_world.y: " ..  m_pt_scroll_pos_world[2])
        end

        table:update_content()
        
        if b_world then
            if m_b_need_scroll_to_top_world then

                if competition_top_controller.calculated and i_index>=1 then
                    table:center_on_cell(i_index-1, false)
                else
                    table:scroll_to_top()
                end

                m_pt_scroll_pos_world=table.scroll_pos
                print (" m_pt_scroll_pos_world.x: " .. m_pt_scroll_pos_world[1] .. " m_pt_scroll_pos_world.y: " ..  m_pt_scroll_pos_world[2])

                m_b_need_scroll_to_top_world=false
            else
                table.scroll_pos=m_pt_scroll_pos_world
            end
        end
        
        if b_local then
            if m_b_need_scroll_to_top_local then

                if competition_top_controller.calculated and i_index>=1 then
                    table:center_on_cell(i_index-1, false)
                else
                    table:scroll_to_top()
                end

                m_pt_scroll_pos_local=table.scroll_pos
                print (" m_pt_scroll_pos_local.x: " .. m_pt_scroll_pos_local[1] .. " m_pt_scroll_pos_local.y: " ..  m_pt_scroll_pos_local[2])
                m_b_need_scroll_to_top_local=false
            else
                table.scroll_pos=m_pt_scroll_pos_local
            end
        end
        
        
        
        
        
	end

    
    
    local your_position_label = dialog:find_child("your_position_label",true,false)
    if your_position_label then
        your_position_label.visible  = i_position > 0
    end
    
    
    local top_light_position_image_button = dialog:find_child("top_light_position_image_button",true,false)
    if top_light_position_image_button then
    
        if i_position > 0 then
            top_light_position_image_button.caption=i_position
        else
            top_light_position_image_button.caption=m_top_light_position_image_button_caption;
        end 
        
        top_light_position_image_button.visible  = i_position > 0

        top_light_position_image_button.action = 
            function( tick )
				on_top_light_position_image_button_action(i_index)
            end        
    end
    
    
    
    
    
    
    -- #156847 Expected Result: The button shows what prizes you can win and how many houses of points, it should not depend on the loading lists stamp
    -- local gifts_button = dialog:find_child("gifts_button",true,false)
    -- if gifts_button then
    --    gifts_button.active = i_position > 0
    -- end

    local info_label = dialog:find_child("info_label",true,false)
    if info_label then
        if i_nearest_position_at_nearest_top > 0 then
            info_label.visible = true
            if i_need_to_collect > 0 then
                info_label.caption = string.format(m_info_label_caption, i_need_to_collect, i_nearest_position_at_nearest_top)
            else
                info_label.caption = framework:strings():load( "*CityCompetitionRewardsCellDescription_error", "Failed to load the correct list of players")
            end
        else
            info_label.visible = i_position > 0
            info_label.caption = framework:strings():load( "*CityCompetitionRewardsPanelBestPosition", "Congratulations, you are on first place!")
        end
    end
    
    
end


table_delegate  = {

create_cell = function (self, idx, rect )
    local w = self.table:create_child(rect)
    
    if m_user_competition_top[idx+1].source_type == 1 then -- e_separator
    
        framework:json_ui_manager():build_from_resource("city_competition_top_separator", w)
        w.rect = rect

        local separator_label = w:find_child('separator_label', true, false)
        if separator_label then
        
            local i_from=m_user_competition_top[idx+1].player_position
            
            local i_to=i_from
            
            if idx+2 <= #m_user_competition_top then
                i_to=-1 + m_user_competition_top[idx+2].player_position
            end
        
            separator_label.caption= string.format(separator_label.caption, i_from ,  i_to)
        end
    
    else

        framework:json_ui_manager():build_from_resource("city_competition_top_panel", w)
        w.rect = rect
        
        local slct_image = w:find_child('slct_image', true, false)
        if slct_image then
            slct_image.visible = m_user_competition_top[idx+1].player_id == m_user_id
        end
        
        local name_label = w:find_child('name_label', true, false)
        if name_label then

            local s_player_name = framework:strings():load( "*CityUnknownProfile", "Player")

            local s_city_name = m_user_competition_top[idx+1].city_name
            if m_user_competition_top[idx+1].player_id == m_user_id then
		s_city_name = framework:game():get_city_name()
            end

            if framework:settings_controller().priority_friends_name then
        	if m_user_competition_top[idx+1].first_name ~= "" or m_user_competition_top[idx+1].last_name ~="" then
            	    s_player_name=m_user_competition_top[idx+1].first_name .. " " .. m_user_competition_top[idx+1].last_name
                end
            else
        	if s_city_name~="" then
        	    s_player_name=s_city_name
            	end
            end

            name_label.caption = s_player_name
        end
        
        local position_label = w:find_child('position_label', true, false)
        if position_label then
    	    local i_player_position=m_user_competition_top[idx+1].player_position
    	    if i_player_position > 0 then
        	position_label.caption = m_user_competition_top[idx+1].player_position
    	    else
    		position_label.caption = "???"
    	    end
        end
        
        local rating_label = w:find_child('rating_label', true, false)
        if rating_label then
            rating_label.caption = m_user_competition_top[idx+1].rating
        end
        
        local arrow_up_image = w:find_child('arrow_up_image', true, false)
        if arrow_up_image then
            arrow_up_image.visible = m_user_competition_top[idx+1].player_rating_change > 0
        end
        
        local arrow_down_image = w:find_child('arrow_down_image', true, false)
        if arrow_down_image then
            arrow_down_image.visible = m_user_competition_top[idx+1].player_rating_change < 0
        end
        
        local s_country_name = m_user_competition_top[idx+1].country_name

        if s_country_name~="" then
        
            local s_country_code = competition_top_controller:get_country_code(s_country_name)

            if s_country_code~="" then
                local country_proxy_texture = w:find_child('country_proxy_texture', true, false)
                if country_proxy_texture then
                
                    country_proxy_texture.texture_name = s_country_code

                    local country_proxy_texture_frame = w:find_child('country_proxy_texture_frame', true, false)

                    if country_proxy_texture_frame then
                        country_proxy_texture_frame.visible = true
                    end
                 end
            else
                print("Not found country_code for country_name: '" .. s_country_name .. "'")
            end
           
        end
        
        local visit_button = w:find_child("visit_button",true,false)
        if visit_button then
            visit_button.visible = not (m_user_competition_top[idx+1].player_id == m_user_id)
            visit_button.action = function() table_delegate:on_visit_button_pressed(idx) end
        end
    
    end

    
    return w
end,

get_cell_count = function ( )
    return #m_user_competition_top
end

}

function table_delegate:on_visit_button_pressed(idx)
    print(idx)
    
    local player_id = m_user_competition_top[idx+1].player_id
    
    print(player_id)
    
    local room_id = framework:game():get_room_id()
    
    print(room_id)
    
    if framework:scene_view():visit_to_friend_and_activate_object(player_id,  0 , room_id, -1) then
        dialog:end_dialog()
    end
    
end

function on_timer(tick)
    local i_ticked_periods_delta = math.floor(tick/1000) - m_i_last_ticked_periods_count
    if i_ticked_periods_delta > 0 then

        update_time_related_widgets()
        
        m_i_last_ticked_periods_count=m_i_last_ticked_periods_count+i_ticked_periods_delta
    end
end

function update_time_related_widgets()
    if competition_top_controller.calculated then
        if m_timer_holder_widget then
            m_timer_holder_widget.visible=false
        end
    else
        local i_time_remaining_sec=competition_top_controller:get_time_remaining_sec()

        if m_timer_holder_widget then
            m_timer_holder_widget.visible=i_time_remaining_sec > 0
        end

        if m_timer_date_time_label then
            m_timer_date_time_label.time= i_time_remaining_sec > 0 and i_time_remaining_sec or 0
        end
    end
end

function on_post_init_dialog()

    local tabs_holder_widget = dialog:find_child( "tabs_holder_widget", true, false )

    local info_button = dialog:find_child( "info_button", true, false )
    if info_button then

	if tabs_holder_widget then
	    tabs_holder_widget.rect= { info_button.rect[1]+info_button.rect[3], tabs_holder_widget.rect[2], tabs_holder_widget.rect[3], tabs_holder_widget.rect[4] }
	end

        info_button.action =
            function( tick )
		on_info_button_action()
            end
    end

    local back_button = dialog:find_child( "back_button", true, false )
    if back_button then

	if tabs_holder_widget then
	    tabs_holder_widget.rect= { back_button.rect[1]+back_button.rect[3], tabs_holder_widget.rect[2], tabs_holder_widget.rect[3], tabs_holder_widget.rect[4] }
	end

        back_button.action =
            function( tick )
		on_back_button_action()
            end
    end
end

function end_dialog( )
end

function notify_callback(s_provider_id, s_event_id, value)

    print ("notify_callback for city_competition_top_dlg.lua: " .. s_provider_id .. s_event_id .. value)
    update_gifts_count()

    local tab_bevel_world = dialog:find_child("tab_bevel_world",true,false)
    if tab_bevel_world then
        if tab_bevel_world.visible==true then
	    if  s_provider_id=="competition_history_provider_id" and  s_event_id=="competition_history_global_event_id" then
		m_b_need_scroll_to_top_world=true
		fill(true, false)
	    end
        end
    end
    
    local tab_bevel_local = dialog:find_child("tab_bevel_local",true,false)
    if tab_bevel_local then
        if tab_bevel_local.visible==true then
	    if s_provider_id=="competition_history_provider_id" and  s_event_id=="competition_history_local_event_id" then
		m_b_need_scroll_to_top_local=true
		fill(false, true)
	    end
        end
    end
end
