scroll_button = {
    is_pressed = false,
    action = nil,
    last_tick = 0,
	delta = 100
}

function scroll_button:reset()
    self.is_pressed = false
    self.action = nil
    self.last_tick = 0
	self.delta = 100
end

function scroll_button:init() 
    
end


function on_init_dialog()

	--init for Qt editor
	if not gift_names then
		gift_names = {'coins', 'steel_girder', 'steel_girder', 'steel_girder', 'steel_girder', 'steel_girder', 'steel_girder', 'steel_girder', 'steel_girder', 'steel_girder', 'steel_girder', 'steel_girder', 'steel_girder', 'steel_girder', 'steel_girder', 'steel_girder', 'steel_girder', 'steel_girder' }
	end

	if not gift_counts then
		gift_counts = {100000, 99, 98, 97, 96, 95, 94, 93, 92, 91, 90, 89, 88, 87, 86, 85, 84, 83, 82, 81, 80, 79, 78, 77, 76, 75, 74, 73, 72, 71, 70}
	end
	
	dialog.theme_flags = 2

	dialog:load_content('city_day_dialog')

	local spinboard = dialog:find_child("spinboard",true,false)
	if spinboard then
        spinboard:update_content()
	end

	local button = dialog:find_child( "btn_r_touch_w", true, false )
    if button then
        button.press_action = function ()
            scroll_button.is_pressed = true
            scroll_button:init()
			
            scroll_button.action = function( tick )
				on_arrow_btn_r_action()
            end
        end

        button.release_action = function ()
            scroll_button:reset()
        end
    end

	local button_2 = dialog:find_child( "btn_l_touch_w", true, false )
    if button_2 then
        button_2.press_action = function ()
            scroll_button.is_pressed = true
            scroll_button:init()
			
            scroll_button.action = function( tick )
				on_arrow_btn_l_action()
            end
        end

        button_2.release_action = function ()
            scroll_button:reset()
        end
    end

end

function on_timer (tick )

    if scroll_button.is_pressed and scroll_button.action ~= nil then
		
        scroll_button.action( tick )
		local spinboard = dialog:find_child("spinboard",true,false)
    	if spinboard then
		if tick - scroll_button.last_tick > scroll_button.delta then
			scroll_button.last_tick = tick
			spinboard:update_content()
		end
		end
	
    end

end

function on_city_day_dialog_ok_button_action()
	framework:dialogs():show_storage_dialog()
	dialog:end_dialog()
end

function on_arrow_btn_l_action()
	local spinboard = dialog:find_child("spinboard",true,false)
    if spinboard then
        spinboard:set_active_page(spinboard:get_active_page()-1, true)
	end
end

function on_arrow_btn_r_action()
	local spinboard = dialog:find_child("spinboard",true,false)
    if spinboard then
        spinboard:set_active_page(spinboard:get_active_page()+1, true)
	end
end

spinboard_delegate  = {
    create_cell = function (  self, idx, rect )
        
        local w = self.spinboard:create_child(rect)

        framework:json_ui_manager():build_from_resource("city_day_cell",w)
        w.rect = rect
        
		local label_count = w:find_child('count_label',true,false)

		if label_count then
			label_count.caption = 'x' .. framework:formats():format_digit_compact(gift_counts[idx+1])
		end

		local img = w:find_child('cell_image',true,false)
        if img then


			local tex_name

			local object_info = framework:object_factory():get_object_info_by_type_name(gift_names[idx+1])
			if not object_info then
				object_info = framework:object_factory():get_surrogate_object_info_by_type_name(gift_names[idx+1])
			end
			
	
			if not object_info then
			print("not found get_object_info_by_type_name for type",'\''..gift_names[idx+1]..'\'')
			else
			tex_name = object_info.shop_image_path
			if tex_name == '' or tex_name == '_v1' then
				print('shop_image_path for ' .. gift_names[idx+1] .. ' invalid ',tex_name)
				tex_name = object_info.image_path
			end
			if tex_name == '' or tex_name == '_v1' then
				print('image_path for ' .. gift_names[idx+1] .. ' invalid ',tex_name)
				tex_name = object_info.icon_name
			end
			end


            	img.texture_name = tex_name
        	

            
        end

        return w
    end,

    get_cell_count = function ( )
        local res = #gift_names
        return res
    end
}
