scroll_button = {
    is_pressed = false,
    action = nil,
    last_tick = 0,
	delta = 500
}

function scroll_button:reset()
    self.is_pressed = false
    self.action = nil
    self.last_tick = 0
	self.delta = 500
end

function scroll_button:init() 
    
end


function on_init_dialog()
	
	dialog.theme_flags = 2

	dialog:load_content('city_gratz_dialog')

    local dollar_label = dialog:find_child("dollar_label",true,false)
	if dollar_label then
        dollar_label.caption=string.format(dollar_label.caption , m_price_bucks)
	end
    
	local spinboard = dialog:find_child("spinboard",true,false)
	if spinboard then
        
        local i_count = math.min(#m_gift_names,  #m_gift_labels)
        
        if i_count <= 5 then
            spinboard.item_spacing=(5-i_count)*spinboard.cell_width/(i_count+1)
            
            local arrow_btn_l = dialog:find_child("arrow_btn_l",true,false)
            if arrow_btn_l then
                arrow_btn_l.visible=false
            end
            
            local arrow_btn_r = dialog:find_child("arrow_btn_r",true,false)
            if arrow_btn_r then
                arrow_btn_r.visible=false
            end
    
        end
        
        spinboard:update_content()
	end

	local button = dialog:find_child( "btn_r_touch_w", true, false )
    if button then
        button.press_action = function ()
            scroll_button.is_pressed = true
            scroll_button:init()
			
            scroll_button.action = function( tick )
				on_arrow_btn_r_action()
            end
        end

        button.release_action = function ()
            scroll_button:reset()
        end
    end

	local button_2 = dialog:find_child( "btn_l_touch_w", true, false )
    if button_2 then
        button_2.press_action = function ()
            scroll_button.is_pressed = true
            scroll_button:init()
			
            scroll_button.action = function( tick )
				on_arrow_btn_l_action()
            end
        end

        button_2.release_action = function ()
            scroll_button:reset()
        end
    end

end

function on_timer (tick )

    if scroll_button.is_pressed and scroll_button.action ~= nil then
		
        scroll_button.action( tick )
		local spinboard = dialog:find_child("spinboard",true,false)
    	if spinboard then
		if tick - scroll_button.last_tick > scroll_button.delta then
			scroll_button.last_tick = tick
			spinboard:update_content()
		end
		end
	
    end

end

function on_city_day_dialog_ok_button_action()
	framework:dialogs():show_storage_dialog()
	dialog:end_dialog()
end

function on_arrow_btn_l_action()
	local spinboard = dialog:find_child("spinboard",true,false)
    if spinboard then
        spinboard:set_active_page(spinboard:get_active_page()-1, true)
	end
end

function on_arrow_btn_r_action()
	local spinboard = dialog:find_child("spinboard",true,false)
    if spinboard then
        spinboard:set_active_page(spinboard:get_active_page()+1, true)
	end
end

spinboard_delegate  = {
    create_cell = function (  self, idx, rect )
        
        local w = self.spinboard:create_child(rect)

        framework:json_ui_manager():build_from_resource("city_gratz_cell",w)
        w.rect = rect
        
        local s_item_label = m_gift_labels[idx+1]
        
		local item_label = w:find_child('item_label',true,false)
		if item_label then
			item_label.caption = s_item_label 
		end

        if s_item_label == "" then
            local building_image = w:find_child('building_image',true,false)
            if building_image then
                	building_image.texture_name = m_gift_names[idx+1]
            end
        else
    		local item_image = w:find_child('item_image',true,false)
            if item_image then
                	item_image.texture_name = m_gift_names[idx+1]
            end
        end

        return w
    end,

    get_cell_count = function ( )
        return math.min(#m_gift_names, #m_gift_labels)
    end
}
