local m_tick = 0
local quest_end_time = 0
local end_time = false

local goal_klass_action
local all_map_pair_goal_klass_action = {}

function on_timer( tick )
	if tick > m_tick then
		
		if end_time == false then
			return
		end
	
		m_tick = tick + 1000
		quest_end_time = quest_end_time - 1
		
		if quest_end_time <= 0 then
			dialog:end_dialog()
		end

		update_timer()
	end
end

function update_timer()
	if dialog then
		
		local time_label = dialog:find_child('time_label', true, false)
		if time_label then
			time_label.time = quest_end_time
		end
	end
end

function update_dlg()
	m_goals_spinboard = dialog:find_child("goals_spinboard",true,false)
    if m_goals_spinboard then
        m_goals_spinboard:update_content()    
    end
    
--    print("quest_controller.action_time = ", quest_controller.action_time)
    
    if quest_controller.action_time ~= 0 then
    	local timer_bg = dialog:find_child("timer_bg", true, false)
    	if timer_bg then
    		timer_bg.visible = true
    		end_time = true
    		quest_end_time = quest_controller.action_time
    		
    		local time_label = dialog:find_child("time_label", true, false)
    		if time_label then
    			time_label.caption = quest_end_time
    		end
    	end
    end
end

function on_init_dialog( )
    
    dialog.theme_flags = 102
    dialog.bevel_type = 1

    if quest_controller then
    	m_controller = quest_controller
    	dialog.caption = quest_controller.quest.name
    end

    dialog:load_content('city_quest_search_dlg')

	update_dlg()
	
	quest_controller:set_update_dlg_callback(update_dlg)

    set_person_image()
    set_top_plate_bg_image()
    set_quest_description()
end

function set_person_image()
	local quest_person_img = dialog:find_child( "quest_person", true, false )
	if quest_person_img then
--		print("quest_person_img = ", quest_controller.person)
		quest_person_img.texture_name = quest_controller.person
	end	
end

function set_top_plate_bg_image()
    local top_plate_bg = dialog:find_child( "top_plate_bg", true, false )
	if top_plate_bg then
--		print("top_plate_bg = ", quest_controller.top_plate_bg)
		top_plate_bg.texture_name = quest_controller.top_plate_bg
	end
end

function set_quest_description()
    local quest_description = dialog:find_child( "quest_description", true, false )
    if quest_description then
--    	print("quest_description = ", quest_controller.quest.description)
        quest_description.caption = quest_controller.quest.description
    end
end


function execute_goal(idx)
--	print("execute goal idx = ", idx)
	quest_controller:execute_goal(idx)
end

function force_goal(idx)
--	print("firce_goal idx=", idx)
	quest_controller:on_do_it(idx)
end

function search_goal()

--	for i = 1,#all_map_pair_goal_klass_action do
--		print(all_map_pair_goal_klass_action[i][1])
--	end

	local succcess_show_object = false
	local i=1
	
	while (i <= #all_map_pair_goal_klass_action and succcess_show_object == false) do
		if all_map_pair_goal_klass_action[i][1] == "clean:leisure_base" then
			succcess_show_object = framework:dialogs():goto_object_status_tax()
		end

		if all_map_pair_goal_klass_action[i][1] == "pick:house_base" then
			succcess_show_object = framework:dialogs():goto_object_status_population()
		end
		
		i = i + 1
	end	
	
	dialog:end_dialog()

end

goals_spinboard_delegate  = {}
function goals_spinboard_delegate:create_cell ( idx, rect )
    local w = self.table:create_child(rect)
    framework:json_ui_manager():build_from_resource("city_quest_search_cell",w)
    w.rect = rect

    local goal = quest_controller.quest:get_goal(idx)
    if goal then
	    local label = w:find_child("goal_title",true,false)
	    if label then
	        label.caption = goal.description
	    end

	    if goal.completed then
	    	set_complete_image(w)
	    else
	    	set_progress(w, goal)
			
			local btn_action_type = quest_controller:get_goal_button_action_type(idx)
			local label = ""
			
			if btn_action_type ~= sqc.sqc_show_goal_action.show_goal_not_show and btn_action_type ~= sqc.sqc_show_goal_action.show_goal_invite_friend then
			
				if btn_action_type == sqc.sqc_show_goal_action.show_goal_show_go_to_registration then
					label = framework:strings():load("*CityGoToRegistration", "Go to registration")
				elseif btn_action_type == sqc.sqc_show_goal_action.show_goal_show_enter_name then
					label = framework:strings():load("*CityEnterName", "Enter Name")
				elseif btn_action_type == sqc.sqc_show_goal_action.show_goal_room_on_map then
					label = framework:strings():load("*CityShowOnMap", "Show on map")
				elseif btn_action_type == sqc.sqc_show_goal_action.show_goal_show_open_url then
					label = framework:strings():load("*CityOpenUrl", "Open URL")
				elseif btn_action_type == sqc.sqc_show_goal_action.show_goal_open_inbox then
					label = framework:strings():load("*OpenInbox", "Show")
				elseif btn_action_type == sqc.sqc_show_goal_action.show_goal_invite_neighbors then
					label = framework:strings():load("*SQInviteFriends", "Invite friends")
				else
					if 	btn_action_type == sqc.sqc_show_goal_action.show_goal_show_on_field or 
						btn_action_type == sqc.sqc_show_goal_action.show_goal_show_material_factory_on_field or 
						btn_action_type == sqc.sqc_show_goal_action.show_goal_show_on_field_building_state_at_first then
						
						label = framework:strings():load("*CityFindOnField", "Show on field")
					elseif sqc.sqc_show_goal_action.btn_action_type == show_goal_show_in_shop or sqc.sqc_show_goal_action.btn_action_type == show_goal_show_add_to_wish_dlg then
						label = framework:strings():load("*CityFindInShop", "Find in shop")
					elseif btn_action_type == sqc.sqc_show_goal_action.show_goal_show_in_barn then
						label = framework:strings():load("*CityShowInBarn", "Show in barn")
					elseif btn_action_type == sqc.sqc_show_goal_action.show_goal_show_buy_location then
						label = framework:strings():load("*CityOpen", "Open")
					end
				end

                local go_button = w:find_child("go_button", true, false)
				if go_button then
					go_button.visible = true
					go_button.action = function()
											execute_goal(idx)
										end
					local goto_label = go_button:find_child("goto_label", true, false)
					if goto_label then
						goto_label.caption = label
					end
				end

			end
			
			local info_provider = framework:object_factory()	
			goal_klass_action = info_provider:get_user_action_by_goal_klass_action(goal.object_action)
			
--			print("#goal_klass_action = ", #goal_klass_action)
			
			local action_idx = #all_map_pair_goal_klass_action + 1
			for i = 1, #goal_klass_action do
			
				pair = {goal_klass_action[i], goal.object_action}
				all_map_pair_goal_klass_action[action_idx] = pair
				action_idx = action_idx + 1
			end
			
--			print("#all_map_pair_goal_klass_action = ", #all_map_pair_goal_klass_action)
			
			if #goal_klass_action ~= 0 then
				local search_button = w:find_child("go_button", true, false)
				if search_button then
					search_button.visible = true
					search_button.action = 	function()
												search_goal(idx)
											end
					local search_label = search_button:find_child("goto_label", true, false)
					if search_label then
						search_label.caption = framework:strings():load("*QuestGoalSearch", "Find")
					end
				end
			end

			if goal.unlock_cost ~= 0 and btn_action_type ~= sqc.sqc_show_goal_action.show_goal_show_go_to_registration and btn_action_type ~= sqc.sqc_show_goal_action.show_goal_show_enter_name then
			
				label = framework:strings():load("*CitySubquestActionBuy", "Complete")
				
				local force_button = w:find_child("force_button", true, false)
				if force_button then
					force_button.visible = true
					force_button.action = 	function()
												force_goal(idx)
											end
					local force_label = force_button:find_child("force_label", true, false)
					if force_label then
						force_label.caption = label.." $ "..goal.unlock_cost
					end
				end
				
			end
			
	    end
	end

    return w
end

function goals_spinboard_delegate:get_cell_count ( )
	if quest_controller then
	    return quest_controller.quest.goals_count
	end
	return 0
end


function set_complete_image( w )
	local image = w:find_child("goal_complete_image", true, false)
	if image then
		image.visible = true
	end
end

function set_progress(w, goal)
	local label_progress = w:find_child("goal_progress", true, false)
	if label_progress then
		label_progress.caption = string.format("%d / %d", goal.progress, goal.count )
	end
end

function adjust_title_dialg()

	local dialog_title_caption = dialog:find_child('dialog_title_caption', true, false)
	if dialog_title_caption then
--		print("dialog_title_caption found")

		local caption_rect = dialog_title_caption.rect 
--		print("caption_rect", caption_rect[1], caption_rect[2], caption_rect[3], caption_rect[4])
		
		if g_device.is_tablet then
			if caption_rect[3] > 415 then
				caption_rect[3] = 415
				dialog_title_caption.rect = caption_rect
				dialog_title_caption.text_adjust_font_size = true
			end
		elseif g_device.is_phone then
			if caption_rect[3] > 260 then
				caption_rect[3] = 260
				dialog_title_caption.rect = caption_rect
				dialog_title_caption.text_adjust_font_size = true
			end
		end
	end
	
	
	local dialog_title_bevel = dialog:find_child('dialog_title_bevel', true, false)
	if dialog_title_bevel then
--		print("dialog_title_bevel found")
		
		local title_bevel_rect = dialog_title_bevel.rect 
--		print("title_bevel_rect", title_bevel_rect[1], title_bevel_rect[2], title_bevel_rect[3], title_bevel_rect[4])
		
		if g_device.is_tablet then
			if title_bevel_rect[1] < 65 then
				title_bevel_rect[1] = 65
				dialog_title_bevel.rect = title_bevel_rect
			end
		
			if title_bevel_rect[3] > 415 then
				title_bevel_rect[3] = 415
				dialog_title_bevel.rect = title_bevel_rect
			end
		elseif g_device.is_phone then
			if title_bevel_rect[3] > 260 then
				title_bevel_rect[3] = 260
				dialog_title_bevel.rect = title_bevel_rect
			end
		end
	end
	
end


function on_info_button_action()
--	print("info button")
	
	if #all_map_pair_goal_klass_action == 0 then
		return
	end

	local info_dlg = cclasses.sqc_scriptable_dialog.create(framework:windows().desktop,"city_quest_search_info_dlg.lua")
	if ( info_dlg ) then
		info_dlg.scripting_object.all_map_pair_goal_klass_action = all_map_pair_goal_klass_action		
		info_dlg.scripting_object.ok_callback = function()
													search_goal()
												end
		info_dlg:do_modal()
	end
end


function on_post_init_dialog()

	local info_button = dialog:find_child('info_button', true, false)
	if info_button then
		info_button.action = on_info_button_action
	end	

	adjust_title_dialg()
end

