function hide_widget(widget_name, parent_widget)
	local widget = parent_widget:find_child(widget_name, true, false)
	if widget then
		widget.visible = false
	end
end

function show_widget(widget_name, parent_widget)
	local widget = parent_widget:find_child(widget_name, true, false)
	if widget then
		widget.visible = true
	end
end

function get_rect_widget(widget)
	local rect = {0, 0, 0, 0}
	local widget_dlg = dialog:find_child(widget, true, false)
	if widget_dlg then
		rect = widget_dlg.rect
	end
	return rect
end

function get_texture_name(texture)
	local texture_by_device = texture
	if g_device.is_tablet then
		texture_by_device = texture_by_device .. "_ipad"
		print(texture_by_device)
	end
	return texture_by_device
end

function on_init_dialog()
	
	dialog.theme_flags = 0
	dialog:load_content('city_quest_search_info_dlg')
	dialog.center_dialog = true

	if #all_map_pair_goal_klass_action == 0 then
		dialog:end_dialog()
	end	


--	for i = 1, #all_map_pair_goal_klass_action do
--		print(all_map_pair_goal_klass_action[i][1], all_map_pair_goal_klass_action[i][2])
--	end

	local dialog_label = dialog:find_child("dialog_caption", true, false)
	if dialog_label then
		dialog_label.caption = framework:get_client_string(all_map_pair_goal_klass_action[1][2] .. "_info_caption_dlg")
		dialog_label.text_adjust_font_size = true
	end

	local info_action_label = dialog:find_child("info_action", true, false)
	if dialog_label then
		info_action_label.caption = framework:get_client_string(all_map_pair_goal_klass_action[1][2] .. "_info_action_dlg")
		info_action_label.text_adjust_font_size = true
	end

	if #all_map_pair_goal_klass_action == 1 then
	
		local action_image = ""
		if all_map_pair_goal_klass_action[1][1] == "clean:leisure_base" then
			action_image = all_map_pair_goal_klass_action[1][2] .. "_search_action_1"
		elseif all_map_pair_goal_klass_action[1][1] == "pick:house_base" then
			action_image = all_map_pair_goal_klass_action[1][2] .. "_search_action_1"
		end
		
		local center_house = dialog:find_child("center_house", true, false)
		if center_house then
--			print("center_house: image = ", action_image)
			center_house.texture_name = get_texture_name(action_image);	--инфо центральное изображение			
			center_house:set_ready_progress_as_indicator()
		end

		show_widget("center_house_border", dialog)

		
	elseif #all_map_pair_goal_klass_action == 2 then

		local action_image = {}
		
		for i = 1, #all_map_pair_goal_klass_action do
			if all_map_pair_goal_klass_action[i][1] == "clean:leisure_base" then
				action_image[i] = all_map_pair_goal_klass_action[1][2] .. "_search_action_1"
			elseif all_map_pair_goal_klass_action[i][1] == "pick:house_base" then
				action_image[i] = all_map_pair_goal_klass_action[1][2] .. "_search_action_2"
			end
		end
		
		if action_image[1] then
--			print("left_house: image = ", action_image[1])
			local left_house = dialog:find_child("left_house", true, false)
			if left_house then
				left_house.texture_name = get_texture_name(action_image[1])	--инфо левое изображение
				left_house:set_ready_progress_as_indicator()	
			end
			show_widget("left_house_border", dialog)
		end
		
		if action_image[2] then
--			print("right_house: image = ", action_image[2])
			local right_house = dialog:find_child("right_house", true, false)
			if right_house then 
				right_house.texture_name = get_texture_name(action_image[2])	--инфо правое изображение
				right_house:set_ready_progress_as_indicator()		
			end		
			show_widget("right_house_border", dialog)	
		end

	end

	local attention_label = dialog:find_child("attention", true, false)
	if attention_label then
		attention_label.caption = framework:get_client_string(all_map_pair_goal_klass_action[1][2] .. "_info_attention_dlg")
		attention_label.text_adjust_font_size = true
	end	

	local attention_description_label = dialog:find_child("attention_description", true, false)
	if attention_description_label then
		attention_description_label.caption = framework:get_client_string(all_map_pair_goal_klass_action[1][2] .. "_info_attention_description_dlg")
		attention_description_label.text_adjust_font_size = true
	end	
	
	local find_button = dialog:find_child("find_button", true, false)
	if find_button then
		local label = find_button:find_child("label", true, false)
		if label then
			label.caption = framework:get_client_string(all_map_pair_goal_klass_action[1][2] .. "_info_button_name")-- label на кнопке Поиск
		end
	end
	
end


function on_close_button_action()
	dialog:end_dialog()
end

function on_find_button_action()
	if ok_callback then
		ok_callback()
	end
	dialog:end_dialog()
end