local action_end_date = 0
local num_tick = 0

local packs_cooldown = {}
local timers = {}

local active_block = 0

local global_action_info

local action_timer_label

local animation_in_process = false;

local update_packs = {};

function on_init_dialog()
	dialog.theme_flags = 2
	dialog:load_content('coins_to_gold_main_dialog')

	action_timer_label = dialog:find_child('dialog_timer_label', true, false)

	if dialog.caption then
		local caption_str = framework:get_client_string("coins_to_gold2_expeditions")
		if caption_str ~= "" then
			dialog.caption = caption_str
		end
	end

	local description1_label = dialog:find_child('dialog_description1_label', true, false)
	if description1_label then
		local description_str = framework:get_client_string("coins_to_gold2_expeditions_info")
		if description_str ~= "" then
			description1_label.caption = description_str
		end
	end

	local args = {}
	args.user_level = framework:game().level
	args.subtype1 = "c2c"
	framework:statistics():send_custom_event(framework:networks():get_user_id(), "window", args)

	global_action_info = framework:game():get_coins_to_gold()

	local action_info = framework:game():get_coins_to_gold()
	action_end_date = action_info:get_calculate_duration()

	for i = 1, #action_info:get_manager_block_item_vector() do
		local manager_block = action_info:get_manager_block_item_vector()[i]
		packs_cooldown[i] = manager_block:get_calculate_cooldown()
		update_packs[i] = true
	end

	update_active_block_number()
	update_dlg()

--	local left_set = 0;
--	local left_item = 0;
--
--	print("translation_key_prefix = ", action_info.cfg_action_config.translation_key_prefix)
--	 for i = 1, #action_info:get_manager_block_item_vector() do
--		print("block = ", action_info:get_manager_block_item_vector()[i].block)
--		print("cooldown = ", action_info:get_manager_block_item_vector()[i]:get_calculate_cooldown())
--		print("state = ", action_info:get_manager_block_item_vector()[i].state)
--		print("unblock_price = ", action_info:get_manager_block_item_vector()[i].string_unblock_price)
--		print("quantity_all_set = ", action_info:get_manager_block_item_vector()[i].quantity_set)
--		print("quantity_left_set = ",  #action_info:get_manager_block_item_vector()[i]:get_set())
--		print("product_id = ", action_info:get_manager_block_item_vector()[i].product_id)
--	
--		local calculate_price = action_info:get_price(action_info:get_manager_block_item_vector()[i].product_id)
--		print("calculate_price = ", calculate_price)
--	
--		left_set = left_set +  #action_info:get_manager_block_item_vector()[i]:get_set()
--		left_item = left_item + #action_info:get_manager_block_item_vector()[i]:get_item()
--	
--		for j=1, #action_info:get_manager_block_item_vector()[i]:get_block_item_vector() do
--			print("name = ",action_info:get_manager_block_item_vector()[i]:get_block_item_vector()[j].name)
--			print("coins = ",action_info:get_manager_block_item_vector()[i]:get_block_item_vector()[j].coins)
--			print("gold = ",action_info:get_manager_block_item_vector()[i]:get_block_item_vector()[j].gold)
--			print("available = ",action_info:get_manager_block_item_vector()[i]:get_block_item_vector()[j].available)
--			print('---------------------------------------------')
--		end
--	
--		for j=1, #action_info:get_manager_block_item_vector()[i]:get_set() do
--			print("set = ",action_info:get_manager_block_item_vector()[i]:get_set()[j])
--		end
--	
--		for j=1, #action_info:get_manager_block_item_vector()[i]:get_item() do
--			print("item = ",action_info:get_manager_block_item_vector()[i]:get_item()[j])
--		end
--		
--		for j=1, #action_info:get_manager_block_item_vector()[i]:get_trophy() do
--			print("trophy = ",action_info:get_manager_block_item_vector()[i]:get_trophy()[j])
--		end
--	
--		for j=1, #action_info:get_manager_block_item_vector()[i]:get_translte() do
--			print("translte = ",action_info:get_manager_block_item_vector()[i]:get_translte()[j])
--		end
--	
--		for j=1, #action_info:get_manager_block_item_vector()[i]:get_set() do
--			print("controller", action_info:get_cfg_action_config():get_translate_map()[action_info:get_manager_block_item_vector()[i]:get_set()[j]])
--		end
--	
--		print('=================================================')
--	 end
--	 
--	 print("left_set = ", left_set)
--	 print("left_item = ", left_item)
end

function on_post_init_dialog()
	adjust_title_dialog()
end

function adjust_title_dialog()
	local dialog_title_caption = dialog:find_child('dialog_title_caption', true, false)
	if dialog_title_caption then
		print("dialog_title_caption found")

		local caption_rect = dialog_title_caption.rect 
		print("caption_rect", caption_rect[1], caption_rect[2], caption_rect[3], caption_rect[4])

		if g_device.is_tablet then
			if caption_rect[3] > 415 then
				caption_rect[3] = 415
				dialog_title_caption.rect = caption_rect
				dialog_title_caption.text_adjust_font_size = true
			end
		elseif g_device.is_phone then
			if caption_rect[3] > 245 then
				caption_rect[3] = 245
				dialog_title_caption.rect = caption_rect
				dialog_title_caption.text_adjust_font_size = true
			end
		end
	end

	local dialog_title_bevel = dialog:find_child('dialog_title_bevel', true, false)
	if dialog_title_bevel then
		print("dialog_title_bevel found")

		local title_bevel_rect = dialog_title_bevel.rect 
		print("title_bevel_rect", title_bevel_rect[1], title_bevel_rect[2], title_bevel_rect[3], title_bevel_rect[4])

		if g_device.is_tablet then
			if title_bevel_rect[3] > 430 then
				title_bevel_rect[3] = 430
				dialog_title_bevel.rect = title_bevel_rect
			end
		elseif g_device.is_phone then
			if title_bevel_rect[3] > 260 then
				title_bevel_rect[3] = 260
				dialog_title_bevel.rect = title_bevel_rect
			end
		end
	end
end

function on_timer(tick)
	if tick > num_tick then
		num_tick = tick + 300

		update_action_timer()

		for i = 1, #packs_cooldown do
			if packs_cooldown[i] > 0 then
				if global_action_info then
					packs_cooldown[i] = global_action_info:get_manager_block_item_vector()[i]:get_calculate_cooldown()
				end
				update_packs[i] = true
			end

			update_timer_idx(i)

			if packs_cooldown[i] == 0 and update_packs[i] == true then
				global_action_info:update_block_item_vector()
				
				if animation_in_process == false then
					update_dlg()
				else
					local buttons_container = dialog:find_child("buttons_container", true, false)
					if buttons_container then
						buttons_container:update_content()
					end
				end
	
				update_packs[i] = false
			end
		end
		
	end
end

function update_timer_idx(timer_idx)
	if dialog then
		if packs_cooldown[timer_idx] > 0 then
			local timer = timers[timer_idx]
			if timer then
				timer.time = packs_cooldown[timer_idx]
			end
		end
	end
end

function update_action_timer()
	if action_timer_label then
		if global_action_info:get_calculate_duration() < 0 then
			action_timer_label.caption = " --:--:-- "

			global_action_info:update_block_item_vector()

			local available_block = 0
			for i = 1, #global_action_info:get_manager_block_item_vector() do
				if global_action_info:get_manager_block_item_vector()[i].state == sqc.city.coins_to_gold_block_state.coins_to_gold_block_unlock then
					available_block = available_block + 1
				end
			end

			if action_end_date ~= global_action_info:get_calculate_duration() then
				print("update dlg after duration expired")
				action_end_date = global_action_info:get_calculate_duration()
				
				if animation_in_process == false then
							
					if available_block > 0 then
						update_dlg()
					end
				else
					print("animation_in_process: so do not update_dlg")
				end
			end

			
			if available_block == 0 then
				dialog:end_dialog()
			end
		else
			action_timer_label.time = global_action_info:get_calculate_duration()
		end
	end
end

function check_to_block(block_idx)
	active_block = block_idx
--	update_dlg()

------------------------------------------------------------------------------------------
	local items_container = dialog:find_child("buttons_container", true, false)
	if items_container then
		local cells = items_container:get_cells()
		for i = 1, #cells do
			
			local action_info = framework:game():get_coins_to_gold()
			local manager_block = action_info:get_manager_block_item_vector()[i]
			
			local button = cells[i]:find_child("block_button", true, false)
			
			if button then
				local current_block = nil
				local count_label = nil
				local name_label = nil
	
				local available = is_block_available(manager_block)
				local is_accomplished = manager_block.state == sqc.city.coins_to_gold_block_state.coins_to_gold_block_close
	
				local btn_texture_name = "c2c_btn_expedition_0"
				if i == active_block then
					btn_texture_name = "c2c_btn_expedition_1"
				end
				if not(available) then
					btn_texture_name = "c2c_btn_expedition_2"
				end
	
				print("btn_texture_name = ", btn_texture_name)
	
				if new_texture_name ~= "" then
					local active_button_texture = get_texture_name(btn_texture_name)
					button.image_name = active_button_texture
					button.pressed_image = active_button_texture					
				end
	
				
				if (available) then

					current_block = cells[i]:find_child("selected_active_block_open", true, false)
					if current_block then
						current_block.visible = false
					end
					
					current_block = cells[i]:find_child("selected_active_block_not_open", true, false)
					if current_block then
						current_block.visible = false
					end
										
					current_block = cells[i]:find_child("usual_active_block_open", true, false)
					if current_block then
						current_block.visible = false
					end

					current_block = cells[i]:find_child("usual_active_block_not_open", true, false)
					if current_block then
						current_block.visible = false
					end

				
					local is_unlock = is_block_unblock(manager_block)
					local current_expedition = manager_block.quantity_set - #manager_block:get_set() + 1;
					
					if i == active_block then
						if (is_unlock) or (current_expedition > 1) then
							current_block = cells[i]:find_child("selected_active_block_open", true, false)
							count_label = cells[i]:find_child("selected_active_block_open_count_label", true, false)
							name_label = cells[i]:find_child("selected_active_block_open_name_label", true, false)
						else
							current_block = cells[i]:find_child("selected_active_block_not_open", true, false)
							name_label = cells[i]:find_child("selected_active_block_not_open_name_label", true, false)
						end
					else
						if (is_unlock) or (current_expedition > 1) then
							current_block = cells[i]:find_child("usual_active_block_open", true, false)
							count_label = cells[i]:find_child("usual_active_block_open_count_label", true, false)
							name_label = cells[i]:find_child("usual_active_block_open_name_label", true, false)
						else
							current_block = cells[i]:find_child("usual_active_block_not_open", true, false)
							name_label = cells[i]:find_child("usual_active_block_not_open_name_label", true, false)
						end
					end
				end
	
				if current_block and not(current_block.visible) then
					current_block.visible = true
				end
	
				if count_label then
					local current_expedition = manager_block.quantity_set - #manager_block:get_set() + 1;
					if current_expedition > manager_block.quantity_set then
						current_expedition = manager_block.quantity_set
					end
	
					local x_from_y = framework:get_client_string(action_info.cfg_action_config.translation_key_prefix .. "x_from_y")
					
					local x_from_y_label = current_expedition .. "/" .. manager_block.quantity_set .. " expeditions"
					
					if x_from_y then
						local s, e, a, b, c, d = string.find(x_from_y, "^(.*)({%d+})(.*)({%d+})")
						if a and c then
							x_from_y_label = a .. current_expedition .. c .. manager_block.quantity_set
						end
					end

					count_label.caption = x_from_y_label
				end
	
				if name_label then
					local translte_key = manager_block:get_translte()[1] .. ":name"
					name_label.caption = framework:get_client_string(translte_key)
					if name_label.caption == "" then
						name_label.caption = translte_key
					end
				end
			end
			
		end
	end



	local action_info = framework:game():get_coins_to_gold()
	local manager_block = action_info:get_manager_block_item_vector()[active_block]

	local block_unlock = manager_block.state == sqc.city.coins_to_gold_block_state.coins_to_gold_block_unlock

	local items_container = dialog:find_child("expedition_items_container", true, false)
	if items_container and items_container.visible ~= block_unlock then
		items_container.visible = block_unlock
	end

	local closed_widget = dialog:find_child("expedition_closed_widget", true, false)
	if closed_widget and closed_widget.visible == block_unlock then
		closed_widget.visible = not(block_unlock)
	end

	if block_unlock then
		if items_container then
			items_container:update_content()
		end
	else
		local open_block_button = dialog:find_child("open_block_button", true, false)
		if open_block_button then
			open_block_button.action = function()
				open_block(active_block)
			end

			local open_label = open_block_button:find_child("open_block_label", true, false)
			if open_label then
				local calculate_price = action_info:get_price(manager_block.product_id)
				open_label.caption = string.format(framework:strings():load("*CityCoinsToGoldOpenBlockFor", "Open for %s %s"), calculate_price, "")
			end
		end

		local old_income_label = dialog:find_child("expedition_old_income_label", true, false)
		if old_income_label then
			old_income_label.caption = manager_block.old_amount
		end

		local new_income_label = dialog:find_child("expedition_new_income_label", true, false)
		if new_income_label then
			local income_value = 0
			local item_vector = manager_block:get_block_item_vector()
			for i = 1, #item_vector do
				income_value = income_value + item_vector[i].gold
			end

			new_income_label.caption = income_value
		end

		local closed_description = dialog:find_child("expedition_closed_description", true, false)
		if closed_description then
			local closed_str = framework:get_client_string("coins_to_gold2_profit")
			if closed_str ~= "" then
				closed_description.caption = closed_str
			end
		end
	end
------------------------------------------------------------------------------------------
end

function update_dlg()
	local buttons_container = dialog:find_child("buttons_container", true, false)
	if buttons_container then
		buttons_container:update_content()
	end

	local action_info = framework:game():get_coins_to_gold()
	local manager_block = action_info:get_manager_block_item_vector()[active_block]

	local block_unlock = manager_block.state == sqc.city.coins_to_gold_block_state.coins_to_gold_block_unlock

	local items_container = dialog:find_child("expedition_items_container", true, false)
	if items_container and items_container.visible ~= block_unlock then
		items_container.visible = block_unlock
	end

	local closed_widget = dialog:find_child("expedition_closed_widget", true, false)
	if closed_widget and closed_widget.visible == block_unlock then
		closed_widget.visible = not(block_unlock)
	end

	if block_unlock then
		if items_container then
			items_container:update_content()
		end
	else
		local open_block_button = dialog:find_child("open_block_button", true, false)
		if open_block_button then
			open_block_button.action = function()
				dialog:play_sound("menu");
				open_block(active_block)
			end

			local open_label = open_block_button:find_child("open_block_label", true, false)
			if open_label then
				local calculate_price = action_info:get_price(manager_block.product_id)
				open_label.caption = string.format(framework:strings():load("*CityCoinsToGoldOpenBlockFor", "Open for %s %s"), calculate_price, "")
			end
		end

		local old_income_label = dialog:find_child("expedition_old_income_label", true, false)
		if old_income_label then
			old_income_label.caption = manager_block.old_amount
		end

		local new_income_label = dialog:find_child("expedition_new_income_label", true, false)
		if new_income_label then
			local income_value = 0
			local item_vector = manager_block:get_block_item_vector()
			for i = 1, #item_vector do
				income_value = income_value + item_vector[i].gold
			end

			new_income_label.caption = income_value
		end

		local closed_description = dialog:find_child("expedition_closed_description", true, false)
		if closed_description then
			local closed_str = framework:get_client_string("coins_to_gold2_profit")
			if closed_str ~= "" then
				closed_description.caption = closed_str
			end
		end
	end
end

function update_active_block_number()
	local action_info = framework:game():get_coins_to_gold()
	if active_block > 0 then
		local manager_block = action_info:get_manager_block_item_vector()[active_block]
		if is_block_available(manager_block) then
			return
		end
	end

	active_block = 0
	for i = 1, #action_info:get_manager_block_item_vector() do
		local manager_block = action_info:get_manager_block_item_vector()[i]
		if active_block == 0 and is_block_available(manager_block) then
			active_block = i
			return
		end
	end

	active_block = -1
end

function is_block_available(manager_block)
	if global_action_info:get_calculate_duration() < 0 then
		return	manager_block.state == sqc.city.coins_to_gold_block_state.coins_to_gold_block_unlock
	else
		return	manager_block.state == sqc.city.coins_to_gold_block_state.coins_to_gold_block_lock or manager_block.state == sqc.city.coins_to_gold_block_state.coins_to_gold_block_unlock
	end
end

function is_block_not_bought(manager_block)
	return	manager_block.state == sqc.city.coins_to_gold_block_state.coins_to_gold_block_lock
end

function is_block_cooldown(manager_block)
	return	manager_block.state == sqc.city.coins_to_gold_block_state.coins_to_gold_block_cooldown
end

function is_block_unblock(manager_block)
	return	manager_block.state == sqc.city.coins_to_gold_block_state.coins_to_gold_block_unlock
end

function is_block_closed(manager_block)
	return	manager_block.state == sqc.city.coins_to_gold_block_state.coins_to_gold_block_close
end

function get_texture_name(texture)
	local texture_by_device = texture
	if g_device.is_tablet then
		texture_by_device = texture_by_device .. "_ipad"
	end
	return texture_by_device
end

function open_block(block_idx)
	local index = block_idx - 1
	print("open block = ", block_idx, ", index = ", index)

	local action_info = framework:game():get_coins_to_gold()

	local callbacks = {}
	callbacks["success"] = 	function()
								if dialog == 0 or dialog == nil then
									print("Warning! Invalid ui_platform_dlg dialog")
									return
								end
								print("[ open_block ] purchase success - update dlg")
								update_dlg()
							end

	callbacks["error"] = 	function()
								if dialog == 0 or dialog == nil then
									print("Warning! Invalid ui_platform_dlg dialog")
									return
								end
								print("[ open_block ] purchase error")
								dialog:end_dialog()
						 	end

	action_info:append_purchase_complete_callback(callbacks["success"])
	action_info:append_purchase_error_callback(callbacks["error"])

	action_info:start_purchase(index);
end

function open_coins_to_cash_buy_functional(item_cell, block_idx, item_idx)

	print("[ coins_to_cash_buy ] block = ", block_idx, "item_idx = ", item_idx)

	local action_info = framework:game():get_coins_to_gold()
	local manager_block = action_info:get_manager_block_item_vector()[block_idx]

	local item = manager_block:get_block_item_vector()[item_idx]

	print("block = ", manager_block.block)
	print("name = ", item.name)
	print ("[ coins_to_cash_buy ] actual coins=", framework:game().coins);
	print ("[ coins_to_cash_buy ] item coins=", item.coins);

	if action_info:check_enough_coins(item.coins) == false then
		show_not_enough_coins()
		return
	end


	local buttons_container = dialog:find_child("buttons_container", true, false)
	if buttons_container then
		buttons_container.disabled = true		
	end

	local dialog_close_button = dialog:find_child("dialog.close_button", true, false)
	if dialog_close_button then
		dialog_close_button.active = false
	end




	local active_block_button = item_cell:find_child("active_block_button", true, false)
	if active_block_button and active_block_button.visible then
		active_block_button.visible = false
	end

	local active_block_process = item_cell:find_child("active_block_process_widget", true, false)
	if active_block_process and not(active_block_process.visible) then
		active_block_process.visible = true
	end

	local items_container = dialog:find_child("expedition_items_container", true, false)
	if items_container then
		local cells = items_container:get_cells()
		for i = 1, #cells do
			local item_button = cells[i]:find_child("active_block_button", true, false)
			if item_button then
				item_button.active = false
			end

			local item_coins_image = cells[i]:find_child("active_block_button_coins_image", true, false)
			if item_coins_image then
				item_coins_image.visible = false
			end

			local item_coins_image_grey = cells[i]:find_child("active_block_button_coins_image_grey", true, false)
			if item_coins_image_grey then
				item_coins_image_grey.visible = true
			end
		end
	end

	local progress_widget = item_cell:find_child("progress_widget", true, false)
	if progress_widget then
		progress_widget.sectors_image = "c2c_exped_progress_mask"

		progress_widget.circles_in_row_count = 10
		progress_widget.circles_in_column_count = 5

		progress_widget.sectors_count = 50

		progress_mask = item_cell:find_child("progress_mask", true, false)
		if progress_mask then
			local progress_animation_size = {progress_mask.rect[3], progress_mask.rect[4]}
			local progress_animation_offset = {progress_mask.rect[1], progress_mask.rect[2]}

			progress_widget.image_size = progress_animation_size
			progress_widget.progress_offset = progress_animation_offset
		end

		progress_widget.all_progress_time = 1500
		animation_in_process = true
		progress_widget.finish_callback =	function()
												
												local buttons_container = dialog:find_child("buttons_container", true, false)
												if buttons_container then
													buttons_container.disabled = false
												end
											
												local dialog_close_button = dialog:find_child("dialog.close_button", true, false)
												if dialog_close_button then
													dialog_close_button.active = true
												end
												
												
												if active_block_process and active_block_process.visible then
													active_block_process.visible = false
												end

												local cell_completed_block = item_cell:find_child("cell_completed_block", true, false)
												if cell_completed_block and not(cell_completed_block.visible) then
													cell_completed_block.visible = true
												end

												local completed_label = item_cell:find_child("completed_block_label", true, false)
												if completed_label then
													local completed_str = framework:get_client_string("coins_to_gold2_done")
													if completed_str ~= "" then
														completed_label.caption = completed_str
													end
												end

												local income_caption_label = item_cell:find_child("completed_block_income_label", true, false)
												if income_caption_label then
													local income_str = framework:get_client_string("coins_to_gold2_profit3")
													if income_str ~= "" then
														income_caption_label.caption = income_str
													end
												end

												local income_value_label = item_cell:find_child("completed_block_income_value", true, false)
												if income_value_label then
													income_value_label.caption = string.format(income_value_label.caption, item.gold)
												end

												animation_in_process = false
												coins_to_cash_buy(block_idx, item_idx)
											end

		progress_widget:start_animation()
	end
	print("[ coins_to_cash_buy ] block = ", block_idx, "item_idx = ", item_idx, "end_function")
end

function coins_to_cash_buy(block_idx, item_idx)
	print("[ coins_to_cash_buy ] block = ", block_idx, "item_idx = ", item_idx)

	local action_info = framework:game():get_coins_to_gold()
	local manager_block = action_info:get_manager_block_item_vector()[block_idx]

	local item = manager_block:get_block_item_vector()[item_idx]

	print("block = ", manager_block.block)
	print("name = ", item.name)
	print ("[ coins_to_cash_buy ] actual coins=", framework:game().coins);
	print ("[ coins_to_cash_buy ] item coins=", item.coins);

	if action_info:check_enough_coins(item.coins) == false then
		show_not_enough_coins()
		return
	end

	local cmd_name = "sqc_coins_to_gold_buy_command"
	local cmd_meta = cclasses[cmd_name]
	if not cmd_meta then
		error('[ coins_to_cash_buy ] not found command class ' .. cmd_name)
		return
	end

	local reward_dlg = cclasses.sqc_scriptable_dialog.create(framework:windows().desktop, "coins_to_gold_receive_reward.lua")

	if reward_dlg then
		reward_dlg.scripting_object.reward_value = item.gold
		reward_dlg.scripting_object.translate_key = manager_block:get_translte()[1]
		reward_dlg.scripting_object.item_id = item_idx
		reward_dlg.scripting_object.block_id = block_idx

		update_callback =  	function()
								if dialog == 0 or dialog == nil then
									print("Warning! Invalid ui_platform_dlg dialog")
									return
								end
								print("update main window")
								update_active_block_number()
								if active_block == -1 then
									dialog:end_dialog()
								else 
									update_dlg()
								end
							end

		reward_dlg.scripting_object.update_callback = update_callback
		reward_dlg:do_modal()
	end
end

function show_not_enough_coins()
	framework:dialogs():show_show_not_enough_bucks_dialog(2)
end

buttons_container_delegate = {
	create_cell = function(self, idx, rect)
		local button_cell = self.table:create_child(rect)
		local block_idx = idx + 1

		framework:json_ui_manager():build_from_resource("coins_to_gold_button_cell", button_cell)
		button_cell.rect = rect

		local action_info = framework:game():get_coins_to_gold()
		local manager_block = action_info:get_manager_block_item_vector()[block_idx]

		local button = button_cell:find_child("block_button", true, false)
		if button then
			local current_block = nil
			local count_label = nil
			local name_label = nil

			local available = is_block_available(manager_block)
			local is_accomplished = manager_block.state == sqc.city.coins_to_gold_block_state.coins_to_gold_block_close

			local new_texture_name = ""
			if block_idx == active_block then
				new_texture_name = "c2c_btn_expedition_1"
			end
			if not(available) then
				new_texture_name = "c2c_btn_expedition_2"
			end

			if new_texture_name ~= "" then
				local active_button_texture = get_texture_name(new_texture_name)
				button.image_name = active_button_texture
				button.pressed_image = active_button_texture
			end

			if not(available) then
				if global_action_info:get_calculate_duration() < 0 then
					current_block = button_cell:find_child("expired_block", true, false)
					local expired_label = button_cell:find_child("expired_label", true, false)
					if expired_label then
						local expired_str = framework:get_client_string("coins_to_gold2_expired")
						if expired_str ~= "" then
							expired_label.caption = expired_str
						end
					end
				elseif is_accomplished then
					current_block = button_cell:find_child("closed_block", true, false)
					local accomplished_label = button_cell:find_child("expedition_accomplished_label", true, false)
					if accomplished_label then
						local accomplished_str = framework:get_client_string("coins_to_gold2_all_finished")
						if accomplished_str ~= "" then
							accomplished_label.caption = accomplished_str
						end
					end
				else
					current_block = button_cell:find_child("cooldown_block", true, false)
					local cooldown_block_label = button_cell:find_child("cooldown_block_label", true, false)
					if cooldown_block_label then
						local cooldown_str = framework:get_client_string("coins_to_gold2_cooldown")
						if cooldown_str ~= "" then
							cooldown_block_label.caption = cooldown_str
						end
					end
				end
			else
				local is_unlock = is_block_unblock(manager_block)
				local current_expedition = manager_block.quantity_set - #manager_block:get_set() + 1;
				
				if block_idx == active_block then
					if (is_unlock) or (current_expedition > 1) then
						current_block = button_cell:find_child("selected_active_block_open", true, false)
						count_label = button_cell:find_child("selected_active_block_open_count_label", true, false)
						name_label = button_cell:find_child("selected_active_block_open_name_label", true, false)
					else
						current_block = button_cell:find_child("selected_active_block_not_open", true, false)
						name_label = button_cell:find_child("selected_active_block_not_open_name_label", true, false)
					end
				else
					if (is_unlock) or (current_expedition > 1) then
						current_block = button_cell:find_child("usual_active_block_open", true, false)
						count_label = button_cell:find_child("usual_active_block_open_count_label", true, false)
						name_label = button_cell:find_child("usual_active_block_open_name_label", true, false)
					else
						current_block = button_cell:find_child("usual_active_block_not_open", true, false)
						name_label = button_cell:find_child("usual_active_block_not_open_name_label", true, false)
					end
				end
			end

			if current_block and not(current_block.visible) then
				current_block.visible = true
			end

			if count_label then
				local current_expedition = manager_block.quantity_set - #manager_block:get_set() + 1;
				if current_expedition > manager_block.quantity_set then
					current_expedition = manager_block.quantity_set
				end

				local x_from_y = framework:get_client_string(action_info.cfg_action_config.translation_key_prefix .. "x_from_y")

				local x_from_y_label = current_expedition .. "/" .. manager_block.quantity_set .. " expeditions"
				
				if x_from_y then
					local s, e, a, b, c, d = string.find(x_from_y, "^(.*)({%d+})(.*)({%d+})")
					if a and c then
						x_from_y_label = a .. current_expedition .. c .. manager_block.quantity_set
					end
				end

				count_label.caption = x_from_y_label
			end

			if name_label then
				local translte_key = manager_block:get_translte()[1] .. ":name"
				name_label.caption = framework:get_client_string(translte_key)
				if name_label.caption == "" then
					name_label.caption = translte_key
				end
			end

			local cooldown = manager_block:get_calculate_cooldown()
			if	(cooldown > 0 and packs_cooldown[block_idx] <= 0) or
				(cooldown <= 0 and packs_cooldown[block_idx] > 0) then
				packs_cooldown[block_idx] = cooldown
			end

			if available then
				button.action = function()
					dialog:play_sound("menu");
					check_to_block(block_idx)
				end
			end

			local timer = button_cell:find_child("cooldown_block_timer_label", true, false)
			if timer then
				timer.time = cooldown
				timers[block_idx] = timer
			end
		end

		return button_cell
	end,

	get_cell_count = function()
		local action_info = framework:game():get_coins_to_gold()
		return #action_info:get_manager_block_item_vector()
	end
}

expedition_items_container_delegate = {
	create_cell = function(self, idx, rect)
		local item_cell = self.table:create_child(rect)
		local item_idx = idx + 1

		framework:json_ui_manager():build_from_resource("coins_to_gold_item_cell", item_cell)
		item_cell.rect = rect

		local action_info = framework:game():get_coins_to_gold()
		local manager_block = action_info:get_manager_block_item_vector()[active_block]

		local item = manager_block:get_block_item_vector()[item_idx]

		local cell_caption = item_cell:find_child("cell_caption", true, false)
		if cell_caption then
			local translte_key = manager_block:get_translte()[1] .. ":action" .. item_idx
			cell_caption.caption = framework:get_client_string(translte_key)
			if cell_caption.caption == "" then
				cell_caption.caption = translte_key
			end
		end

		if item.available then
			local cell_active_block = item_cell:find_child("cell_active_block", true, false)
			if cell_active_block then
				if not(cell_active_block.visible) then
					cell_active_block.visible = true
				end

				local income_caption_label = item_cell:find_child("active_block_income_label", true, false)
				if income_caption_label then
					local income_str = framework:get_client_string("coins_to_gold2_profit2")
					if income_str ~= "" then
						income_caption_label.caption = income_str
					end
				end

				local income_value_label = item_cell:find_child("active_block_income_value", true, false)
				if income_value_label then
					income_value_label.caption = string.format(income_value_label.caption, item.gold)
				end

				local button_price_label = item_cell:find_child("active_block_button_price_label", true, false)
				if button_price_label then
					button_price_label.caption = item.coins
				end

				local active_block_button = item_cell:find_child("active_block_button", true, false)
				if active_block_button then
					active_block_button.action = function()
						dialog:play_sound("menu");
						open_coins_to_cash_buy_functional(item_cell, active_block, item_idx)
					end
				end
			end

			local cell_completed_block = item_cell:find_child("cell_completed_block", true, false)
			if cell_completed_block and cell_completed_block.visible then
				cell_completed_block.visible = false
			end
		else
			local cell_completed_block = item_cell:find_child("cell_completed_block", true, false)
			if cell_completed_block then
				if not(cell_completed_block.visible) then
					cell_completed_block.visible = true
				end

				local income_caption_label = item_cell:find_child("completed_block_income_label", true, false)
				if income_caption_label then
					local income_str = framework:get_client_string("coins_to_gold2_profit3")
					if income_str ~= "" then
						income_caption_label.caption = income_str
					end
				end

				local income_value_label = item_cell:find_child("completed_block_income_value", true, false)
				if income_value_label then
					income_value_label.caption = string.format(income_value_label.caption, item.gold)
				end

				local completed_label = item_cell:find_child("completed_block_label", true, false)
				if completed_label then
					local completed_str = framework:get_client_string("coins_to_gold2_done")
					if completed_str ~= "" then
						completed_label.caption = completed_str
					end
				end
			end

			local cell_active_block = item_cell:find_child("cell_active_block", true, false)
			if cell_active_block and cell_active_block.visible then
				cell_active_block.visible = false
			end
		end

		return item_cell
	end,

	get_cell_count = function()
		local action_info = framework:game():get_coins_to_gold()
		local manager_block = action_info:get_manager_block_item_vector()[active_block]
		return #manager_block:get_block_item_vector()
	end
}
