local action_end_date = 0
local num_tick = 0
local global_action_info

function get_texture_name(texture)
	local texture_by_device = texture
	if g_device.is_tablet then
		texture_by_device = texture_by_device .. "_ipad"
	end
	return texture_by_device
end

function on_init_dialog()
	dialog.theme_flags = 2
	dialog:load_content('coins_to_gold_anons_dialog')

	local args = {}
	args.user_level = framework:game().level
	args.subtype1 = "c2c"
	framework:statistics():send_custom_event(framework:networks():get_user_id(), "show_promo", args)

	if dialog.caption then
		local caption_str = framework:get_client_string("coins_to_gold2_expeditions")
		if caption_str ~= "" then
			dialog.caption = caption_str
		end
	end

	local anons_image = dialog:find_child('anons_image', true, false)
	if anons_image then
		anons_image.texture_name = get_texture_name("actions/coins2cash/art_promo")
	end

	local description_label = dialog:find_child('anons_description_label', true, false)
	if description_label then
		local description_str = framework:get_client_string("coins_to_gold2_expeditions_promo")
		if description_str ~= "" then
			description_label.caption = description_str
		end
	end

	-- local income_label = dialog:find_child('anons_income_label', true, false)
	-- if income_label then
	-- 	income_label.caption = framework:get_client_string("coins_to_gold2_profit2")
	-- end

	global_action_info = framework:game():get_coins_to_gold()
	action_end_date = global_action_info:get_calculate_duration()


	local anons_timer_label = dialog:find_child('anons_timer_label', true, false)
	if anons_timer_label then
		anons_timer_label.time = action_end_date
	end
		
	-- local income_value = 0
	-- for i = 1, #action_info:get_manager_block_item_vector() do
	-- 	local manager_block = action_info:get_manager_block_item_vector()[i]
	-- 	local item_vector = manager_block:get_block_item_vector()
	-- 	for j = 1, #item_vector do
	-- 		income_value = income_value + item_vector[j].gold
	-- 	end
	-- end

	local income_value_label = dialog:find_child('anons_income_value', true, false)
	if income_value_label then
		income_value_label.caption = global_action_info.total_gold
	end
end

function on_post_init_dialog()
	adjust_title_dialog()
end

function adjust_title_dialog()
	local dialog_title_caption = dialog:find_child('dialog_title_caption', true, false)
	if dialog_title_caption then
		print("dialog_title_caption found")

		local caption_rect = dialog_title_caption.rect
		print("caption_rect", caption_rect[1], caption_rect[2], caption_rect[3], caption_rect[4])

		if g_device.is_tablet then
			if caption_rect[3] > 415 then
				caption_rect[3] = 415
				dialog_title_caption.rect = caption_rect
				dialog_title_caption.text_adjust_font_size = true
			end
		elseif g_device.is_phone then
			caption_rect[3] = 259
			dialog_title_caption.rect = caption_rect
			dialog_title_caption.text_adjust_font_size = true
		end
	end
	
	local dialog_title_bevel = dialog:find_child('dialog_title_bevel', true, false)
	if dialog_title_bevel then
		print("dialog_title_bevel found")
		
		local title_bevel_rect = dialog_title_bevel.rect 
		print("title_bevel_rect", title_bevel_rect[1], title_bevel_rect[2], title_bevel_rect[3], title_bevel_rect[4])
		
		if g_device.is_tablet then
			if title_bevel_rect[3] > 430 then
				title_bevel_rect[3] = 430
				dialog_title_bevel.rect = title_bevel_rect
			end
		elseif g_device.is_phone then
			title_bevel_rect[3] = 267
			dialog_title_bevel.rect = title_bevel_rect
		end
	end
end

function on_timer(tick)
	if tick > num_tick then	
		num_tick = tick + 1000
		
		if global_action_info then	
			action_end_date = global_action_info:get_calculate_duration()
			update_timer()
		end
	end
end

function update_timer()
	if dialog then
		if action_end_date < 0 then
			dialog:end_dialog()
		end

		local anons_timer_label = dialog:find_child('anons_timer_label', true, false)
		if anons_timer_label then
			anons_timer_label.time = action_end_date
		end
	end
end

function on_anons_go_button_action()
	print("[ on_anons_go_button_action ]")
	start_coins_to_gold_action(true)
	dialog:end_dialog()
end

function on_close_button_pressed()
	print("[ on_close_button_action ]")
	start_coins_to_gold_action(false)
	dialog:end_dialog()
end

function start_coins_to_gold_action(show_main_dialog)
	local action_info = framework:game():get_coins_to_gold()
	local start_sets = action_info:get_start_set()

	print("[ start_coins_to_gold_action ] start_sets = ", start_sets)

	local cmd_name = "sqc_coins_to_gold_start_command"
	local cmd_meta = cclasses[cmd_name]
	if cmd_meta then
		local cmd = cmd_meta.new(game.native.room_id, start_sets)
		local callbacks = {}
		callbacks["success"] = 	function()
									print(cmd_name .. " complete success")
									if show_main_dialog then
										coins_to_gold_dlg = cclasses.sqc_scriptable_dialog.create(framework:windows().desktop, "coins_to_gold.lua")
										coins_to_gold_dlg:do_modal()
									end
								end
		callbacks["error"] = 	function()
									print(cmd_name .. " complete with error")
								end

		cmd:append_complete_callback(callbacks.success)
		cmd:append_error_callback(callbacks.error)

		framework:cmd_processor():schedule(cmd, 0)
	else
		error('[ start_coins_to_gold_action ] not found command class ' .. cmd_name)
	end
end
