function get_texture_name(texture)
	local texture_by_device = texture
	if g_device.is_tablet then
		texture_by_device = texture_by_device .. "_ipad"
	end
	return texture_by_device
end

function on_init_dialog()
	dialog.theme_flags = 2
	dialog:load_content('coins_to_gold_final_dialog')

    local args = {}
    args.user_level = framework:game().level
    args.subtype1 = "c2c"
    framework:statistics():send_custom_event(framework:networks():get_user_id(), "show_final", args)

	if dialog.caption then
		local caption_str = framework:get_client_string("coins_to_gold2_complete_title")
		if caption_str ~= "" then
			dialog.caption = caption_str
		end
	end

	local anons_image = dialog:find_child('final_image', true, false)
	if anons_image then
		anons_image.texture_name = get_texture_name("actions/coins2cash/art_promo_final")
	end

	local description_label = dialog:find_child('final_description_label', true, false)
	if description_label then
		local description_str = framework:get_client_string("coins_to_gold2_expeditions_complete")
		if description_str ~= "" then
			description_label.caption = description_str
		end
	end
end

function on_post_init_dialog()
	adjust_title_dialog()
end

function adjust_title_dialog()
	local dialog_title_caption = dialog:find_child('dialog_title_caption', true, false)
	if dialog_title_caption then
		print("dialog_title_caption found")

		local caption_rect = dialog_title_caption.rect 
		print("caption_rect", caption_rect[1], caption_rect[2], caption_rect[3], caption_rect[4])

		if g_device.is_tablet then
			caption_rect[3] = 595
			dialog_title_caption.rect = caption_rect
			dialog_title_caption.text_adjust_font_size = true
		elseif g_device.is_phone then
			caption_rect[3] = 385
			dialog_title_caption.rect = caption_rect
			dialog_title_caption.text_adjust_font_size = true			
		end
	end
	
	local dialog_title_bevel = dialog:find_child('dialog_title_bevel', true, false)
	if dialog_title_bevel then
		print("dialog_title_bevel found")

		local title_bevel_rect = dialog_title_bevel.rect 
		print("title_bevel_rect", title_bevel_rect[1], title_bevel_rect[2], title_bevel_rect[3], title_bevel_rect[4])

		if g_device.is_tablet then
			title_bevel_rect[3] = 600
			dialog_title_bevel.rect = title_bevel_rect
		elseif g_device.is_phone then
			title_bevel_rect[3] = 385
			dialog_title_bevel.rect = title_bevel_rect
		end
	end
end

function on_final_close_button_action()
	print("[ on_final_close_button_action ]")
	dialog:end_dialog()
end
