
function get_texture_name(texture)
	local texture_by_device = texture
	if g_device.is_tablet then
		texture_by_device = texture_by_device .. "_ipad"
		print(texture_by_device)
	end
	return texture_by_device
end

function on_init_dialog()
--	dialog.theme_flags = 2
	dialog:load_content('coins_to_gold_reward_dialog')

	print("[c2c] translate_key = ", translate_key)
	print("[c2c] item_id = ", item_id)
	print("[c2c] block_id = ", block_id)

	local action_info = framework:game():get_coins_to_gold()
	local manager_block = action_info:get_manager_block_item_vector()[block_id]

	print("[c2c] manager_block:get_rand_trophy() = ", manager_block:get_rand_trophy())

	local reward_title_label = dialog:find_child("reward_title_label", true, false)
	if reward_title_label then
		local reward_title_str = framework:get_client_string("coins_to_gold2_complete_title")
		if reward_title_str ~= "" then
			reward_title_label.caption = reward_title_str
		end
	end

	complete_label =  translate_key .. ":" .. "action" .. item_id .. "_complete"
	print("complete_label = ", complete_label)

	local reward_description_label = dialog:find_child("reward_description_label", true, false)
	if reward_description_label then
		local complete_str = framework:get_client_string(complete_label)
		if complete_str ~= "" then
			reward_description_label.caption = complete_str
		end
	end

	local trophy = manager_block:get_rand_trophy()

	local reward_name_label = dialog:find_child("reward_name_label", true, false)
	if reward_name_label then
		local trophy_str = framework:get_client_string(trophy)
		if trophy_str ~= "" then
			reward_name_label.caption = trophy_str
		end
	end

	local reward_frame_image = dialog:find_child("reward_frame_image", true, false)
	if reward_frame_image then
		reward_frame_image.texture_name = trophy
		reward_frame_image:set_ready_progress_as_indicator()
	end

	local button_take_label = dialog:find_child("reward_dialog_take_label", true, false)
	if button_take_label then
		button_take_label.caption = string.format(button_take_label.caption, reward_value)
	end	
end

function start_buy_command()
	print("[c2c] item_id = ", item_id)
	print("[c2c] block_id = ", block_id)

	local action_info = framework:game():get_coins_to_gold()
	local manager_block = action_info:get_manager_block_item_vector()[block_id]

	local cmd_name = "sqc_coins_to_gold_buy_command"
	local cmd_meta = cclasses[cmd_name]
	if not cmd_meta then
		error('[ coins_to_cash_buy ] not found command class ' .. cmd_name)
		return
	end

	local item = manager_block:get_block_item_vector()[item_id]

	local cmd = cmd_meta.new(game.native.room_id, manager_block.block, item.name)

	local callbacks = {}
	callbacks["success"] = 	function()
								start_buy_command_compete()
							end

	callbacks["error"] = 	function()
								print(cmd_name .. " complete with error")
--								dialog:end_dialog()
						 	end

	cmd:append_complete_callback(callbacks.success)
	cmd:append_error_callback(callbacks.error)

	framework:cmd_processor():schedule(cmd, 0)
end

function show_final_dlg()
	local final_dlg = cclasses.sqc_scriptable_dialog.create(framework:windows().desktop, "coins_to_gold_final.lua")
	if final_dlg then
		final_dlg:do_modal()
	end
end

function start_buy_command_compete()
	print("[c2c] start_buy_command_compete()")

	local action_info = framework:game():get_coins_to_gold()

	local left_item = 0
	local left_set = 0

	for i = 1, #action_info:get_manager_block_item_vector() do
		local manager_block = action_info:get_manager_block_item_vector()[i]
		left_item = left_item + #manager_block:get_item()
		left_set = left_set +  #manager_block:get_set()
	end

	print("[c2c] left_item = ", left_item)
	print("[c2c]left_set = ", left_set)

	if left_item == 0  and left_set == 0 then
		show_final_dlg()
	else
		if left_item == 0 and action_info:get_calculate_duration() < 0 then
			show_final_dlg()
		end
	end

	if update_callback then
		print("[c2c] update_callback main_dlg")
		update_callback()
	end

--	dialog:end_dialog()
end

function on_reward_dialog_take_button_action()
--	start_buy_command()
	dialog:end_dialog()
end

function end_dialog()
	print("[c2c] reward_dlg  call start_buy_command()")
	start_buy_command()
end