function on_init_dialog( )

    dialog:load_content('cross_promo_rewards_dlg')

    create_dialog_elements()

end

function get_texture_name(texture)
    if g_device.is_tablet then
        texture = texture .. "_ipad"
    end
    if g_device.is_hdpi then
        texture = texture .. "@2x"
    end
    return texture
end

function increase_rect(rect, x, y, cx, cy)
    rect[1] = rect[1] + x
    rect[2] = rect[2] + y
    rect[3] = rect[3] + cx
    rect[4] = rect[4] + cy
    return rect
end

function fill_cell(tag, award)

    local cell_bg = dialog:find_child(tag, true, false)
    if not cell_bg then
        print("[city_cross_promo_rewards_dlg] cell not found "..tag)
    end

    cell_bg.visible = true

    local is_building = cross_promo_controller:is_building(award.type)

    local cell_label = cell_bg:find_child("cell_label" , true, false)
    if cell_label then
        cell_label.visible = not is_building
        cell_label.caption = award.amount
    end


    local cell_image = cell_bg:find_child("cell_image" , true, false)
    if cell_image then
        if is_building then
            cell_image.rect = g_device.is_tablet and increase_rect(cell_image.rect, -15, -15, 30, 25) 
                                                 or increase_rect(cell_image.rect, -12, -15, 24, 20)
        end
        cell_image.texture_name = cross_promo_controller:get_texture_name(award.type)
        cell_image:set_ready_progress_as_indicator()
    end
end

function create_dialog_elements()

    local offer = cross_promo_controller.offer
    if not offer then 
        print("[city_cross_promo_rewards_dlg] offer not found")
    end

    local title_label = dialog:find_child('title_label', true, false)
    if title_label then 
        title_label.caption = offer.title
    end

    local text_label = dialog:find_child('text_label', true, false)
    if text_label then 
        text_label.caption = offer.description_reward
    end

    local awards = offer:get_rewards()
    if not offer then 
        print("[city_cross_promo_rewards_dlg] awards not found")
    else
        if #awards == 1 then
            fill_cell('cell_center_item_bg', awards[1])
        else
            fill_cell('cell_left_item_bg', awards[1])
            fill_cell('cell_right_item_bg', awards[2])
        end
    end
end

function on_post_init_dialog()
end

function end_dialog()
    local cross_promo = framework:game():get_cross_promo_manager()
    if not cross_promo.initialized then
        print("[city_cross_promo_rewards_dlg] cross promo manager hasn't been initialized")
    end

    local offer = cross_promo_controller.offer
    if not offer then
        print("[city_cross_promo_rewards_dlg] offer not found")
    end

    cross_promo:finish_offer( offer.offer_id )
end

function on_close_button_action()
    print("[city_cross_promo_rewards_dlg] on_close_button_action")
    dialog:end_dialog()
end

function on_accept_button_action()
    print("[city_cross_promo_rewards_dlg] on_accept_button_action")

    cross_promo_controller:on_accept_button_pressed()
    dialog:end_dialog()
end