
local num_tick = 0

local action_end_date = 0

local g_tr
local g_drum
local g_star
local g_win_lable
local g_drum_type


local g_num_of_sectors=14

local g_drum_use_customized_drum=true

local drum_numbers={}

local g_drum_animation_started=false
local g_drum_spinned=false

local g_angle

local g_bonus

local g_default_drum_type="drum_new_year"
local g_bonus_shown = false



function add_image_name_prefix_postfix(image_name)
    local image_name2=image_name

    if not g_device.is_phone then
        image_name2=image_name2 .. "_ipad"
    end

    local prefix="actions/".. "drum_action" .."/"
    
    if (#g_drum_type > 0) then
        prefix=prefix .. g_drum_type .. "/"
    else
        prefix=prefix .. g_default_drum_type .. "/"
    end 

    image_name2=prefix .. image_name2

    print("image_name ",image_name2)
    return image_name2
end


function on_close_button_pressed()
    print ("on_close_button_pressed()")
    dialog:end_dialog()
end

function customize_background()

    local background=dialog:find_child("image_bg", true, false)
    
    if(background) then
        background.image_name=add_image_name_prefix_postfix("bg_drum")
    end
end


function show_network_error_message()
    local params={}
    -- 0: sqc_message_box_type_default
    -- 1: sqc_message_box_type_local_error
    -- 2: sqc_message_box_type_server_error
    params.type = 2
    params.dlg_title= framework:strings():load("*CityServerRespondErrorTitle", "Error");  
    --params.dlg_text= framework:strings():load("*StockExchangeViewController_NoInternet", "Internet connection is required.");
    
    params.dlg_text=framework:get_client_string("drum_mobile_window_no_internet")
    
    params.button_text=framework:strings():load("*CityOKButton","OK" )
    framework:dialogs():show_message_box( params );
end


function show_prize_dialog(bonus)
    local info_dlg = cclasses.sqc_scriptable_dialog.create(framework:windows().desktop, "drum_output_dlg.lua")
    
	if info_dlg then
        g_bonus_shown = true
	    info_dlg.scripting_object.m_bonus=bonus
		info_dlg:do_modal()
	end
	
end


function end_dialog()
    print("[LUA]END OF DIALOG CALLED")
    framework:windows():animation():cancel_animation(g_tr)
    
    if(not g_bonus_shown and g_bonus) then
        local bonus_text=g_bonus .. "%"
        show_prize_dialog(bonus_text)
    end
end

function on_timer (tick)
	if tick > num_tick then
		num_tick = tick + 1000
        
        if not refresh_end_date() then
            action_end_date = action_end_date - 1
        end
		update_timer()
	end
end

function update_timer()
--			print("update_timer: action_end_date = ", action_end_date)
	if dialog then
	
		if(action_end_date < 0) then
			dialog:end_dialog()
		end
	
		local date_time_label = dialog:find_child('date_time', true, false)
		if date_time_label then
			date_time_label.time = action_end_date
		end
	end
end

function refresh_end_date()
	local action_info = framework:game():get_drum_bonus_action()
    local action = framework.extern_action:get_active_action_by_name(action_info.name, game.native.room_id)

    if action == nil then
        print("refresh_end_date: could not find action with nams" .. action_info.name)
        return false
     end

    action_end_date = action:get_duration()
    action_end_date = action_end_date/1000
--    print("refresh_end_date: action_end_date = ", action_end_date)
    
    return true
end


function on_post_init_dialog()
    local args = {}
    args.user_level = framework:game().level
    args.subtype1 = "drum_action"
    framework:statistics():send_custom_event(framework:networks():get_user_id(), "show_drum_window", args)
end

function on_init_dialog()

	print("on_init_dialog start")
	
	dialog.theme_flags = 2
	dialog:load_content('city_drum_main_dlg')
	dialog.center_dialog = true

	action_end_date = 12345
    
    refresh_end_date();

	local action_info = framework:game():get_drum_bonus_action()
	print("action_info.name = ", action_info.name)
    print("action_info.version = ", action_info.version )
    print("action_info.duration = ", action_info.duration )
    print("action_info.title = ", action_info.title )
    print("action_info.is_available = ", action_info.is_available )

    local action_config = framework:game():get_drum_bonus_info()
    print("action_config.version = ", action_config.version )
    print("action_config.segments_count = ", action_config.segments_count )
     
    g_drum_type=action_config.drum_type
    print("drum_type ",g_drum_type)
    
    local colors = action_config:get_custom_drum_colors()
    g_num_of_sectors=action_config.segments_count
    
    local bonuses=action_config:get_bonuses()
    
    print("num_of_bonuses ",#bonuses,bonuses[1])
    
    print("colors.size = ", #colors )

    print("drum_image == ", action_config.drum_image)
    
	customize_background()

	dialog.caption = framework:get_client_string("drum_mobile_window_action")
	
	local descr_label = dialog:find_child('descr_label', true, false)
	if descr_label then
		descr_label.caption = framework:get_client_string("drum_mobile_window_description") -- описание в желтой плашке 
	end
	
	local descr_label = dialog:find_child('sale_label', true, false)
	if descr_label then
		descr_label.caption = framework:get_client_string("drum_mobile_window_sale_description") -- label в красной стрелке
		descr_label.text_adjust_font_size = true
	end
	
	local descr_label = dialog:find_child('action_label', true, false)
	if descr_label then
		descr_label.caption = framework:get_client_string("drum_mobile_window_action_description") -- label на кнопке
		descr_label.text_adjust_font_size = true
	end
	
	 g_drum=dialog:find_child('round_drum', true, false)
	 
	 local font_size
	 local drum_image
	 
	 if g_device.is_phone then
	   font_size=10
	 else
	   font_size=17
	 end
	 
	 if(#bonuses < g_num_of_sectors) then
	     drum_numbers={20,25,30,35,40,45,50,55,60}
	 else
	     for i=1, #bonuses do
	         drum_numbers[i]=math.floor(100*(bonuses[i]+0.0001))
	     end
	 end
	 
	 --#######CREATE DRUM#########
	 
	 if (#action_config.drum_image==0) then
	     
	     local discount_plate="star_amount"
	     if not g_device.is_phone then
	         discount_plate=discount_plate .. "_ipad"
	     end
	     
	     local drum_sector_image=add_image_name_prefix_postfix("drum_sector")
	 
	     g_drum:create_controls(drum_sector_image,discount_plate,"Arial-BoldMT.otf", font_size,g_num_of_sectors)
	 
	     for i = 1, #colors do
             print("color == ", colors[i].color)
             print("alfa == ", colors[i].alfa)
             g_drum:add_color_hex(colors[i].color,colors[i].alfa)
         end
	
	     g_drum:set_drum_digits(drum_numbers)
	    
	 else
	    local drum_image=add_image_name_prefix_postfix(action_config.drum_image)
	    g_drum:create_drum(drum_image)
	 end
	 
	 
	 
	 g_star=dialog:find_child('win_circle',true,false)
	 
	 g_star.visible=false
	 
	 g_win_lable=dialog:find_child('win_label',true,false)
	 
	 if(action_info.version ~= action_config.version) then
         start_action()
   end

   get_bonuses()
	
end

function start_action()
    local cmd_name = "sqc_start_drum_action_command"
    local cmd_meta = cclasses[cmd_name]
    if not cmd_meta then
	   error('not found command class ' .. cmd_name)
    end   
    
    local cmd

    cmd = cmd_meta.new(game.native.room_id)
    print("cmd == ", cmd)

    local callbacks={}

    callbacks["success"] = function()
       print("drum action started")                         
    end

    callbacks["error"] = function()
       print("command complete error")
       if dialog then
         dialog:end_dialog()
       end  
    end
        
    send_cmd(cmd,callbacks) 
end


function get_bonuses()
    local cmd_name = "sqc_gen_drum_bonus_command"
    local cmd_meta = cclasses[cmd_name]
    if not cmd_meta then
	   error('not found command class ' .. cmd_name)
    end    

    local cmd

    cmd = cmd_meta.new(game.native.room_id)
   
    local callbacks={}

    callbacks["success"] = function()
       print("command  success") 
       local action_info = framework:game():get_drum_bonus_action()
       g_bonus=action_info.bonus
       g_bonus=math.floor((g_bonus+0.000001)*100)  
    end

    callbacks["error"] = function()
       print("command complete error")
       show_network_error_message()

       if dialog then 
         dialog:end_dialog()
       end  
    end
        
    send_cmd(cmd,callbacks) 
    
end


function send_cmd(cmd,callbacks)
    local cb = callbacks

    if cb.success then
       cmd:append_complete_callback(cb.success)
    end

    if cb.error then
       cmd:append_error_callback(cb.error)
    end

    framework:cmd_processor():schedule(cmd)
end

function on_spin_button_action()
    print("spin_button_action")
   
    if(not g_drum_animation_started) then
        g_drum_animation_started=true
        if dialog then
            drum_animation()                     
        end
    elseif (g_drum_spinned) then
       local spin_button=dialog:find_child("spin_button", true, false)
       if(spin_button) then
           spin_button.active=false
       end
       
       drum_final_animation()
    end

end

function get_index_of_bonus(bonus)
  for i=1,#drum_numbers do
     if(bonus == drum_numbers[i]) then
         return i
     end 
  end
  print("bonus not found in received settings drum_numbers, return default index 1")
  return 1
end


function drum_animation()
   local drum_rect=g_drum.rect
   g_angle=360/g_num_of_sectors

   anchor={drum_rect[3]/2,drum_rect[4]/2}

   local spin_label=dialog:find_child("action_label", true, false)
   
   g_star.visible=false

   if(g_drum) then
      g_tr=g_drum:transform()
      g_tr.anchor=anchor

      anumation_seq =cclasses.animation_animator_sequency.new(false)

      local start_angle=0
      
      --[[
      for time=1.8,0.45,-0.20 do
          anumation_seq:add(cclasses.animation_animator_rotate.new(start_angle,start_angle-180, time ))
          start_angle=start_angle-180
      end
      
      spin_label.caption=framework:strings():load("*CityHallActionStop", "Stop"); 
      
      g_drum_spinned=true
      
      anumation_seq:add(cclasses.animation_animator_rotate.new(0,-180*1000, 1000*0.45 ))
      --]]
      
      for time=0.5,0.1,-0.05 do
          anumation_seq:add(cclasses.animation_animator_rotate.new(start_angle,start_angle-g_angle, time ))
          start_angle=start_angle-g_angle
      end
      
      spin_label.caption=framework:strings():load("*CityHallActionStop", "Stop"); 
      
      g_drum_spinned=true
      
      anumation_seq:add(cclasses.animation_animator_rotate.new(0,-g_angle*1000, 1000*0.1 ))
      
      
      
      anumation_seq:add(cclasses.animation_animator_event.new(
                                function()
                                    drum_final_animation() 
                                end
                        ))
      
      
      framework:windows():animation():add_animator(g_tr,anumation_seq)
end


function drum_final_animation()
    framework:windows():animation():cancel_animation(g_tr)
    g_drum_spinned=false
    local rotation=g_tr.rotation
    
    local discount_num=get_index_of_bonus(g_bonus)-1
    local bonus_text=g_bonus .. "%"
    
    print("received discount num=",discount_num)
    
    anumation_seq =cclasses.animation_animator_sequency.new(false)
        
    rotation=(rotation%-360)
    local final_angle=-2*360 -rotation -g_angle*discount_num
        
        
    anumation_seq:add(cclasses.animation_animator_rotate.new(rotation,rotation+final_angle/3, 1.8))
    rotation=rotation+final_angle/3
    
    anumation_seq:add(cclasses.animation_animator_rotate.new(rotation,rotation+final_angle/3, 2.8))
        
    rotation=rotation+final_angle/3
        
    anumation_seq:add(cclasses.animation_animator_rotate.new(rotation,rotation+final_angle/3, 3.8))
    
    anumation_seq:add(cclasses.animation_animator_event.new(
                                function()
                                    g_star.visible=true
                                    g_win_lable.caption=bonus_text
                                end
                                ))
                                
      anumation_seq:add(cclasses.animation_animator_pause.new( 2 ))
      
      anumation_seq:add(cclasses.animation_animator_event.new(
                                function()
                                    show_prize_dialog(bonus_text)
                                    dialog:end_dialog()  
                                end
                        ))
        
        
    framework:windows():animation():add_animator(g_tr,anumation_seq)

end
	
	
end
