local drum_time
local num_tick = 0
local g_action_info={}
local g_drum_type
local g_default_drum_type="drum_new_year"

function add_image_name_prefix_postfix(image_name)
    local image_name2=image_name

    if not g_device.is_phone then
        image_name2=image_name2 .. "_ipad"
    end

    local prefix="actions/".. "drum_action" .."/"
    
    if (#g_drum_type > 0) then
        prefix=prefix .. g_drum_type .. "/"
    else
        prefix=prefix .. g_default_drum_type .. "/"
    end 

    image_name2=prefix .. image_name2

    print("image_name ",image_name2)
    return image_name2
end

function on_close_button_pressed()
    print ("on_close_button_pressed()")
    dialog:end_dialog()
end

function customize_background()

    local background=dialog:find_child("drum_art_image", true, false)
    
    if(background) then
        background.image_name=add_image_name_prefix_postfix("drum_art")
    end
    
    local win_background=dialog:find_child("discount_image", true, false)
    
    if(win_background) then
        win_background.image_name=add_image_name_prefix_postfix("drum_discount")
    end
    
end


function show_charge_dlg()
   framework:dialogs():show_ruby_buy_dlg()
   dialog:end_dialog() 
end

function on_init_dialog()

	dialog.theme_flags = 1

	dialog.bevel_type = 'none'

	dialog:load_content('drum_output_dlg')
	
	local action_config = framework:game():get_drum_bonus_info()
	local action_list = framework.extern_action:get_active_action(game.native.room_id)
    local action_name = framework:game():get_drum_bonus_action().name
    
    for i = 1,  #action_list do
        print("action_name = ", action_list[i].name)
        if (action_name == action_list[i].name) then
            g_action_info=action_list[i]
            break
        end
    end
    
    g_drum_type=action_config.drum_type
    
    g_action_end_date = g_action_info:get_duration()
    g_action_end_date = g_action_end_date/1000
    
    print("action_end_date = ", g_action_end_date)
	
	local drum_descr = framework:get_client_string("drum_mobile_window_reward_description")
	
    local charge_button = dialog:find_child('drum_theme_button', true, false)

    local discount_label=dialog:find_child("discount_label", true, false)

    if(discount_label) then
        discount_label.caption=m_bonus
    end
    
    if(charge_button) then
        charge_button.action = function()
            show_charge_dlg()
        end
    end 
   
    customize_background()
   
	local descr_label = dialog:find_child('descr_label', true, false)
	if descr_label then
        descr_label.caption = drum_descr
	end

	local charge_button_label = dialog:find_child('action_charge_label', true, false)
	if charge_button_label then	
		charge_button_label.caption = framework:get_client_string("drum_mobile_window_fill_account")
		charge_button_label.text_adjust_font_size = true
	end


	local suffix = lang_api.language_prefix(framework:language(true))

	if suffix == "ru" then
		return
	end

	local congratulation_image = dialog:find_child('congr_image', true, false)
	if congratulation_image then
		congratulation_image.image_name = get_device_texture_name("drum_your_winnings_" .. suffix)
	end
end

function get_device_texture_name(texture_name)
	if g_device.is_tablet then
		return texture_name .. "_ipad"
	end
	return texture_name
end

function on_timer (tick)

    g_action_end_date = g_action_info:get_duration()
    g_action_end_date = g_action_end_date/1000
    
	update_timer()
end

function update_timer()
	if dialog then
	
		if(g_action_end_date <= 0) then
			dialog:end_dialog()
		end
	
		local date_time_label = dialog:find_child('drum_date_time_label', true, false)
		if date_time_label then
			date_time_label.time = g_action_end_date
		end
	end
end


