/* vertex water shader for earth */

#ifdef GL_ES
#define LOWP lowp
#else
#define LOWP
#endif

attribute vec2 vPosition; 
attribute vec2 tPosition;
attribute LOWP vec4 vColor;
varying vec2 tCoords;
varying vec2 tCoordsBrush1;
varying vec2 tCoordsBrush2;
varying LOWP vec4 color;

uniform float time;
uniform mat4 vpMatrix;
uniform float offset_x;
uniform float offset_y;
uniform float scale;

void main()
{
   gl_Position = vpMatrix*vec4(vPosition,0.0,1.0);
   tCoords = tPosition;
   float x =  vPosition.x * scale - offset_x;
   float y =  vPosition.y * scale - offset_y;

    float tx1 = x/128.0;
    float tx2 = x/512.0;
    float ty1 = y/128.0;
    float ty2 = y/512.0;
    
    tx1+=sin(time*0.1)*0.25;
    ty1-=cos(time*0.1)*0.25;
    
    tx2+=cos(-time*0.02)*0.8;
    ty2-=sin(-time*0.03)*0.7;
    
   tCoordsBrush1 = vec2(tx1,ty1);
   tCoordsBrush2 = vec2(tx2,ty2);
    
   color = vColor;
}
