--local test_data = {
--	animals = {
--			{ name = 'bb' , found = true},
--			{ name = 'xx' , found = true },
--			{ name = 'xx' , found = true },
--			{ name = 'xx' , found = true },
--			
--			{ name = 'xx' , found = true },
--			{ name = 'xx' , found = false },
--			{ name = 'xx' , found = false },
--			{ name = 'xx' , found = false }
--		},
--}
--
--local rewards = {
--	{pos = 0, image = "", population = 0, coins = 0},
--	{pos = 0, image = "", population = 0, coins = 0}
--}

local timer = 123456
local num_tick = 0

local action_end_date = 0

function on_timer (tick)
	if tick > num_tick then
		num_tick = tick + 1000
		timer = timer - 1
		action_end_date = action_end_date - 1
		update_timer()
	end
end

function set_proxy_texture_widget(widget, texture)
	local widget_dlg = dialog:find_child(widget, true, false)
	if widget_dlg then
		widget_dlg.texture_name = texture
	end
end

function set_image_widget(widget, texture)
	local widget_dlg = dialog:find_child(widget, true, false)
	if widget_dlg then
		widget_dlg.image_name = texture
	end
end

function get_rect_widget(widget)
	local rect = {0, 0, 0, 0}
	local widget_dlg = dialog:find_child(widget, true, false)
	if widget_dlg then
		rect = widget_dlg.rect
	end
	return rect
end

function get_texture_name(texture)
	local texture_by_device = texture
	if g_device.is_tablet then
		texture_by_device = texture_by_device .. "_ipad"
		print(texture_by_device)
	end
	return texture_by_device
end

function hide_widget(widget_name, parent_widget)
	local widget = parent_widget:find_child(widget_name, true, false)
	if widget then
		widget.visible = false
	end
end

function show_widget(widget_name, parent_widget)
	local widget = parent_widget:find_child(widget_name, true, false)
	if widget then
		widget.visible = true
	end
end

function update_timer()
	if dialog then
	
		if(action_end_date < 0) then
			dialog:end_dialog()
		end
	
		local date_time_label = dialog:find_child('date_time', true, false)
		if date_time_label then
			date_time_label.time = action_end_date
		end
	end
end

function set_up_reward(reward_bg_image, reward_position, index_found, object_info)

	print("set_up_reward(), reward_position = ", reward_position, "index_found = ", index_found)

	local action_info = framework:game():get_escaped_action()
	local escaped_action_config = action_info.cfg_action_config
	
	if reward_position <= index_found then
	
		reward_bg_image.image_name = get_texture_name('green_item')
		
--		local get_label = reward_bg_image:find_child("get_label", true, false)
--		if get_label then
--			get_label.caption = framework:get_client_string(escaped_action_config.action_type .. "_mobile_window_text_get_reward") -- надпись получена
--		end

		hide_widget("get_label", reward_bg_image)	-- скрываем виджеты 
		hide_widget("check", reward_bg_image)
	
		local reward_label = reward_bg_image:find_child("reward", true, false)
		if reward_label then
			reward_label.caption = framework:strings():load("*CityEscapedActionGetTitle", "GET")
		end
		
		
		local reward_image = reward_bg_image:find_child("reward_image", true, false)
		if reward_image then
			reward_image.texture_name = object_info.shop_image_path -- изображение реварда
			reward_image:set_ready_progress_as_indicator()
			reward_image.visible = true
		end
		
		local grayscaled = reward_bg_image:find_child("grayscaled", true, false)
		if grayscaled then
			grayscaled.visible = false
		end
	else
		local reward_label = reward_bg_image:find_child("reward", true, false)
		if reward_label then
			reward_label.caption = framework:strings():load("*CityEscapedActionRewardTitle", "REWARD")
		end
	
		reward_bg_image.image_name = get_texture_name('grey_item') --search_from_1_revard_item_grey
		hide_widget("get_label", reward_bg_image)	-- скрываем виджеты 
		hide_widget("check", reward_bg_image)
		
		local reward_image = reward_bg_image:find_child("reward_image", true, false)
		if reward_image then
			reward_image.visible = false
		end
		
		local grayscaled = reward_bg_image:find_child("grayscaled", true, false)
		if grayscaled then
			grayscaled.visible = true
		end
		
		local grayscaled_reward_image = reward_bg_image:find_child("grayscaled_reward_image", true, false)
		if grayscaled_reward_image then
			grayscaled_reward_image.texture_name = object_info.shop_image_path -- изображение реварда
			grayscaled_reward_image:set_ready_progress_as_indicator()
		end
				
	end

	local reward_name = reward_bg_image:find_child("name", true, false)
	if reward_name then
		reward_name.caption = object_info.description -- reward_name_caption -- название реварда
	end
	
	
	local quantity_population = 0;
	if object_info.max_population_increase ~= 0 then
		quantity_population = object_info.max_population_increase  	-- население в реварде
	elseif object_info.population_increase ~= 0 then
		quantity_population = object_info.population_increase 	-- население в реварде
	end

	local population = reward_bg_image:find_child("population_label", true, false)
	if population and quantity_population ~= 0 then
		population.caption = "+" .. tostring(quantity_population)
		population.text_adjust_font_size = true 
	else
		hide_widget("population_box", reward_bg_image)
	end
	hide_widget("top_population_box", reward_bg_image)
	
	local coins = reward_bg_image:find_child("coins_label", true, false)
	if coins and object_info.extra_coins ~= 0 then
		coins.caption = "+" .. tostring(object_info.extra_coins) -- монеты в реварде
		coins.text_adjust_font_size = true
	else		
		hide_widget("coins_box", reward_bg_image)		
	end
	hide_widget("top_coins_box", reward_bg_image)

end

function update_dlg()
	
	local action_info = framework:game():get_escaped_action()
	local escaped_action_config = action_info.cfg_action_config
	
	local num_rewards = 0
	local rewards_position = {0,0}
	
	print("escaped_action_config.action_type = ", escaped_action_config.action_type)
	
	local info_provider = framework:object_factory()
	local num_action_escaped = info_provider:get_num_escaped_in_custom_actions()
	
	for i = 1, #escaped_action_config:get_escaped_item_list() do
		print("escaped_action_config:get_escaped_item_list()[].name = ",escaped_action_config:get_escaped_item_list()[i].name)
		print("escaped_action_config:get_escaped_item_list()[].chance = ",escaped_action_config:get_escaped_item_list()[i].chance)
		print("escaped_action_config:get_escaped_item_list()[].buy = ",escaped_action_config:get_escaped_item_list()[i].buy)
		
		for j=1, #escaped_action_config:get_escaped_item_list()[i]:get_shared_request() do
			print("escaped_action_config:get_escaped_item_list()[i]:get_shared_request()[j] = ", escaped_action_config:get_escaped_item_list()[i]:get_shared_request()[j])
		end
		
		if (escaped_action_config:get_escaped_item_list()[i].reward ~= "") then
			print("escaped_action_config:get_escaped_item_list()[].reward = ",escaped_action_config:get_escaped_item_list()[i].reward)
			
--			local info_provider = framework:object_factory()
			local object_info = info_provider:get_object_info_by_type_name(escaped_action_config:get_escaped_item_list()[i].reward)
			
			print("object_info.shop_image_path = ",object_info.shop_image_path)
			print("object_info.description = ", object_info.description)
			print("object_info.max_population_increase = ", object_info.max_population_increase)
			print("object_info.extra_coins = ", object_info.extra_coins)
			
			num_rewards = num_rewards + 1
			
			if num_rewards <= 2 then
				rewards_position[num_rewards] = i
			end
		end
	end
	

	print("action_info.name = ", action_info.name)
	
	local action_list = framework.extern_action:get_active_action(game.native.room_id)
	for i = 1,  #action_list do
		print("action_list[].name = ", action_list[i].name)
		print("action_list[].duration = ", action_list[i]:get_duration())
		
		if (action_info.name == action_list[i].name) then
			action_end_date = action_list[i]:get_duration()
			action_end_date = action_end_date/1000
			print("action_end_date = ", action_end_date)
		end
	end
	

	print("num_rewards = ", num_rewards)

	for i = 1,num_rewards do
		local object_info = info_provider:get_object_info_by_type_name(escaped_action_config:get_escaped_item_list()[rewards_position[i]].reward)
		
		print("rewards[",i,"] pos = ",rewards_position[i], "image = ",  object_info.shop_image_path)
	end
	
	print("action_info.index_found = ", action_info.index_found)

	print("num_action_escaped = ", num_action_escaped)
	

	dialog.caption = framework:get_client_string(escaped_action_config.action_type)
	
	local descr_label = dialog:find_child('descr_label', true, false)
	if descr_label then
		print("found descr_label")
		descr_label.caption = framework:get_client_string(escaped_action_config.action_type .. "_mobile_window_text_description") -- описание в желтой плашке 
--		descr_label.text_adjust_font_size = true
	end
	--level box
	local left_box = dialog:find_child('left_box', true, false)
	if left_box then
	
		local found_label = left_box:find_child('found_label', true, false)
		if found_label then

			local alredy_found_items = framework:get_client_string(escaped_action_config.action_type .. "_mobile_window_text_found_items")
			if alredy_found_items then
				alredy_found_items = string.format(alredy_found_items, tostring(action_info.index_found))
				print("alredy_found_items = ", alredy_found_items)
				found_label.caption = alredy_found_items
			else
				print("alredy_found_items not found")
				found_label.caption = "Found items: " .. tostring(action_info.index_found)
			end
			
		end
		
		local buy_found_label = left_box:find_child('buy_found_label', true, false)
		if buy_found_label then
			
			print("left_box: action_info.index_found = ", action_info.index_found, " #escaped_action_config:get_escaped_item_list() = ", #escaped_action_config:get_escaped_item_list())
			if action_info.index_found < #escaped_action_config:get_escaped_item_list() then
				buy_found_label.caption = framework:get_client_string(escaped_action_config.action_type .. "_mobile_window_text_find_now")
				buy_found_label.text_adjust_font_size = true
	
				local gold = framework:game().gold
						
				local buy_found_button = left_box:find_child('buy_found_button', true, false)	
				if buy_found_button then
				
					print("gold = ", gold, "action_info.index_found+1 = ", action_info.index_found+1, "next cost robot's = ", escaped_action_config:get_escaped_item_list()[action_info.index_found+1].buy)
				
					if (gold < escaped_action_config:get_escaped_item_list()[action_info.index_found+1].buy) then
						buy_found_button.active = false
					else
						buy_found_button.active = true
					end
				
				
					local label = buy_found_button:find_child('label', true, false)
					if label then
						local find_now_for = framework:get_client_string(escaped_action_config.action_type .. "_mobile_window_text_find_now_for")
						find_now_for = string.format(find_now_for, tostring(escaped_action_config:get_escaped_item_list()[action_info.index_found+1].buy))
						label.caption = find_now_for
					end
				end
			end		
		end
		
	end
	
	
	local reward_counter = 1	
	
	
	--center_box
	if num_rewards == 1 then
	
		dialog.theme_flags = 2
	
		rect = get_rect_widget("center_box")
		local info_cell = dialog:create_child(rect)
		framework:json_ui_manager():build_from_resource("city_escaped_info_cell",info_cell)
		info_cell.rect = rect
		
		local info = info_cell:find_child("info", true, false)

		if info then
			info.caption = framework:get_client_string(escaped_action_config.action_type .. "_mobile_window_text_instructions")
			info.text_adjust_font_size = true
		end
		
		if num_action_escaped == 1 then
		
			local center_house = info_cell:find_child("center_house", true, false)
			if center_house then							
				center_house.texture_name = get_texture_name(escaped_action_config.action_type .. "_escaped_action_1"); --инфо центральное изображение
				center_house:set_ready_progress_as_indicator()
			end
			
			show_widget("center_house_border", info_cell)
			
		elseif num_action_escaped == 2 then
		
			local left_house = info_cell:find_child("left_house", true, false)
			if left_house then
				left_house.texture_name = get_texture_name(escaped_action_config.action_type .. "_escaped_action_1"); --инфо центральное изображение
				left_house:set_ready_progress_as_indicator()
				
			end
						
			local right_house = info_cell:find_child("right_house", true, false)
			if right_house then
				right_house.texture_name = get_texture_name(escaped_action_config.action_type .. "_escaped_action_2"); --инфо центральное изображение
				right_house:set_ready_progress_as_indicator()
				
			end
			
			show_widget("left_house_border", info_cell)
			show_widget("right_house_border", info_cell)
			
		end

	elseif num_rewards == 2 then
	
		dialog.theme_flags = 34
		
		local reward_bg_image;
		
		local city_escaped_reward_cell = dialog:find_child("city_escaped_reward_cell_left", true, false)
		if city_escaped_reward_cell then
			reward_bg_image = city_escaped_reward_cell:find_child("bg_image", true, false)
		else
			rect = get_rect_widget("center_box")
			left_reward_cell = dialog:create_child(rect)
			framework:json_ui_manager():build_from_resource("city_escaped_reward_cell",left_reward_cell)
			left_reward_cell.rect = rect	
			
			left_reward_cell.tag = left_reward_cell.tag .. "_left"

			reward_bg_image = left_reward_cell:find_child("bg_image", true, false)
			
			local arrow =  left_reward_cell:find_child("arrow", true, false)
			if arrow then
				rect = arrow.rect
				rect[1] = rect[1]-25
				arrow.rect = rect
			end
		end
				
		if reward_bg_image then
			local object_info = info_provider:get_object_info_by_type_name(escaped_action_config:get_escaped_item_list()[rewards_position[reward_counter]].reward)
			set_up_reward(reward_bg_image, rewards_position[reward_counter], action_info.index_found, object_info)
			reward_counter = reward_counter + 1
		end
		
	end
	
	
--	if 2 reward start --------------------------------------------------------------------
--	set_proxy_texture_widget('left_reward', 'search_from_1_revard_item_grey_ipad')	
--	set_image_widget('left_arrow_reward', 'search_from_1_revard_item_arrow_ipad')	
--	if 2 reward end   --------------------------------------------------------------------


--	if 1 reward start --------------------------------------------------------------------
--	set_proxy_texture_widget('left_house', 'search_from_1_revard_item_grey_ipad')
--	set_proxy_texture_widget('right_house', 'search_from_1_revard_item_grey_ipad')
--	if 1 reward end --------------------------------------------------------------------

--	set_proxy_texture_widget('right_reward', 'search_from_1_revard_item_grey_ipad')
--	set_image_widget('right_arrow_reward', 'search_from_1_revard_item_arrow_ipad')
		
	--right_box
	local reward_bg_image;
	local city_escaped_reward_cell = dialog:find_child("city_escaped_reward_cell_right", true, false)
	if city_escaped_reward_cell then
		reward_bg_image = city_escaped_reward_cell:find_child("bg_image", true, false)
	else
		rect = get_rect_widget("right_box")
		local right_reward_cell = dialog:create_child(rect)	
		framework:json_ui_manager():build_from_resource("city_escaped_reward_cell",right_reward_cell)
		right_reward_cell.rect = rect
		
		right_reward_cell.tag = right_reward_cell.tag .. "_right"
		
		reward_bg_image = right_reward_cell:find_child("bg_image", true, false)
	end	
	
	if reward_bg_image then
		local object_info = info_provider:get_object_info_by_type_name(escaped_action_config:get_escaped_item_list()[rewards_position[reward_counter]].reward)
		set_up_reward(reward_bg_image, rewards_position[reward_counter], action_info.index_found, object_info)
	end
	
	
	
	local date_time_label = dialog:find_child('date_time', true, false)
	if date_time_label then
		date_time_label.time = action_end_date
	end

	local spinboard = dialog:find_child("spinboard",true, false)
	if spinboard then
        spinboard:update_content()
	end

	local start_button = dialog:find_child("start_button", true, false)
	if start_button then
		local label = start_button:find_child("label", true, false)
		if label then		
			label.caption = framework:get_client_string(escaped_action_config.action_type .. "_mobile_window_text_begin_search") -- label на кнопке Начать поиск
		end
	end



	local new_city_balance_widget = dialog:find_child("city_balance_widget", true, false)
	if(new_city_balance_widget) then
		new_city_balance_widget:set_set_balance_widget(1, false)
		new_city_balance_widget:layout_controls()
		
	end
	
	print("end init dlg")
end

function balance_label(balance)
	
	local label
	
	if (balance > 100) then
		label = string.format("%.1f", balance)
	elseif (balance > 10) then
		label = string.format("%.2f", balance)
	else
		label = string.format("%.3f", balance)
	end
	
	return label
end


function on_init_dialog()

	dialog:load_content('city_escaped_dlg')
	dialog.center_dialog = true

	update_dlg()
	
end

function adjust_title_dialg()

	local dialog_title_caption = dialog:find_child('dialog_title_caption', true, false)
	if dialog_title_caption then
		print("dialog_title_caption found")

		local caption_rect = dialog_title_caption.rect 
		print("caption_rect", caption_rect[1], caption_rect[2], caption_rect[3], caption_rect[4])
		
		if g_device.is_tablet then
--			if caption_rect[3] > 415 then
				caption_rect[1] = 74
				caption_rect[3] = 410
				dialog_title_caption.rect = caption_rect
				dialog_title_caption.text_adjust_font_size = true
--			end
		elseif g_device.is_phone then
--			if caption_rect[3] > 260 then
				caption_rect[1] = 53
				caption_rect[3] = 260
				dialog_title_caption.rect = caption_rect
				dialog_title_caption.text_adjust_font_size = true
--			end
		end
	end
	
	
	local dialog_title_bevel = dialog:find_child('dialog_title_bevel', true, false)
	if dialog_title_bevel then
		print("dialog_title_bevel found")
		
		local title_bevel_rect = dialog_title_bevel.rect 
		print("title_bevel_rect", title_bevel_rect[1], title_bevel_rect[2], title_bevel_rect[3], title_bevel_rect[4])
		
		if g_device.is_tablet then
--			if title_bevel_rect[3] > 415 then	
				title_bevel_rect[1] = 69
				title_bevel_rect[3] = 420
				dialog_title_bevel.rect = title_bevel_rect
--			end
		elseif g_device.is_phone then
--			if title_bevel_rect[3] > 260 then
				title_bevel_rect[1] = 50
				title_bevel_rect[3] = 267
				dialog_title_bevel.rect = title_bevel_rect
--			end
		end
	end
	
end

function on_post_init_dialog()
	local info_button = dialog:find_child('info_button', true, false)
	if info_button then
		info_button.action = on_info_button_action
	end	
	
	adjust_title_dialg()
end

spinboard_delegate = {
	create_cell = function (  self, idx, rect )
		local w = self.spinboard:create_child(rect)
		
		print("create_cell")
        local loc_idx = idx+1
                
        framework:json_ui_manager():build_from_resource("city_escaped_spinboard_cell",w)
        w.rect = rect
        
        
        local action_info = framework:game():get_escaped_action()
		local escaped_action_config = action_info.cfg_action_config

        local item_image = escaped_action_config.action_type .. "_escaped_item_" .. loc_idx 
        print("item_image = ", item_image)
        
        local cell_bg = w:find_child('cell_bg',true,false)
        if cell_bg then
        	if loc_idx <= action_info.index_found then
				cell_bg.image_name = get_texture_name('search_from_1_revard_ifream_not_found')
				
        		local grayscaled = cell_bg:find_child("grayscaled", true, false)
				if grayscaled then
					grayscaled.visible = false
				end
        	
				local escaped_item = cell_bg:find_child("escaped_item", true, false)
				if escaped_item then
					escaped_item.visible = true
					escaped_item.texture_name = get_texture_name(item_image) -- изображение item-а
					escaped_item:set_ready_progress_as_indicator()
				end				
				
			else 
				cell_bg.image_name = get_texture_name('search_from_1_revard_ifream_found')
        	
        		local grayscaled = cell_bg:find_child("grayscaled", true, false)
				if grayscaled then
					print("grayscaled found");
					grayscaled.visible = true
					
					local grayscaled_escaped_item = grayscaled:find_child("grayscaled_escaped_item", true, false)
					if grayscaled_escaped_item then
						grayscaled_escaped_item.texture_name = get_texture_name(item_image) -- изображение item-а
						grayscaled_escaped_item:set_ready_progress_as_indicator()
					end
				end
		
				local escaped_item = w:find_child("escaped_item", true, false)
				if escaped_item then
					escaped_item.visible = false
				end
        	
			end
        end
		        
        return w
	end,
	
	get_cell_count = function ( )
		local action_info = framework:game():get_escaped_action()
		local escaped_action_config = action_info.cfg_action_config
		
		return #escaped_action_config:get_escaped_item_list()
    end
}

function on_info_button_action()
	local info_dlg = cclasses.sqc_scriptable_dialog.create(framework:windows().desktop,"escaped_info.lua")
	if ( info_dlg ) then
	
		local action_info = framework:game():get_escaped_action()
		local escaped_action_config = action_info.cfg_action_config
			
		local info_provider = framework:object_factory()			
		num_action_escaped = info_provider:get_num_escaped_in_custom_actions()

		info_dlg.scripting_object.num_action_escaped = info_provider:get_num_escaped_in_custom_actions()
		info_dlg.scripting_object.left_action_image = escaped_action_config.action_type .. "_escaped_action_1"
		info_dlg.scripting_object.right_action_image = escaped_action_config.action_type .. "_escaped_action_2"
		info_dlg.scripting_object.center_action_image = ""
		
		info_dlg:do_modal()
	end
end


function on_buy_found_button_action_pressed()
	print("on_buy_found_button_action_pressed")

	local cmd_name = "sqc_buy_robot_command"
	local cmd_meta = cclasses[cmd_name]
	if not cmd_meta then
		error('not found command class ' .. cmd_name)
	end
	
	local action_info = framework:game():get_escaped_action()
	local escaped_action_config = action_info.cfg_action_config
	
	print("command buy_items, room_id = ", game.native.room_id, "action_info.index_found = ", action_info.index_found)
	local cmd = cmd_meta.new( game.native.room_id, action_info.index_found)
	
	local callbacks = {}
	
	callbacks["success"] = 	function()
								print("command complete sucess")
							
								local action_info = framework:game():get_escaped_action()
								local escaped_action_config = action_info.cfg_action_config
	
								print("command complete sucess action_info.index_found = ", action_info.index_found)
							
								if (escaped_action_config:get_escaped_item_list()[action_info.index_found].reward ~= "") then
									escapd_found_dlg = cclasses.sqc_scriptable_dialog.create(framework:windows().desktop,"escaped_found_reward.lua")
								else
									escapd_found_dlg = cclasses.sqc_scriptable_dialog.create(framework:windows().desktop,"escaped_found.lua")
								end
								
								if ( escapd_found_dlg ) then
									update_callback =  	function()
															print("update main window")
															update_glg()
														end
									
									escapd_found_dlg.scripting_object.update_callback = update_callback
									
									escapd_found_dlg:do_modal()
								end	
						 	end

	callbacks["error"] = 	function()
								print("command complete error")
						 	end
			
	print("game.native.room_id = ", game.native.room_id)
	
						 	
	run_buy_escaped_item_command( cmd, callbacks)
end


function on_buy_found_button_action()
	print("on_buy_found_button_action")
	
	if framework:settings_controller().gold_warning_enabled then
        
        local action_info = framework:game():get_escaped_action()
        local escaped_action_config = action_info.cfg_action_config
        
        local params = { }
        params.product = framework:get_client_string(escaped_action_config.action_type .. "_mobile_window_text_find_now")
        params.price = tostring(escaped_action_config:get_escaped_item_list()[action_info.index_found+1].buy)
        params.ok_callback = function() on_buy_found_button_action_pressed() end
        params.no_callback = function() end
        
        framework:dialogs():show_buy_for_megabucks_dialog(params)
    else
        on_buy_found_button_action_pressed()
    end
end

function on_buy_found_button_unactive_action()
	print("on_buy_found_button_unactive_action")
	
	framework:dialogs():show_show_not_enough_bucks_dialog(3)
end

function run_buy_escaped_item_command( cmd, callbacks )
	print("run_market_command")		
	local cb = callbacks or {}
	if cb.success then 
		cmd:append_complete_callback(cb.success)
	end
	if cb.error then 
		cmd:append_error_callback(cb.error)
	end
	
	--game.native.market:prepare_market_command( cmd )
	framework:cmd_processor():schedule(cmd,0) -- command_priority_now
end 

function on_start_button_action()
	print("start_button")
	
	local num_action_escaped = framework:object_factory():get_type_escaped_in_custom_actions()
	
	local succcess_show_object = false
	local i = 1		
	while (i <= #num_action_escaped and succcess_show_object == false) do
		if num_action_escaped[i] == "clean:leisure_base" then
			succcess_show_object = framework:dialogs():goto_object_status_tax()
		end

		if num_action_escaped[i] == "pick:house_base" then
			succcess_show_object = framework:dialogs():goto_object_status_population()
		end
		
		i = i + 1
	end	
	
	dialog:end_dialog()
end

function on_buy_bucks_button_action()
	print("on_buy_bucks_button_action")

	framework:dialogs():show_add_bucks_dialog()

end

function update_glg()

	update_dlg()
	adjust_title_dialg()
	
	local spinboard = dialog:find_child('spinboard', true, false)
	if spinboard then
		print("spinboard found")
	
		spinboard:update_content()
	end
	          	
	local action_info = framework:game():get_escaped_action()
	local escaped_action_config = action_info.cfg_action_config
			
	if ( action_info.index_found >= #escaped_action_config:get_escaped_item_list() ) then
		dialog:end_dialog()
	end
end