function get_rect_widget(widget)
	local rect = {0, 0, 0, 0}
	local widget_dlg = dialog:find_child(widget, true, false)
	if widget_dlg then
		rect = widget_dlg.rect
	end
	return rect
end

function hide_widget(widget_name, parent_widget)
	local widget = parent_widget:find_child(widget_name, true, false)
	if widget then
		widget.visible = false
	end
end

function get_texture_name(texture)
	local texture_by_device = texture
	if g_device.is_tablet then
		texture_by_device = texture_by_device .. "_ipad"
		print(texture_by_device)
	end
	return texture_by_device
end

function label_replace_tag(widget_name, widget_suffix, value)
	local widget = dialog:find_child(widget_name, true, false)
	
	local action_info = framework:game():get_escaped_action()
	local escaped_action_config = action_info.cfg_action_config 
	
	if widget then
	    print("found " .. widget_name)
		print("widget.tag == " .. widget.tag)
		local action_name =escaped_action_config.action_type
		print("action name == " .. action_name)
		
		local str_id = action_name  .. "_" .. widget.tag .. widget_suffix
		print("str_id == " .. str_id)
		
		local c = framework:get_client_string(str_id)
		print("c == " .. c)
		
		if c == "" then
			print("c is empty use default value without sufix")
			str_id = action_name  .. "_" .. widget.tag
			print("str_id == " .. str_id)
			c = framework:get_client_string(str_id)
			print("c == " .. c)
		end
		
		if value ~= "" then
			c = string.format(c, value)
		end
		widget.caption = c
    else
        print("not found " .. widget_name)
    end
           
end

function get_dialog_init_arg()
    local params = {}
    params.right_button = 1  -- milk_dialog_button_type_close;
    return params
end

function on_init_dialog()
	
	dialog.theme_flags = 0
	dialog:load_content('city_escaped_found_dlg')
	dialog.center_dialog = true
	
    label_replace_tag("mobile_found_post_title","", "")
    
	local action_info = framework:game():get_escaped_action()
	local escaped_action_config = action_info.cfg_action_config 
	
	local names = framework:get_client_string(escaped_action_config.action_type .. "_names")
	
	n,m = 0
	i = 0
	r = 0
	name_map = {""}
	while n do
		   i=i+1
		   m=n
		   n=string.find(names,"\n",n+1)
		   if n then 
				   r=n-1 
				   m=m+1 
		   else
				   m = r+2
				   r = string.len(names)                   
		   end
		   
		   name = string.sub(names,m,r)
		   name_map[i] = name
	end
	
	label_replace_tag("mobile_found_post_congrat", "_with_name", name_map[action_info.index_found])

	local action_info = framework:game():get_escaped_action()
	local escaped_action_config = action_info.cfg_action_config

	local info_provider = framework:object_factory()
	local num_action_escaped = info_provider:get_num_escaped_in_custom_actions()
	
	
	local robots_count = #escaped_action_config:get_escaped_item_list()
	local robot_index = action_info.index_found
    local left = robots_count - action_info.index_found
    
-- --[[
print("robots_count == %d", robots_count)
print("robot_index == %d", robot_index)
print("left == %d", left)
-- ]]--
    label_replace_tag("mobile_found_post_left", "", tostring(left))

	
	local found_bg = dialog:find_child("found_bg", true, false)
	if found_bg then
		local found_image = found_bg:find_child("found_image", true, false)
		
		if found_image then
			local item_image = escaped_action_config.action_type .. "_escaped_item_" .. robot_index
			print("item_image = ", item_image)
			found_image.texture_name = get_texture_name(item_image);
			found_image:set_ready_progress_as_indicator()
		end
	end

 
 	
 
 	local take_button = dialog:find_child("take_button", true, false)
	if take_button then
		local label = take_button:find_child("label", true, false)
		if label then
			label.caption = framework:get_client_string(escaped_action_config.action_type .. "_mobile_window_text_found_send_friends") 
		end
	end
 
end

function on_close_button_pressed()
	print("on_close_button_action")
	if update_callback then
		update_callback()
	end
	dialog:end_dialog()
end

function on_take_button_action()
	print("on_take_button_action")
	
	local sqc_request_args = {}
	local action_info = framework:game():get_escaped_action()
	local escaped_action_config = action_info.cfg_action_config
	
	for i=1, #escaped_action_config:get_escaped_item_list()[action_info.index_found]:get_shared_request() do
		print("escaped_action_config:get_escaped_item_list()[action_info.index_found]:get_shared_request()[i] = ", escaped_action_config:get_escaped_item_list()[action_info.index_found]:get_shared_request()[i])
		
		send_request(escaped_action_config:get_escaped_item_list()[action_info.index_found]:get_shared_request()[i])
	end	
	
	if update_callback then
		update_callback()
	end
    dialog:end_dialog()
end

function send_request(request_name)
	local sqc_request_args = {}
	print("request_name = ", request_name)
			
	local request = framework.requests_processor:create_request(request_name,sqc_request_args);
	if (request) then
		framework:send_request(request)
	else
		print("request nil")
	end
end

