function get_rect_widget(widget)
	local rect = {0, 0, 0, 0}
	local widget_dlg = dialog:find_child(widget, true, false)
	if widget_dlg then
		rect = widget_dlg.rect
	end
	return rect
end

function hide_widget(widget_name, parent_widget)
	local widget = parent_widget:find_child(widget_name, true, false)
	if widget then
		widget.visible = false
	end
end

function get_texture_name(texture)
	local texture_by_device = texture
	if g_device.is_tablet then
		texture_by_device = texture_by_device .. "_ipad"
		print(texture_by_device)
	end
	return texture_by_device
end

function vstretch(widget, prent_widget, hight)
	local rect = {0, 0, 0, 0}
	local stretch_widget = prent_widget:find_child(widget, true, false)
	if stretch_widget then
		rect = stretch_widget.rect
		rect[4] = rect[4]+hight
		stretch_widget.rect = rect
	end	
end

function vmove(widget, prent_widget, hight)
	local rect = {0, 0, 0, 0}
	local move_widget = prent_widget:find_child(widget, true, false)
	if move_widget then
	
		rect = move_widget.rect
		
		print("vmove, move_widget, rect = ", rect[1], rect[2], rect[3], rect[4])
		
		rect[2] = rect[2]+hight
		move_widget.rect = rect
		
		print("vmove, move_widget, rect = ", rect[1], rect[2], rect[3], rect[4])
	end	
end


function get_dialog_init_arg()
    local params = {}
    params.right_button = 1  -- milk_dialog_button_type_close;
    return params
end

function on_init_dialog()
	
	dialog.theme_flags = 0
	dialog:load_content('city_escaped_found_reward_dlg')
	dialog.center_dialog = true
	
	local action_info = framework:game():get_escaped_action()
	local escaped_action_config = action_info.cfg_action_config
	
	local dialog_label = dialog:find_child("dialog_label", true, false)
	if dialog_label then
		dialog_label.caption = framework:get_client_string(escaped_action_config.action_type)	-- заголовок диалога
	end
	
	
	local info_provider = framework:object_factory()
	
	local index_found = action_info.index_found

	print("index_found = ", index_found)
	
	
	--escaped_data_items = escaped_data:get_escaped_data_items()
--	search_items = escaped_data.index_search
--	search_items = search_items + 1
		
	local object_info = info_provider:get_object_info_by_type_name(escaped_action_config:get_escaped_item_list()[index_found].reward)
		
	local descr_label = dialog:find_child("descr_label", true, false)
	if descr_label then
			
		local names = framework:get_client_string(escaped_action_config.action_type .. "_names")
		n,m=0
		i=0
		name_map = {""}
		while n do
			   i=i+1
			   m=n
			   n=string.find(names,"\n",n+1)
			   if n then 
					   r=n-1 
					   m=m+1 
			   else
					   m = r+2
					   r = string.len(names)
			   end
			   
			   name = string.sub(names,m,r)
			   name_map[i] = name
		end
		
		
		local description_resources = framework:get_client_string(escaped_action_config.action_type .. "_mobile_window_text_found_with_reward_with_name")	--описанине
		local description_with_name_item = true;
		
		if description_resources == "" then
			description_resources = framework:get_client_string(escaped_action_config.action_type .. "_mobile_window_text_found_with_reward")
			description_with_name_item = false
		end
		
		local description = ""
		if description_with_name_item == true then
			description = string.format(description_resources, name_map[action_info.index_found], object_info.description)
		else
			description = string.format(description_resources, object_info.description)
		end
				
		descr_label.caption = description
	end
	
	
	local found_bg = dialog:find_child("found_bg", true, false)
	if found_bg then
		found_bg.image_name = get_texture_name("found_ifream")
		
		local found_image = found_bg:find_child("found_image", true, false);
		if found_image then
		
			local item_image = escaped_action_config.action_type .. "_escaped_item_" .. index_found
		
			found_image.texture_name = get_texture_name(item_image) 	--изображение наденного item-а
			found_image:set_ready_progress_as_indicator()
		end
		
		local found_label = found_bg:find_child("found_label", true, false);
		if found_label then
			local num_need_found = #escaped_action_config:get_escaped_item_list() - index_found
			if (num_need_found > 0) then
				found_post_left = framework:get_client_string(escaped_action_config.action_type .. "_mobile_found_post_left")
				print("found_post_left = ",found_post_left)
				found_post_left = string.format(found_post_left, tostring(num_need_found))
				found_label.caption = found_post_left
			else
				found_label.caption = ""
			end
			
		end
	end
	

--	local reward
--	if escaped_data_items[search_items].data_reward then
--		reward = escaped_data_items[search_items].data_reward
--	end
	
	local rect = {0,0,0,0}
	rect = get_rect_widget("reward")
	print("reward rect = ", rect[1], rect[2], rect[3], rect[4])
	local reward_cell = dialog:create_child(rect)
	framework:json_ui_manager():build_from_resource("city_escaped_reward_cell",reward_cell)
	reward_cell.rect = rect
	
	reward_bg_image = reward_cell:find_child("bg_image", true, false)
	if reward_bg_image then
		print("reward_bg_image found")
		
		reward_bg_image.image_name = get_texture_name('found+revard_ifream')
		
--		local reward_label = reward_bg_image:find_child("reward", true, false)
--		if reward_label then
--			reward_label = framework:get_client_string(escaped_action_config.action_type .. "_mobile_window_text_reward")
--		end

		local reward_label = reward_bg_image:find_child("reward", true, false)
		if reward_label then
--			reward_label.caption = framework:strings():load("*CityEscapedActionGetTitle", "GET")
			reward_label = framework:get_client_string(escaped_action_config.action_type .. "_mobile_window_text_reward")
			
			if g_device.is_tablet then	
				vmove("reward", reward_bg_image, -4)
			elseif g_device.is_phone then
				vmove("reward", reward_bg_image, -2)
			end
		end

		
		local get_label = reward_bg_image:find_child("get_label", true, false)
		if get_label then
			get_label.caption = framework:get_client_string(escaped_action_config.action_type .. "_mobile_window_text_get_reward") -- надпись получена
		end
		
--		if escaped_data_items[search_items].data_reward then
		if (escaped_action_config:get_escaped_item_list()[index_found].reward ~= "") then
		
			local reward_name = reward_bg_image:find_child("name", true, false)
			if reward_name then
				reward_name.caption =  object_info.description --escaped_data_items[search_items].data_reward.description -- название реварда
			end
			
			
			local quantity_population = 0;
			if object_info.max_population_increase ~= 0 then
			 	quantity_population = object_info.max_population_increase  	-- население в реварде
			elseif object_info.population_increase ~= 0 then
				quantity_population = object_info.population_increase 	-- население в реварде
			end
			
			local top_population = reward_bg_image:find_child("top_population_box", true, false)
			if top_population then
				local population = top_population:find_child("population_label", true, false)
				if population and quantity_population ~= 0 then
					population.caption = "+" .. tostring(quantity_population) -- tostring(escaped_data_items[search_items].data_reward.population) 	-- население в реварде
					population.text_adjust_font_size = true
				else
					hide_widget("top_population_box", reward_bg_image)
				end
			end			
			hide_widget("population_box", reward_bg_image)
			
			
			local top_coins = reward_bg_image:find_child("top_coins_box", true, false)
			if top_coins then
				local coins = top_coins:find_child("coins_label", true, false)
				if coins and object_info.extra_coins ~= 0 then
					coins.caption = "+" .. tostring(object_info.extra_coins) -- tostring(escaped_data_items[search_items].data_reward.coins) -- монеты в реварде
					coins.text_adjust_font_size = true
				else
					hide_widget("top_coins_box", reward_bg_image)
				end
			end
			hide_widget("coins_box", reward_bg_image)
						
			hide_widget("get_label", reward_bg_image)	-- скрываем виджеты 
			hide_widget("check", reward_bg_image)
			
			local reward_image = reward_bg_image:find_child("reward_image", true, false)
			if reward_image then
--				reward_image.image_name = get_texture_name(escaped_data_items[search_items].data_reward.image) -- изображение реварда
				
				print("shop_image_path = ", object_info.shop_image_path)
				
				reward_image.texture_name = object_info.shop_image_path -- изображение реварда
				reward_image:set_ready_progress_as_indicator()


			end
			
		end		
	end
	
	hide_widget("arrow", reward_cell)

	if g_device.is_tablet then	
--		hide_widget("population_image", reward_cell)
--		hide_widget("coins_image", reward_cell)
	elseif g_device.is_phone then
--		hide_widget("check", reward_cell)
--		hide_widget("get_label", reward_cell)
				
		vstretch("bg_image", reward_cell, 35)
		vmove("reward",reward_cell, 35)
		vmove("name",reward_cell, 32)
--		vmove("top_population_box",reward_cell, 30)
--		vmove("top_coins_box",reward_cell, 30)
		vmove("reward_image", reward_cell, 5)
	end
	

	local take_button = dialog:find_child("take_button", true, false)
	if take_button then
		local label = take_button:find_child("label", true, false)
		if label then
			label.caption = framework:get_client_string(escaped_action_config.action_type .. "_mobile_window_text_found_with_reward_send_friends")
		end
	end
end


function show_barn_animation()
    local action_info = framework:game():get_escaped_action()
	local escaped_action_config = action_info.cfg_action_config

    local reward_image = reward_bg_image:find_child("reward_image", true, false)
	if reward_image then
       screen_rect=reward_image.screen_rect

       local object_info = framework:object_factory():get_object_info_by_type_name(escaped_action_config:get_escaped_item_list()[action_info.index_found].reward)
	   if object_info then
	       framework:dialogs():show_goto_storage_dialog(object_info.type_id,screen_rect)
	   end
	end
end

function on_close_button_pressed()
	--local action_info = framework:game():get_escaped_action()
	--local escaped_action_config = action_info.cfg_action_config
	
	--local object_info = framework:object_factory():get_object_info_by_type_name(escaped_action_config:get_escaped_item_list()[action_info.index_found].reward)
	--framework:dialogs():show_goto_storage_dialog(object_info.type_id)

	show_barn_animation()
	
	if update_callback then
		update_callback()
	end
	dialog:end_dialog()
end


function on_take_button_action()
	local action_info = framework:game():get_escaped_action()
	local escaped_action_config = action_info.cfg_action_config

	for i=1, #escaped_action_config:get_escaped_item_list()[action_info.index_found]:get_shared_request() do
		send_request(escaped_action_config:get_escaped_item_list()[action_info.index_found]:get_shared_request()[i])
	end	
	

	show_barn_animation()
	--local object_info = framework:object_factory():get_object_info_by_type_name(escaped_action_config:get_escaped_item_list()[action_info.index_found].reward)
	--framework:dialogs():show_goto_storage_dialog(object_info.type_id)
	
	if update_callback then
		update_callback()
	end
	dialog:end_dialog()
end

function send_request(request_name)
	local sqc_request_args = {}
				
	local request = framework.requests_processor:create_request(request_name,sqc_request_args);
	if (request) then
		framework:send_request(request)
	end
end

