function hide_widget(widget_name, parent_widget)
	local widget = parent_widget:find_child(widget_name, true, false)
	if widget then
		widget.visible = false
	end
end

function show_widget(widget_name, parent_widget)
	local widget = parent_widget:find_child(widget_name, true, false)
	if widget then
		widget.visible = true
	end
end

function get_rect_widget(widget)
	local rect = {0, 0, 0, 0}
	local widget_dlg = dialog:find_child(widget, true, false)
	if widget_dlg then
		rect = widget_dlg.rect
	end
	return rect
end

function get_texture_name(texture)
	local texture_by_device = texture
	if g_device.is_tablet then
		texture_by_device = texture_by_device .. "_ipad"
		print(texture_by_device)
	end
	return texture_by_device
end

function on_init_dialog()

	print("on_init_dialog start")
	
	local action_info = framework:game():get_escaped_action()
	local escaped_action_config = action_info.cfg_action_config
	
	dialog.theme_flags = 0
	dialog:load_content('city_escaped_info_dlg')
	dialog.center_dialog = true

	if g_device.is_tablet then
		local rect = {0, 0, 0, 0}
		rect = get_rect_widget("info_box")
		print("rect = ", rect[1],rect[2],rect[3],rect[4])
		local info_cell = dialog:create_child(rect)
		framework:json_ui_manager():build_from_resource("city_escaped_info_cell",info_cell)
		info_cell.rect = rect
		
		info_label =  info_cell:find_child("name", true, false)
		if info_label then
			rect = info_label.rect		
			rect[2] = rect[2]+20
			rect[3] = rect[3]+20
			info_label.rect = rect
		end
	end
		
	local dialog_label = dialog:find_child("dialog_label", true, false)
	if dialog_label then
		dialog_label.caption = framework:get_client_string(escaped_action_config.action_type) --название инфо диалога 
		dialog_label.text_adjust_font_size = true
	end
	
		
	local info = dialog:find_child("info", true, false)
	if info then
		info.caption = framework:get_client_string(escaped_action_config.action_type .. "_mobile_window_text_instructions")
		info.text_adjust_font_size = true
	end
	
	if num_action_escaped == 1 then
		
		local center_house = dialog:find_child("center_house", true, false)
		if center_house then
			print("center_house")
			center_house.texture_name = get_texture_name(center_action_image);	--инфо центральное изображение			
			center_house:set_ready_progress_as_indicator()
		end
		
	elseif num_action_escaped == 2 then
		print("escaped_data.num_action_escaped == 2")
		local left_house = dialog:find_child("left_house", true, false)
		if left_house then
			left_house.texture_name = get_texture_name(left_action_image)	--инфо левое изображение
			left_house:set_ready_progress_as_indicator()	
		end
					
		local right_house = dialog:find_child("right_house", true, false)
		if right_house then 
			right_house.texture_name = get_texture_name(right_action_image)	--инфо правое изображение
			right_house:set_ready_progress_as_indicator()		
		end
		
		show_widget("left_house_border", dialog)
		show_widget("right_house_border", dialog)
	end

	local find_button = dialog:find_child("find_button", true, false)
	if find_button then
		local label = find_button:find_child("label", true, false)
		if label then
			label.caption = framework:get_client_string(escaped_action_config.action_type .. "_mobile_window_text_find")-- label на кнопке Поиск
		end
	end

	print("on_init_dialog end")
end


function on_close_button_action()
	print("on_close_button_action")
	dialog:end_dialog()
end

function on_find_button_action()
	dialog:end_dialog()
end