function get_texture_name(texture)
	local texture_by_device = texture
	if g_device.is_tablet then
		texture_by_device = texture_by_device .. "_ipad"
	end
	return texture_by_device
end

function on_init_dialog()
	dialog.theme_flags = 0
	dialog:load_content('gambling_exchange_complete_dlg')
	dialog.center_dialog = true
	
	local fream_aler = dialog:find_child("fream_aler", true, false)
	if fream_aler then							
		fream_aler.image_name = get_texture_name("fream_aler");
		
		local material_name = fream_aler:find_child("material_name", true, false)
		if material_name then
			material_name.texture_name = exchange_item.material_name;
		end
		
		
		local chip_name = fream_aler:find_child("chip_name", true, false)
		if chip_name then
			chip_name.texture_name = get_texture_name(exchange_item.chip_name .. "_exchange")
		end
		
		local exchange_arrow = fream_aler:find_child("exchange_arrow", true, false)
		if exchange_arrow then
			exchange_arrow.image_name = get_texture_name("arrow_green");
		end
		
		local material_quantity = fream_aler:find_child('material_quantity', true, false)
		if material_quantity then
			material_quantity.caption = "x" .. exchange_item.material_quantity
			material_quantity.text_adjust_font_size = true
		end
		
		local chip_quantity = fream_aler:find_child('chip_quantity', true, false)
		if chip_quantity then
			chip_quantity.caption = "x" .. exchange_item.chip_quantity
			chip_quantity.text_adjust_font_size = true
		end
	end
	
	local congradulation = dialog:find_child("congradulation", true, false)
	if congradulation then
		congradulation.caption = framework:strings():load("*CityCongratulationsString", "Congratulations")
		congradulation.text_adjust_font_size = true
	end
	
	local description = dialog:find_child("description", true, false)
	if description then
		description.caption = framework:strings():load("*GamblingExchangeDescription", "Description")
		description.text_adjust_font_size = true
	end
end

function on_close_button_action()
	dialog:end_dialog()
end

function on_exchange_ok_button_action()
    dialog:end_dialog()
end

