local friends_list = {}

function on_init_dialog()

    dialog.theme_flags = 2

    dialog:load_content('global_transport_map_dlg')
    
    friends_list = controller:get_friends(framework:game())

    create_dialog_elements()
end

spinboard_delegate = {
    create_cell = function (self, idx, rect)

        local cell_parent = self.spinboard:create_child(rect)

        framework:json_ui_manager():build_from_resource("global_transport_map_cell", cell_parent)
        
        local friend_avatar = cell_parent:find_child("friend_avatar", true, false)
        if friend_avatar then
            if controller:is_bot(friends_list[idx+1].user_id) then
                friend_avatar.texture_name = friends_list[idx+1].avatar_url
            else
                friend_avatar:set_remote_texture(friends_list[idx+1].avatar_url)
            end
            friend_avatar:set_seady_progress_as_image("default_avatar")
        end

        return cell_parent
    end,
        
    get_cell_count = function()
        return #friends_list
    end
}

function create_dialog_elements()
    spinboard = dialog:find_child("spinboard", true, false)
    if spinboard then
        spinboard:on_create()
    end

    local title_label = dialog:find_child("title_label", true, false)
    if title_label then
        title_label.caption = controller.object_description
    end

    local region_label = dialog:find_child("region_label", true, false)
    if region_label then
        region_label.caption = controller.region_description
    end

    local region_image = dialog:find_child("region_image", true, false)
    if region_image then
        region_image.image_name = "bus_station_route_icon_normal" .. controller.region_short_image_name
    end

    local friends_in_region_label = dialog:find_child("friends_in_region_label", true, false)
    if friends_in_region_label then
        friends_in_region_label.caption = string.format(framework:strings():load("*CityTransportGlobalMapFriendInYourRegion", "Friends in Your region: %d"), #friends_list)
    end

    local passengers_progress_bar = dialog:find_child("passengers_progress_bar", true, false)
    if passengers_progress_bar then
        passengers_progress_bar.pos = (controller.current_passengers / controller.max_passengers) * 100
    end

    local passengers_progress_label = dialog:find_child("passengers_progress_label", true, false)
    if passengers_progress_label then
        passengers_progress_label.caption = string.format("%d / %d", controller.current_passengers, controller.max_passengers)
    end

    local current_region = dialog:find_child("region" .. controller.region_short_name, true, false)
    if current_region then
        current_region.visible = true
    end

    local upgrade_button = dialog:find_child("upgrade_button", true, false)
    if upgrade_button then
        upgrade_button.active = controller:need_upgrade_terminal()
    end
end

function on_upgrade_button_action()
    controller:upgrade_terminal()
end