local m_selected_reward_key

function get_texture_name(texture)
	local texture_by_device = texture
	if g_device.is_tablet then
		texture_by_device = texture_by_device .. "_ipad"
		print(texture_by_device)
	end
	return texture_by_device
end

function on_init_dialog()

	dialog.theme_flags = 2
    dialog.bevel_type = milk_bevel_type_none

	m_selected_reward_key = selected_reward_key
	local action_info
	
	
	local ruby_action = framework:game():get_ruby_action()
	local drum_action = framework:game():get_drum_bonus_action()
	
	if ruby_action then
		if ruby_action:promotion_active() == true then
			action_info = framework:game():get_ruby_action()
		end
	end
	
	if not action_info then
		if drum_action then
			if drum_action:is_bonus_available() == true then
				action_info = framework:game():get_drum_bonus_action()
			end
		end
	end
		
	if action_info then
		local reward_vector = action_info:get_in_app_purchaser_reward(m_selected_reward_key)
			
		if #reward_vector == 1 then
			dialog:load_content('in_app_purchaser_one_reward_info_msgbox')
		else 
			if #reward_vector == 2 then
				dialog:load_content('in_app_purchaser_two_reward_info_msgbox')
			else
				if #reward_vector > 2 then
					dialog:load_content('in_app_purchaser_three_reward_info_msgbox')
				end
			end
		end
		
		local congradulation_title = dialog:find_child("congradulation_title", true, false)
    
		if congradulation_title then
			congradulation_title.caption = framework:strings():load("*InAppPurchaserGiftTitle", "Gift")
		end
		
	
		local spinboard = dialog:find_child("spinboard",true, false)
		if spinboard then
		
			if #action_info:get_in_app_purchaser_reward(m_selected_reward_key) <= 3 then
				spinboard.enable_horizontal_scroll = false
			end 
		
			spinboard:update_content()
		end
	end		
end

spinboard_delegate = {
	create_cell = function (  self, idx, rect )
		local w = self.spinboard:create_child(rect)
		
		local loc_idx = idx+1
                
        framework:json_ui_manager():build_from_resource("in_app_purchaser_cell_reward",w)
        w.rect = rect
        
        
        local reward_item = framework:game():get_ruby_action():get_in_app_purchaser_reward(m_selected_reward_key)[loc_idx]        
        action_object_info = framework:object_factory():get_object_info_by_type_name(reward_item.name)
        
        if action_object_info then
			local reward_name_label = w:find_child('reward_name',true,false)
			if reward_name_label then
				reward_name_label.caption = action_object_info.description
			end

			local cell_bg = w:find_child('cell_bg', true, false)
			local info_plate = w:find_child("info_plate", true, false)
			
			if		action_object_info.shop_department == "bouquets"
				or	action_object_info.shop_department == "act_of_expanding"
				or	action_object_info.shop_department == "expand"
				or	action_object_info.shop_department == "materials"
				or	action_object_info.shop_department == "craft_materials"
			then 
			
				if info_plate then
					info_plate.visible = false
				end
				
				if cell_bg then
					cell_bg.visible = true
					local reward_image = cell_bg:find_child('reward_image', true, false)
					if reward_image then
						reward_image.texture_name = action_object_info.shop_image_path
						reward_image:set_ready_progress_as_indicator()
					end
		
					local reward_quantity_label = cell_bg:find_child('reward_quantity', true, false)
					if reward_quantity_label then
						reward_quantity_label.caption = "x" .. tostring(reward_item.quantity)
					end			
				end
				
			else
			
				if cell_bg then
					cell_bg.visible = false
				end
				
				if info_plate then
					info_plate.visible = true
					info_plate.object_name = action_object_info.type_name
					info_plate:layout_controls()
					info_plate:add_show_property(21, reward_item.quantity, true)
					
					local background_image = info_plate:find_child('default_background_image', true, false)
					if background_image then
						background_image.image_name = get_texture_name("advances_small_item")
					end
				end
				
			end
		end
        
		return w
	end,
	
	get_cell_count = function ( )
		local action_info = framework:game():get_ruby_action()
		return #action_info:get_in_app_purchaser_reward(m_selected_reward_key)
    end
}

function on_ok_btn_action()
    dialog:end_dialog()
end

function on_close_button_action()
    dialog:end_dialog()
end
