


print("init build:" .. g_application.build)


print('device.manufacturer',g_device.manufacturer)
print('device.model',g_device.model)
print('device.gpu',g_device.gpu)

local function dump_config( config )
	local res = '{'
	for k,v in pairs(config) do
		res = res .. k .. '=' .. tostring(v) .. ','
	end
	res = res .. '}'
	return res
end

local function find_config( list , debug ) 
	for _,v in ipairs(list) do
		local all_matches = true
		for k,pattern in pairs(v) do
			if type(pattern) == 'string' then
				local device = g_device[k]
				if type(device) == 'string' then
					if not device:match(pattern) then
						if debug then print(tostring(debug) .. ' not match parameter ' .. k,"'"..device.."'","'"..pattern.."'") end
						all_matches = false
						break
					end
				end
			end
		end
		if all_matches then
			if debug then print(tostring(debug) .. ' found matched config ' .. tostring(_) .. ' ' .. dump_config(v)) end
			return _,v
		end
	end
	return 0,nil
end

function calc_resources_memory_limit( config )

	local memory_limits = {
		{
			model = '^iPad2,[567]',	-- 512mb iPad mini 1gen
			minimum = 128
		},
		{
			model = '^iPad2,%d+',	-- 512mb iPad other 2gen
			minimum = 128
		},
		{
			model = '^iPad3,%d+',	-- 1GB
			minimum = 256
		},
		{
			model = '^iPad4,%d+',	-- 1GB (air)
			minimum = 256
		},
		{
			model = '^iPad5,%d+',	-- 2GB (air2)
			minimum = 256
		},
		{
			model = '^iPhone6,%d+',	-- 1GB (5S)
			minimum = 256
		},
		{
			model = '^iPhone7,%d+',	-- 1GB (6,6+)
			minimum = 256
		},
	}

	local model = g_device.model
	local gpu = g_device.gpu

	local megbytes = 1024 * 1024

	local num,matched = find_config(memory_limits,calc_resources_memory_limit_debug)

	calc_resources_memory_limit_debug = nil

	if matched then
		--print('found memory config rule: ' .. tostring(num),model,gpu)
		if matched.minimum then
			
			config.minimum = matched.minimum * megbytes
			if config.memory_warning then
				config.minimum = matched.minimum * megbytes * 0.75
			end
			--print('minimum:',config.minimum /  megbytes)
		end
		if matched.maximum then
			--print('maximum:',matched.maximum )
			config.maximum = matched.maximum * megbytes
		end
		if matched.result then
			--print('result:',matched.result )
			config.result = matched.result * megbytes
		end
		return
	end

	--print('not found memory config, use default values',model,gpu)

end