-- cell count
local spinboard_cell_count = 7 

-- plate positions
local plate_positions = {
    [1] = "top",
    [2] = "bottom",
    [3] = "center"
}

----
---- cell vertical correction
---- for changing vertical spacing between top and bottom cell plates
----
local cell_vertical_correction = {
    ["phone"] = 14,
    ["tablet"] = 0
}

--using only descripted buttons
local button_widgets = {
    [0] = "button_buy",             --info_page_button_type_buy
    [1] = "button_buy_gray",        --info_page_button_type_buy_gray
    [2] = "button_goto",            --info_page_button_type_show
    [3] = "fake",                       --
    [4] = "button_upgrade",         --info_page_button_type_upgrade
    [5] = "button_upgrade_gray",    --info_page_button_type_upgrade_gray
    [6] = "fake",                       --
    [7] = "fake",                       --
    [8] = "button_build"            --info_page_button_type_build
}

-- arrows
local arrows_by_cell = {
    [0] = {"arrow_h_top_right"},
    [1] = {"arrow_h_top_left", "arrow_v_top_to_bot", "arrow_construct_part_left", "arrow_h_top_right"},
    [2] = {"arrow_h_top_left", "arrow_construct_part_center", "arrow_h_top_right"},
    [3] = {"arrow_h_top_left", "arrow_construct_part_center", "arrow_h_top_right"},
    [4] = {"arrow_h_top_left", "arrow_construct_part_center_right", "arrow_h_top_right"},
    [5] = {"arrow_h_top_left", "arrow_construct_part_right", "arrow_h_top_right", "arrow_dia_to_bot_right"},
    [6] = {"arrow_h_top_left", "arrow_dia_to_bot_left"}
}

-- plate types
local plate_types = {
    [0] = { 
                ["top"] = "info_island_plate_simple", 
                ["bottom"] = "", 
                ["center"] = ""
          },
    [1] = { 
                ["top"] = "info_island_plate_level", 
                ["bottom"] = "info_island_plate_level", 
                ["center"] = ""
          },
    [2] = { 
                ["top"] = "", 
                ["bottom"] = "info_island_plate_level", 
                ["center"] = ""
          },
    [3] = { 
                ["top"] = "", 
                ["bottom"] = "info_island_plate_level", 
                ["center"] = ""
          },
    [4] = { 
                ["top"] = "", 
                ["bottom"] = "info_island_plate_level", 
                ["center"] = ""
          },
    [5] = { 
                ["top"] = "info_island_plate_level", 
                ["bottom"] = "info_island_plate_level", 
                ["center"] = ""
          },
    [6] = { 
                ["top"] = "info_island_plate_level", 
                ["bottom"] = "info_island_plate_level", 
                ["center"] = ""
          }
}

local plate_content = {
    [0] =   {
                ["top"]     = {"hydroport_stage2"},
                ["bottom"]  = {},
                ["center"]  = {}
            },
    [1] =   {
                ["top"]     = {"marine_terminal_new_stage2"},
                ["bottom"]  = {"coast_hotels_new_buildsite", "coast_hotels_new_buildsite_real"},
                ["center"]  = {}
            },
    [2] =   {
                ["top"]     = {},
                ["bottom"]  = {"large_planetarium_buildsite", "large_planetarium_buildsite_real"},
                ["center"]  = {}
            },
    [3] =   {
                ["top"]     = {},
                ["bottom"]  = {"observatorium_buildsite", "observatorium_buildsite_real"},
                ["center"]  = {}
            },
    [4] =   {
                ["top"]     = {""},
                ["bottom"]  = {"aquapark_buildsite", "aquapark_buildsite_real", "aquapark_new_buildsite", "aquapark_new_buildsite_real"},
                ["center"]  = {}
            },
    [5] =   {
                ["top"]     = {"marine_terminal_new_stage3"},
                ["bottom"]  = {"tropical_hotel_buildsite", "tropical_hotel_buildsite_real", "tropical_hotel_new_buildsite", "tropical_hotel_new_buildsite_real"},
                ["center"]  = {}
            },
    [6] =   {
                ["top"]     = {"avia_ground_buildsite", "avia_ground_buildsite_real"},
                ["bottom"]  = {"liner_berth_buildsite", "liner_berth_buildsite_real"},
                ["center"]  = {}
            }
}

local plate_levels = {
    [0] =   {
                ["top"]     = {["min"] = 0, ["max"] = 0, ["shift"] = -1},
                ["bottom"]  = {["min"] = 0, ["max"] = 0, ["shift"] = 0},
                ["center"]  = {["min"] = 0, ["max"] = 0, ["shift"] = 0},
            },
    [1] =   {
                ["top"]     = {["min"] = 1, ["max"] = 1, ["shift"] = 2},
                ["bottom"]  = {["min"] = 1, ["max"] = 4, ["shift"] = 2},
                ["center"]  = {["min"] = 0, ["max"] = 0, ["shift"] = 0},
            },
    [2] =   {
                ["top"]     = {["min"] = 0, ["max"] = 0, ["shift"] = 0},
                ["bottom"]  = {["min"] = 1, ["max"] = 4, ["shift"] = 1},
                ["center"]  = {["min"] = 0, ["max"] = 0, ["shift"] = 0},
            },
    [3] =   {
                ["top"]     = {["min"] = 0, ["max"] = 0, ["shift"] = 0},
                ["bottom"]  = {["min"] = 1, ["max"] = 3, ["shift"] = 2},
                ["center"]  = {["min"] = 0, ["max"] = 0, ["shift"] = 0},
            },
    [4] =   {
                ["top"]     = {["min"] = 0, ["max"] = 0, ["shift"] = 0},
                ["bottom"]  = {["min"] = 1, ["max"] = 3, ["shift"] = 1},
                ["center"]  = {["min"] = 0, ["max"] = 0, ["shift"] = 0},
            },
    [5] =   {
                ["top"]     = {["min"] = 2, ["max"] = 2, ["shift"] = 2},
                ["bottom"]  = {["min"] = 1, ["max"] = 4, ["shift"] = 2},
                ["center"]  = {["min"] = 0, ["max"] = 0, ["shift"] = 0},
            },
    [6] =   {
                ["top"]     = {["min"] = 1, ["max"] = 2, ["shift"] = 0},
                ["bottom"]  = {["min"] = 1, ["max"] = 1, ["shift"] = 1},
                ["center"]  = {["min"] = 0, ["max"] = 0, ["shift"] = 0},
            }
}

local info_description_text = {
    [0] =   {
                ["top"]     = "tourist_island_title_info_2",
                ["bottom"]  = "",
                ["center"]  = ""
            },
    [1] =   {
                ["top"]     = "tourist_island_title_info_0",
                ["bottom"]  = "*CoastalHotelsDescription",
                ["center"]  = ""
            },
    [2] =   {
                ["top"]     = "",
                ["bottom"]  = "",
                ["center"]  = ""
            },
    [3] =   {
                ["top"]     = "",
                ["bottom"]  = "*ObservatoryDescription",
                ["center"]  = ""
            },
    [4] =   {
                ["top"]     = "",
                ["bottom"]  = "*AquaparkDescription",
                ["center"]  = ""
            },
    [5] =   {
                ["top"]     = "",
                ["bottom"]  = "",
                ["center"]  = ""
            },
    [6] =   {
               ["top"]     = "",
                ["bottom"]  = "tourist_island_title_info_3",
                ["center"]  = ""
            }
}


local m_page_destroed = false

local controllers = {}



function plate_buy_action(cell_controller)
    cell_controller:on_press_btn_buy()
end

function plate_buy_gray_action(cell_controller)
end

function plate_goto_action(cell_controller)
    cell_controller:on_press_btn_show()
end

function plate_upgrade_action(cell_controller)
    cell_controller:on_press_btn_upgrade()
end

function plate_upgrade_gray_action(cell_controller)
end

function plate_build_action(cell_controller)
    cell_controller:on_press_btn_upgrade()
end

function plate_info_action(cell_controller)

    close_callback = 	function()
							end
		
	local params={}
		-- 0: sqc_message_box_type_default
		-- 1: sqc_message_box_type_local_error
		-- 2: sqc_message_box_type_server_error
	params.type = 0
	params.dlg_text = cell_controller.description_text
	params.button_text = framework:strings():load("*CityOKButton","OK" )
	params.on_close_callback = close_callback
	framework:dialogs():show_message_box( params );
end

function fill_content_controllers()

    --- set plate positions for correct init
    controller:set_plate_positions(plate_positions)
    --- init controller
    controller:init()
    
    local cell_count = controller:get_custom_cell_count()
    --local content_controllers = controller:get_controllers_from_content()
    if cell_count > 0 then
        print("[island_info:fill_content_controllers] create custom content controllers for cells. Cell count = ", cell_count)
        for i = 0, (cell_count-1) do
            local plate_controllers = {}
            for j = 1, #plate_positions do
                
                local p_controller = controller:get_cell_controller(i, plate_positions[j])
                if p_controller then 
                    plate_controllers[plate_positions[j]] = p_controller;
                end
            end
            
            controllers[i] = plate_controllers;
        end
        
        return true
    else
        return false 
    end
end


function on_init_page()

	page:load_content('island_info')
	
	--- Try fill custom content from hierarchy
	local success_fill_content = fill_content_controllers()
	
	if not success_fill_content then
	    --- Fill natural content from lua  
	    print( "[island_info:on_init_page] fill natural lua content")   
	    local cell_count = info_spinboard_delegate:get_cell_count()
	    for i = 0, cell_count-1 do
	    
	        if i <= #plate_types then
                local cell_controllers = {}
	            for j = 1, #plate_positions do
	        
	                local position = plate_positions[j]
	                if not (position == "") then
	                    local contr = controller:get_cell_controller(i, position)
	            
	                    -- fill objects
	                    if i <= #plate_content then
	                        local content_objects =  plate_content[i][position]
	                        if #content_objects > 0 then 
	                            contr:set_object_type(content_objects)
	                        end
	                    end
	                
	                    -- fill plate types
	                    if i <= #plate_types then
	                        local p_type = plate_types[i][position]
	                        contr.plate_type = p_type
	                    end
	                    
	                    -- fill levels
	                    if i <= #plate_levels then
	                    
	                        -- level max value
	                        local max = plate_levels[i][position]['max']
	                        if not (max == "") then
                                contr.level_max     = max
                            end
                            
                            -- level min value
                            local min = plate_levels[i][position]['min']
                            if not (min == "") then
                                contr.level_min    = min
                            end
                        
                            -- level shift value
                            local shift = plate_levels[i][position]['shift']
                            if not (shift == "") then
                                contr.level_shift    = shift
                            end
                        end
	        
	                    -- fill info description
	                    if i < #info_description_text then
                            local info_description = framework:get_client_string( info_description_text[i][position] )
	                        if info_description == "" then
	                            info_description = framework:strings():load( info_description_text[i][position], "object information" )
	                       end
	                        contr.description_text = info_description
                        end
                        cell_controllers[position] = contr
	                else
	                    print("[island_info::on_init_page] Error! Wrong plate position at index ", j)
	                end
	            end
	        
	            controllers[i] = cell_controllers
            else
                print("[island_info::on_init_page] Warning! not init controller for cell with idx = ", i)
            end
            
            --- cell arrows
            if i <= #arrows_by_cell then
                local cell_arrows = arrows_by_cell[i]
                if #cell_arrows > 0 then
                    controller:set_cell_arrows(i, cell_arrows)
                end
            end
            
	    end
	end
	
	local info_spinboard = page:find_child('info_spinboard', true, false)
	if info_spinboard then
	    info_spinboard.visible = true
	    info_spinboard:update_content()
	end
	
	update_page()
end



function fill_cell( plate, idx, position )
    
    if idx > #controllers then
        print("[island_info::fill_cell] Error! controllers. Array index out of bounds. idx = ", idx)
        return
    end
    
    local cell_controller = controllers[idx][position]
    if not cell_controller then
        print("[island_info::fill_cell] Error! controller is nil for cell with idx =", idx, ", position =", position)
        return
    end
    
    if cell_controller.plate_type == "" then
        print("[island_info::fill_cell] plate_type is empty for plate with idx = ", idx, ", position = ", position )
        return
    end
    
    local title = cell_controller:get_title()
    local title_label = plate:find_child('title_label', true, false)
    if title_label then
	    title_label.visible = true
	    title_label.caption = title
	end
        
    local object_image_path = cell_controller:get_object_image_path()
    --print("object_image_path!!! = ", object_image_path)
    local item_image = plate:find_child('item_image', true, false)
    if item_image then
        item_image.visible = true
        item_image.texture_name = object_image_path
		item_image:set_ready_progress_as_indicator()
	end
	    
	local b_type = cell_controller:get_button_type()
	if button_widgets[b_type] then
	    local button = plate:find_child(button_widgets[b_type], true, false)
	    if button then
	        button.visible = true
	    end
	end
	
	local stage_num = cell_controller:get_object_current_stage_num()
	local level_shift = cell_controller.level_shift
	if stage_num - level_shift > 0 then
	    local check_icon = plate:find_child('check_icon', true, false)
	    if check_icon then
	        check_icon.visible = true
	    end
	end
	
	update_cell_levels( plate, idx, cell_controller)
    update_buttons( plate, idx, cell_controller)
	    
end

function update_arrows( arrows_plate, idx )

    local cell_arrows = controller:get_cell_arrows(idx)   
    if cell_arrows and #cell_arrows > 0 then
		for i = 0, #cell_arrows do
		    local arrow_name = cell_arrows[i]
		    if not ( arrow_name == "" ) then
		        local arrow = arrows_plate:find_child( arrow_name, true, false)
			    if arrow then
			        arrow.visible = true
			    else
			        print("[island_info::update_arrows] can't find arrow with name  '", arrow_name, "' for cell with idx = ", idx)
			    end
		    end  
		end
	else
	    print("[island_info::update_arrows] Warning! cell_arrows. Arrows array is empty for cell with idx = ", idx)
        return
	end
end

function update_buttons ( plate, idx, cell_controller )

    for i = 0, #button_widgets do
        local button_name = button_widgets[i]
        if  not ( button_name == "" ) then
            local button = plate:find_child( button_name, true, false)
		    if button then
			    if button_widgets[i] == 'button_buy' then
				    button.action = function()
									    plate_buy_action(cell_controller)
								    end
			    elseif button_widgets[i] == 'button_buy_gray' then
				    button.action = function()
									    plate_buy_gray_action(cell_controller)
								    end
			    elseif button_widgets[i] == 'button_goto' then
				    button.action = function()
									    plate_goto_action(cell_controller)
								    end
			    elseif button_widgets[i] == 'button_upgrade' then
				    button.action = function()
									    plate_upgrade_action(cell_controller)
								    end
			    elseif button_widgets[i] == 'button_upgrade_gray' then
				    button.action = function()
									    plate_upgrade_gray_action(cell_controller)
								    end
			    elseif button_widgets[i] == 'button_build' then
				    button.action = function()
									    plate_build_action(cell_controller)
								    end		
			    end							
		    end
        end
    end
    
    local info_button = plate:find_child("info_button", true, false)
    if info_button then
        info_button.action = function()
							plate_info_action(cell_controller)
						end
	end
end

function update_cell_levels ( plate, idx, cell_controller )
    
    local level_plate = plate:find_child('level_plate', true, false)
	if level_plate then
	    local level_active = level_plate:find_child('level_active', true, false)
	    local level_item_space = level_plate:find_child('level_item_space', true, false)
	    if level_active and level_item_space then
	        
	        
	        local rect = level_active.rect
	        local space_rect = level_item_space.rect
	        
	        local max_level = cell_controller.level_max 
	        local min_level = cell_controller.level_min
	        if max_level > 0 then
	            for i = min_level, max_level do
	                local next_level_rect = rect
	                local plate = level_plate:create_child(rect)
	                local current_stage_num = cell_controller:get_object_current_stage_num()
	                local current_level = current_stage_num - cell_controller.level_shift
	            
	                if i > current_level then
	                    framework:json_ui_manager():build_from_resource("info_level_plate_inactive",plate)
	                else
	                    framework:json_ui_manager():build_from_resource("info_level_plate_active",plate)
	                end
	                
	                plate.rect = next_level_rect
	            
	                local level_label = plate:find_child('level_label', true, false)
	                local text= string.format(level_label.caption, i)
	                level_label.caption = text
	            
	                rect[2] = rect[2] + rect[4] + space_rect[4]
	            end
	        end
	    end
	end
	
end

info_spinboard_delegate = {
	create_cell = function (  self, idx, rect )
		
		local w = self.spinboard:create_child(rect)
        
		local arrows_plate = w:create_child(rect)
		framework:json_ui_manager():build_from_resource("arrows_plate",arrows_plate)
		update_arrows(arrows_plate, idx)
		
		if idx > #controllers then
            print("[island_info::create_cell] Warning! controllers. Array index out of bounds. idx = ", idx)
            return w
        end
        
		local positions = controller:get_plate_positions()
		if #positions > 0 then
		    for i = 1, #positions do
		        local plate_widget = w:create_child(rect)
		        local position = positions[i]
		        local plate_controller = controllers[idx][position]
		        if plate_controller then 
		        
		            local plate_type = plate_controller.plate_type
		            framework:json_ui_manager():build_from_resource(plate_type, plate_widget)
		            
		            --- rect correction for top plate
		            if position == "top" then  
		                -- copy rect for changes
		                local rect2 = {}
		                for j = 1, 4 do
		                    rect2[j] = rect[j]
		                end 
		                
		                -- move plate
		                if controller:is_tablet() then
                            rect2[2] = rect2[2] + rect2[4]/2 + cell_vertical_correction["tablet"]
                        else
                            rect2[2] = rect2[2] + rect2[4]/2 + cell_vertical_correction["phone"]
                        end
                        plate_widget.rect = rect2
                    else
                        plate_widget.rect = rect
		            end
		            
		            fill_cell(plate_widget, idx, position)
		        else
		            print("[island_info::create_cell] Warning! Empty plate controller for cell with idx =",idx,", position =",position)
		        end
		    end
		end
		
        return w
    end,
    get_cell_count = function ( )
    
        local cell_count = controller:get_custom_cell_count()
        if cell_count == custom_cell_count_none then
            cell_count = spinboard_cell_count
        end
        
        if controller:is_tablet() then
            -- making visible last cell for tablet1
            cell_count = cell_count + 1
        end
        
        return cell_count
    end
}

function on_destroy_page()
	m_page_destroed = true
end

function update_page()
	if m_page_destroed then
		return
	end
end