function get_dialog_init_arg()
    local params = {}
    params.right_button = 1  -- milk_dialog_button_type_close;
    return params
end

function on_init_dialog()

	dialog.theme_flags = 1
    dialog.bevel_type = milk_bevel_type_none

	dialog:load_content('prize_object_info_msgbox')
		
	create_dialog_elements()	
end

function on_post_init_dialog()
	init_barn_animator()
end

function init_barn_animator()
    if not barn_animator then
        local animator_name = "city_barn_animation_impl"
        local barn_animator_class = cclasses[animator_name]
        if barn_animator_class then        
            barn_animator=barn_animator_class.new()
        end
    end

    if not barn_animator_params then
        local animator_params_name="barn_animator_params"
        local barn_animator_params_class=cclasses[animator_params_name]
        if barn_animator_params_class then 
            barn_animator_params=barn_animator_params_class.new()
        end
    end
end

function create_dialog_elements()
    
    local label_dialog_title = dialog:find_child("dialog_title", true, false)
    if label_dialog_title then
    	label_dialog_title.caption = framework:strings():load("*CityCongratulationsString", "Congratulation")
    	label_dialog_title.text_adjust_font_size = true
    end
    
    local label_you_get_reward = dialog:find_child("you_get_reward", true, false)
    if label_you_get_reward then
    	label_you_get_reward.caption = framework:strings():load("*CityActionYouGetPrize", "You build 4 object and you can get prize for this")
    	label_you_get_reward.text_adjust_font_size = true
    end
    
    local info_plate = dialog:find_child("info_plate", true, false)
    if info_plate then
        info_plate.object_name = m_reward_info.type_name
        info_plate.plate_type = 1
        info_plate:layout_controls()
    end
    
    local tell_btn_label = dialog:find_child("tell_btn_label", true, false)
    
    if(tell_btn_label and not framework:settings_controller():get_post_to_wall_warning_enabled()) then
        tell_btn_label.caption=framework:strings():load("*CityOKButton","OK" )
    end
    
    local object_image = dialog:find_child("object_image", true, false)
    
    if(object_image) then
        local rect=object_image.rect
        rect[2]=rect[2]/2
        object_image.rect=rect
    end
    
    local object_properties = dialog:find_child("object_properties", true, false) 
    
    if(object_properties) then
        local rect=object_properties.rect 
        rect[2]=rect[2]-2
        object_properties.rect=rect
    end
    
end

function on_tell_btn_action()
    
    if(framework:settings_controller():get_post_to_wall_warning_enabled()) then
        local sqc_request_args = {}
        request_name = "share_" .. m_sale_name .. "_".. m_reward_info.type_name
        print("request_name = ", request_name)
        local request = framework.requests_processor:create_request(request_name,sqc_request_args)
        if (request) then
            framework:send_request(request)
        else
            print("request nil")
        end
    end

	show_barn_update_animation()
end

function show_barn_update_animation()
    
    if barn_animator and barn_animator.animation_started then
	    return true
    end
    
    local type_names={}
    local reward_rects={}

	table.insert(type_names, m_reward_info.type_name)
    
    local object_image = dialog:find_child("object_image", true, false)
	if object_image then
		table.insert(reward_rects, object_image.screen_rect)
	end
        
    if #type_names > 0 and barn_animator then
        if barn_animator_params then
            barn_animator_params.close_window=true
        end
        barn_animator:set_rewards_data(type_names,reward_rects)
        barn_animator:show_barn_update_animation(barn_animator_params)
    else
		return false
    end
    
    return true
end

function on_end_dialog()
	if show_barn_update_animation() == true then
		return false
	else
		return true
	end
end

function on_close_button_action()
	can_close_window=true
    if barn_animator and barn_animator.animation_started then
        can_close_window=false
    end

    if can_close_window then
        dialog:end_dialog()
    end
end
