local all_posible_stations = {}
local information_bubble = {}

local bridges_names = {
	"forth_bridge",
	"hudson_bridge",
	"longbow_bridge",
	"bridge_red_gate",
	"bridge_gustave_flaubert",
	"underwater_rail_tunnel_in",
	"underwater_rail_tunnel_out"
}

function hide_information_bubble()
	if information_bubble then
		information_bubble.visible = false
		information_bubble = {}
	end
end

function station_params_by_tag(station_tag)
	for i = 1, #all_posible_stations do
		if all_posible_stations[i].station_tag == station_tag then
			return all_posible_stations[i]
		end
	end

	return nil;
end

function change_route_button_action()
	if is_statictic_dlg == true then return end 
	
	hide_information_bubble()

	controller:send_route_command()
	framework:tutorial():fire_event("chnage_route_button:touch", 1)
	if framework:is_tutorial_mode() then
		framework:windows():close_all_modals()
	elseif dialog then 
		dialog:end_dialog() 
	end
end

function draw_train_information()
	local train_info_layer = dialog:find_child("train_info_layer", true, false)
	if train_info_layer then
		train_info_layer.visible = true
	end

	local statistic_layer = dialog:find_child("statistic_layer", true, false)
	if statistic_layer then
		statistic_layer.visible = false
	end

	local train_name = dialog:find_child("train_name", true, false)
	train_name.caption = controller:vehicle_name()

	local train_image = dialog:find_child("train_image", true, false)
	train_image.texture_name = controller:vehicle_image()

	local train_stops = dialog:find_child("train_stops", true, false)
	local stops_text = string.format(framework:strings():load("*CityMaterialsQuantityLabel", "%d out of %d"), controller:get_route_length(), controller:get_route_max_length())
	train_stops.caption = stops_text

	local train_coins = dialog:find_child("coins_productivity", true, false)
	local coins_text = string.format("+%d", controller:current_vehicle_coins_productivity())
	train_coins.caption = coins_text

	local train_passengers = dialog:find_child("passengers_productivity", true, false)
	local passengers_text = string.format("+%d", controller:current_vehicle_passengers_productivity())
	train_passengers.caption = passengers_text

	local change_route = dialog:find_child("chnage_route_button", true, false)
	--change_route.active = controller:can_send_vehicle()
	change_route.action = function()
		change_route_button_action()
	end

	local change_button_label = change_route:find_child("change_button_label", true, false)
	if controller.route_length > 0 then
		change_button_label.caption = framework:strings():load("*CityBusStationBusesButtonSend", "Send")
	else
		change_button_label.caption = framework:strings():load("*CityBusStationRouteChange", "Change")
	end

end

function move_to_station(station_tag)
	local field = framework:game():get_field()
    local object_provider = framework:object_factory()
    local station_object = framework.quests_processor:find_object_on_field_by_quest_tag(station_tag, field, object_provider)

    framework:windows():close_all_modals()
    if station_object then
        framework:scene_view():focus_on_object(station_object, true)
    end
end

function draw_bubble_progress(station, bubble)
	local productivity_value = 0
	if station.passangers_current_productivity_with_vehicle >= station.passangers_max_productivity then
		local red_progress = bubble:find_child("red_progress", true, false)
		if red_progress then
			red_progress.visible = true
			red_progress.pos = 100
		end

		local green_progress = bubble:find_child("green_progress", true, false)
		if green_progress then
			green_progress.visible = false
		end
		
		local orange_part_progress = bubble:find_child("orange_part_progress", true, false)
		if orange_part_progress then
			orange_part_progress.visible = false
		end

		local orange_progress = bubble:find_child("orange_progress", true, false)
		if orange_progress then
			orange_progress.visible = false;
		end
	
		productivity_value = station.passangers_current_productivity_with_vehicle
	elseif station.is_in_route == true and station.passangers_current_productivity ~= station.passangers_max_productivity then
		local green_progress = bubble:find_child("green_progress", true, false)
		if green_progress then
			green_progress.visible = true
			green_progress.pos = (station.passangers_current_productivity_with_vehicle / station.passangers_max_productivity) * 100
		end

		local orange_part_progress = bubble:find_child("orange_part_progress", true, false)
		if orange_part_progress then
			orange_part_progress.pos = (station.passangers_current_productivity / station.passangers_max_productivity) * 100
		end

		local orange_progress = bubble:find_child("orange_progress", true, false)
		if orange_progress then
			orange_progress.visible = false;
		end

		local red_progress = bubble:find_child("red_progress", true, false)
		if red_progress then
			red_progress.visible = false
		end

		productivity_value = station.passangers_current_productivity_with_vehicle
	else
		local orange_progress = bubble:find_child("orange_progress", true, false)
		if orange_progress then
			orange_progress.visible = true
			orange_progress.pos = (station.passangers_current_productivity / station.passangers_max_productivity) * 100
		end

		local green_progress = bubble:find_child("green_progress", true, false)
		if green_progress then
			green_progress.visible = false;
		end

		local red_progress = bubble:find_child("red_progress", true, false)
		if red_progress then
			red_progress.visible = false
		end

		productivity_value = station.passangers_current_productivity
	end

	local caption = string.format("%s / %s", 
											framework:formats():format_digit_compact(productivity_value), 
											framework:formats():format_digit_compact(station.passangers_max_productivity))
	
	local prductivity_label = bubble:find_child("prductivity_label", true, false)
	local prductivity_label_white = bubble:find_child("prductivity_label_white", true, false)
	if station.passangers_current_productivity_with_vehicle >= station.passangers_max_productivity then
		if prductivity_label then
			prductivity_label.visible = false
		end

		if prductivity_label_white then
			prductivity_label_white.caption = caption
			prductivity_label_white.visible = true
		end
	else
		if prductivity_label_white then
			prductivity_label_white.visible = false
		end

		if prductivity_label then
			prductivity_label.caption = caption
			prductivity_label.visible = true
		end
	end
	
end

function draw_station_bubbles()
	for i=2, #all_posible_stations do
		local big_bubble = dialog:find_child(all_posible_stations[i].station_tag .. "_info_big", true, false)
		local small_bubble = dialog:find_child(all_posible_stations[i].station_tag .. "_info_complete", true, false)
		local notbuild_bubble = dialog:find_child(all_posible_stations[i].station_tag .. "_info_notbuild", true, false)
		
		if all_posible_stations[i].built_for_needed_stage == false then 
			small_bubble.visible = false
			big_bubble.visible = false
			notbuild_bubble.visible = true

			local build_button = notbuild_bubble:find_child("build_button", true, false)
			if build_button then
				build_button.action = function()
										move_to_station(all_posible_stations[i].station_tag)
									  end
			end
			
		elseif all_posible_stations[i].station_complete_build == false then
			small_bubble.visible = false
			big_bubble.visible = true
			notbuild_bubble.visible = false

			draw_bubble_progress(all_posible_stations[i], big_bubble)

			local build_button = big_bubble:find_child("build_button", true, false)
			if build_button then
				build_button.action = function()
										move_to_station(all_posible_stations[i].station_tag)
									  end
			end
		else
			small_bubble.visible = true
			big_bubble.visible = false
			notbuild_bubble.visible = false

			draw_bubble_progress(all_posible_stations[i], small_bubble)
			
			local move_button = small_bubble:find_child("move_button", true, false)
			if move_button then
				move_button.action = function()
										move_to_station(all_posible_stations[i].station_tag)
									 end
			end
		end
	end

	local bubbles_layer = dialog:find_child("bubbles_layer", true, false)
	if bubbles_layer then
		bubbles_layer:raise()
	end
end

function draw_ways_between_stations()
	local notselected_ways = {}
	local selected_ways = {}

	for i=1, #all_posible_stations do
		local connected_stations = all_posible_stations[i]:connected_stations()
		for j=1, #connected_stations do

			if not controller:stations_conected_by_ways(all_posible_stations[i].station_tag, connected_stations[j]) then goto continue end

			local ways = all_posible_stations[i]:ways(connected_stations[j])
			
			for k=1, #ways do
				local way_name = ways[k]
				
				local station_way_notbuild = dialog:find_child(way_name .. "_notbuild", true, false)
				if not station_way_notbuild then goto continue_ways end

				local station_way_selected = dialog:find_child(way_name .. "_selected", true, false)
				local station_way_notselected = dialog:find_child(way_name .. "_notselected", true, false)
				
				table.insert(notselected_ways, station_way_notselected)
				table.insert(selected_ways, station_way_selected)

				station_way_notbuild.visible = false
				station_way_selected.visible = false
				station_way_notselected.visible = false

				local is_way_complete = true
				local is_way_in_route = true
				for m=1, #ways do
					if not controller:is_way_complete(way_name) then
						is_way_complete = false
					end
					
					if controller:is_way_in_route(way_name) == false then
						is_way_in_route = false
					end
				end

				if is_way_complete == false then
					station_way_notbuild.visible = true
				else
					station_way_notselected.visible = true
				end
				
				if is_way_in_route then
					station_way_selected.visible = true
				end

				::continue_ways::
			end

			::continue::
		end
	end

	for i = 1, #notselected_ways do
		notselected_ways[i]:raise()
	end

	for i = 1, #selected_ways do
		selected_ways[i]:raise()
	end
end

function draw_not_build_station(station)
	local station_image = dialog:find_child(station.station_tag, true, false)
	station_image.visible = false

	local station_circle = dialog:find_child(station.station_tag .. "_notbuild", true, false)
	print(station.station_tag .. "_notbuild")
	station_circle.visible = true
end

function draw_not_selected_station(station)
	local station_image = dialog:find_child(station.station_tag, true, false)
	station_image.visible = true

	local station_circle = dialog:find_child(station.station_tag .. "_notselected", true, false)
	station_circle.visible = true

	local station_circle_selected = dialog:find_child(station.station_tag .. "_selected", true, false)
	station_circle_selected.visible = false

	local station_circle_cant_add = dialog:find_child(station.station_tag .. "_cant_add", true, false)
	station_circle_cant_add.visible = false
end

function draw_selected_station(station)
	local station_circle = dialog:find_child(station.station_tag .. "_notselected", true, false)
	station_circle.visible = false

	local station_circle_cant_add = dialog:find_child(station.station_tag .. "_cant_add", true, false)
	station_circle_cant_add.visible = false

	local station_image = dialog:find_child(station.station_tag, true, false)
	station_image.visible = true

	local station_plate = dialog:find_child(station.station_tag .. "_selected", true, false)
	station_plate.visible = true
	station_plate:raise()

	local numbers_to_set = controller:get_station_numbers(station.station_tag)

	for i = 1, 3 do
		local station_circle = station_plate:find_child("selected_image_" .. i, true, false)
		station_circle.visible = i == #numbers_to_set
	end
	
	local station_circle = station_plate:find_child("selected_image_" .. #numbers_to_set, true, false)
	
	if #numbers_to_set == 1 then
		local num_label = station_circle:find_child("num_label", true, false)
		if num_label then
			if numbers_to_set[1] == "1" then 
				num_label.visible = false 
			else
				num_label.visible = true
			end
			num_label.caption = numbers_to_set[1]
		end

		local num_label_one = station_circle:find_child("num_label_one", true, false)
		if num_label_one then
			if numbers_to_set[1] ~= "1" then 
				num_label_one.visible = false 
			else
				num_label_one.visible = true
			end
			num_label_one.caption = numbers_to_set[1]
		end
	else
		for i = 1, #numbers_to_set do
			local num_label = station_circle:find_child("num_label_" .. i, true, false)
			if num_label then
				num_label.caption = numbers_to_set[i]
			end
		end
	end

	local station_circle_not = dialog:find_child(station.station_tag .. "_notselected", true, false)
	station_circle_not.visible = false
end

function draw_cant_add_station(station)
	local station_image = dialog:find_child(station.station_tag, true, false)
	station_image.visible = true

	local station_circle = dialog:find_child(station.station_tag .. "_notselected", true, false)
	station_circle.visible = false

	local station_circle_selected = dialog:find_child(station.station_tag .. "_selected", true, false)
	station_circle_selected.visible = false

	local station_circle_cant_add = dialog:find_child(station.station_tag .. "_cant_add", true, false)
	station_circle_cant_add.visible = true
end

function draw_stations()
	for i=2, #all_posible_stations do
		local current_station = all_posible_stations[i]

		if not current_station.built_for_needed_stage then
			draw_not_build_station(all_posible_stations[i])

		elseif current_station.is_in_route then
			draw_selected_station(all_posible_stations[i])

		else
			local route = controller:get_route_for_staion(current_station.station_tag)
			local result = controller:can_add_to_route(current_station.station_tag, route)

			if result == sqc.city.city_transport_regional_station_check.everything_is_ok then 
				draw_not_selected_station(all_posible_stations[i])
			else
				draw_cant_add_station(all_posible_stations[i])
			end
		end

	end
end

function show_message(text)
	local params={}
			-- 0: sqc_message_box_type_default
			-- 1: sqc_message_box_type_local_error
			-- 2: sqc_message_box_type_server_error
			params.type = 0
			params.dlg_title = framework:strings():load("*CityWarning","Warning")
			params.dlg_text = text
			params.button_text = framework:strings():load("*CityOKButton","OK" )
			framework:dialogs():show_message_box( params );
end

function on_station_press(station_tag)
	hide_information_bubble()

	local route = controller:get_route_for_staion(station_tag)
	local result = controller:can_add_to_route(station_tag, route)
	local station_params = station_params_by_tag(station_tag)

	if not station_params then
		result = sqc.city.city_transport_regional_station_check.unknown_error
	end

	if result == sqc.city.city_transport_regional_station_check.station_not_build_enough then
		local needed_station = controller:first_not_completed_station(route)
		framework:dialogs():show_object_required_dialog(sqc.city.sqc_city_shop_error_value.city_shop_result_need_required_building, 
														needed_station);

	elseif result == sqc.city.city_transport_regional_station_check.station_not_conected then
		show_message("станции не соеденены\n TODO: текст")

	elseif result == sqc.city.city_transport_regional_station_check.ways_to_station_not_completed then
		local needed_way = controller:get_needed_complete_way(route)
		framework:dialogs():show_railroad_required_dialog(needed_way)

	elseif is_statictic_dlg == true then 
		move_to_station(station_tag)
		return
	
	elseif result == sqc.city.city_transport_regional_station_check.route_is_full then
		show_message(framework:strings():load("*CityTransportRegionalRouteMaxSize", "Max number already added to route"))

	elseif result == sqc.city.city_transport_regional_station_check.already_in_route then
		controller:delete_station_from_route(station_tag)

	elseif result == sqc.city.city_transport_regional_station_check.everything_is_ok then
		controller:add_station_to_route(station_tag, route)
	
	elseif result == sqc.city.city_transport_regional_station_check.station_too_far then
		show_message(framework:strings():load("*CityTransportStationTooFar", "Station too far"))

	elseif result == sqc.city.city_transport_regional_station_check.unknown_error then
		print("[regional_route] on_station_press something strnage for: " .. station_tag)
	end

	framework:tutorial():fire_event(station_tag .. "_button:touch", 1)
end

function make_station_buttons()
	for i=2, #all_posible_stations do
		local station_button = dialog:find_child(all_posible_stations[i].station_tag .. "_button", true, false)
		if station_button then
			station_button.action = function() on_station_press(all_posible_stations[i].station_tag) end	
		end

		local station_image = dialog:find_child(all_posible_stations[i].station_tag, true, false)
		if station_image then
			station_image.visible = all_posible_stations[i].built_for_needed_stage			
		end
	end
end

function draw_bridges()
	for i = 1, #bridges_names do
		local bridge_image = dialog:find_child(bridges_names[i] .. "_build", true, false)
		if bridge_image then
			bridge_image.visible = controller:is_bridge_built(bridges_names[i])
		end
	end
end

function draw_statistic()
	local train_info_layer = dialog:find_child("train_info_layer", true, false)
	if train_info_layer then
		train_info_layer.visible = false
	end

	local statistic_layer = dialog:find_child("statistic_layer", true, false)
	if statistic_layer then
		statistic_layer.visible = true
	end

	local start_bg = dialog:find_child("start_bg", true, false)
	if start_bg then
		start_bg.visible = false
	end

	local passengers_progress_label = dialog:find_child("passengers_progress_label", true, false)
	if passengers_progress_label then
		passengers_progress_label.caption = string.format("%d / %d", controller.all_stations_passengers_productivity, controller.all_stations_max_passengers_productivity)
	end

	if controller.all_stations_passengers_productivity >= controller.all_stations_max_passengers_productivity then
		local passengers_red_progress = dialog:find_child("passengers_red_progress", true, false)
		if passengers_red_progress then
			passengers_red_progress.pos = 100
			passengers_red_progress.visible = true
		end

		local passengers_progress = dialog:find_child("passengers_progress", true, false)
		if passengers_progress then
			passengers_progress.visible = false
		end
	else
		local passengers_progress = dialog:find_child("passengers_progress", true, false)
		if passengers_progress then
			passengers_progress.pos = (controller.all_stations_passengers_productivity / controller.all_stations_max_passengers_productivity) * 100
			passengers_progress.visible = true
		end

		local passengers_red_progress = dialog:find_child("passengers_red_progress", true, false)
		if passengers_red_progress then
			passengers_red_progress.visible = false
		end
	end

	local coins_progress_label = dialog:find_child("coins_progress_label", true, false)
	if coins_progress_label then
		coins_progress_label.caption = string.format("%s / %s", 
													framework:formats():format_digit_compact(controller.all_stations_coins_productivity, false, true), 
													framework:formats():format_digit_compact(controller.all_stations_max_coins_productivity, false, true))
	end

	if controller.all_stations_coins_productivity >= controller.all_stations_max_coins_productivity then
		local coins_red_progress = dialog:find_child("coins_red_progress", true, false)
		if coins_red_progress then
			coins_red_progress.pos = 100
			coins_red_progress.visible = true
		end
	
		local coins_progress = dialog:find_child("coins_progress", true, false)
		if coins_progress then
			coins_progress.visible = false
		end
	else
		local coins_progress = dialog:find_child("coins_progress", true, false)
		if coins_progress then
			coins_progress.pos = (controller.all_stations_coins_productivity / controller.all_stations_max_coins_productivity) * 100
		end

		local coins_red_progress = dialog:find_child("coins_red_progress", true, false)
		if coins_red_progress then
			coins_red_progress.visible = false
		end
	end

	local upgrade_button = dialog:find_child("upgrade_button", true, false)
	if upgrade_button then
		upgrade_button.active = controller.need_upgrade_central_station
	end

	local upgrade_label = dialog:find_child("upgrade_label", true, false)

	if upgrade_label then
		if controller.need_upgrade_central_station then
			upgrade_label.caption = framework:strings():load("*CityUpgrade", "Upgrade") .. " " .. controller.object_description
		else
			local s = framework:strings():load("*CityTransportStatisticDlgMaxUpgraded", "%s max upgraded")
			upgrade_label.caption = string.format(s, controller.object_description)
		end
	end
	
end

function update_information_bubbles()
	passengers_information = dialog:find_child("passengers_information", true, false)
	if passengers_information then
		passengers_information.visible = false
		local values = passengers_information:find_child("values", true, false)
		if values then
			values.caption = string.format(framework:strings():load("*CityTransportCountPerHour", "+%d per hour"), controller:current_vehicle_passengers_productivity())
		end
	end

	coins_information = dialog:find_child("coins_information", true, false)
	if coins_information then
		coins_information.visible = false
		local values = coins_information:find_child("values", true, false)
		if values then
			values.caption = string.format(framework:strings():load("*CityTransportCountPerHour", "+%d per hour"), controller:current_vehicle_coins_productivity())
		end
	end

	points_information = dialog:find_child("points_information", true, false)
	if points_information then
		points_information.visible = false
		local values = points_information:find_child("values", true, false)
		if values then
			values.caption = string.format(framework:strings():load("*CityMaterialsQuantityLabel", "%d out of %d"), controller:get_route_length(), controller:get_route_max_length())
		end
	end
end

function update_central_station()
	local station_green_square = dialog:find_child("central_station_notselected", true, false)
	
	local station_orange_square = dialog:find_child("central_station_selected", true, false)

	if is_statictic_dlg == true then
		station_orange_square.visible = false
		station_green_square.visible = true
	else
		station_orange_square.visible = true
		station_green_square.visible = false
	end
end

function update()
	if not dialog then return end

	if is_statictic_dlg == true then
		draw_statistic()
	else
		draw_train_information()
	end
	make_station_buttons()
	draw_ways_between_stations()
	draw_stations()
	update_central_station()
	draw_station_bubbles()
	update_information_bubbles()

	local ways_layer = dialog:find_child("ways_layer", true, false)
	local decoration_layer = dialog:find_child("decoration_layer", true, false)
	local stations_state_layer = dialog:find_child("stations_state_layer", true, false)
	local bubbles_layer = dialog:find_child("bubbles_layer", true, false)
	local information_layer = dialog:find_child("information_layer", true, false)

	ways_layer:raise()
	decoration_layer:raise()
	stations_state_layer:raise()
	bubbles_layer:raise()
	information_layer:raise()
end

function on_init_dialog()
    dialog:load_content("regional_route_dlg")    

    all_posible_stations = controller:get_stations_list()
    
    controller.update_dialog_callback = function()
		update()
	end

	draw_bridges()

	update()
end

function on_upgrade_button_action()
	controller:goto_upgrade_station_dlg()
end

function show_information_bubble(widget_name)
	hide_information_bubble()
	
	information_bubble = dialog:find_child(widget_name, true, false)
	if information_bubble then
		information_bubble.visible = true
	end
end

function on_passengers_info_button_action()
	if information_bubble then
		if information_bubble.tag ~= "passengers_information" then
			show_information_bubble("passengers_information")
		else
			hide_information_bubble()
		end
	else
		show_information_bubble("passengers_information")
	end
end

function on_coins_info_button_action()
	if information_bubble then
		if information_bubble.tag ~= "coins_information" then
			show_information_bubble("coins_information")
		else
			hide_information_bubble()
		end
	else
		show_information_bubble("coins_information")
	end
end

function on_poins_info_button_action()
	if information_bubble then
		if information_bubble.tag ~= "points_information" then
			show_information_bubble("points_information")
		else
			hide_information_bubble()
		end
	else
		show_information_bubble("points_information")
	end
end

function on_central_station_button_action()
	if is_statictic_dlg == false then return end 

	move_to_station("central_station")
end
