current_use_specialists = 1

function on_init_dialog()

    dialog.theme_flags = 0
    dialog.bevel_type = milk_bevel_type_none
    dialog.dialog_type = 1
    
    dialog:load_content('select_specialists_dlg')
        
    create_dialog_elements()    
end

function create_dialog_elements()
    
    current_use_specialists = object_info.max_man
    if current_use_specialists > all_specialists then
        current_use_specialists = all_specialists
    end
    
    local dialog_title = dialog:find_child("dialog_title", true, false)
    if dialog_title then
        if object_info.contract_lvl_count > 1 then
            dialog_title.caption = string.format(dialog_title.caption, object_info.description, object_info.next_contract_level, object_info.contract_lvl_count)
        else
            dialog_title.caption = object_info.description
        end
    end
    
    local info_plate = dialog:find_child("info_plate", true, false)
    if info_plate then
        local object_info_plate = dialog:create_child(info_plate, object_info)
        info_plate.object_name = object_info.type_name
        if contract_exp > 0 then
            info_plate:add_show_property(8, contract_exp)
        end
        info_plate:layout_controls()
    end
    
    local current_specialists_count = dialog:find_child("current_specialists_count", true, false)
    if current_specialists_count then
        caption_for_selected_count = current_specialists_count.caption
    end
    
    select_progress = dialog:find_child("select_progress", true, false)
    if select_progress then
        select_progress.range = { 0, object_info.max_man }
        
        progress_width = select_progress.rect[3]
    end
    
    m_separators = {}
    -- m_separators_orange = {}
    local progress_bg = dialog:find_child("progress_bg", true, false)
    if progress_bg then
        m_progress_bg_rect = progress_bg.rect

        for i = 1, object_info.max_man-1 do
            local specialists_separator = framework:json_ui_manager():create_from_resource("specialists_separator", progress_bg)
            
            local rect = specialists_separator.rect
            rect[1] = m_progress_bg_rect[3] / object_info.max_man * i
            specialists_separator.rect = rect
            table.insert(m_separators, #m_separators+1, specialists_separator)
        end
    end
    
    local select_specialists_bg = dialog:find_child("select_specialists_bg", true, false)
    if select_specialists_bg then
        m_progress_bg_rect[1] = (dialog.rect[3]/2 - select_specialists_bg.rect[3]/2) + (select_specialists_bg.rect[3]/2 - m_progress_bg_rect[3]/2)
        m_progress_bg_rect[2] = select_specialists_bg.rect[2] + m_progress_bg_rect[2]
    end

    local cost_label = dialog:find_child("cost_label", true, false)
    local coins_icon = dialog:find_child("coins_icon", true, false)
    if contract_cost == 0 then
        if coins_icon then
            coins_icon.visible = false
        end
        if cost_label then
            cost_label.visible = false
        end
    end
    
    
    if cost_label then
        cost_label.caption = framework:formats():format_digit_grouping(contract_cost)
    end
    
    update_dialog()
end

function point_in_rect(x, y, rect)
    return (rect[1] <= x) and (rect[2] <= y) and ((rect[1] + rect[3]) > x) and ((rect[2] + rect[4]) > y) 
end

function on_touch(x, y)
    if point_in_rect(x, y, m_progress_bg_rect) == true then
        local local_x = x - m_progress_bg_rect[1]
        local section_length = m_progress_bg_rect[3] / object_info.max_man
        current_use_specialists = math.ceil(local_x / section_length)
        
        if current_use_specialists > all_specialists then
            current_use_specialists = all_specialists
        elseif current_use_specialists < 0 then
            current_use_specialists = 0
        elseif current_use_specialists > object_info.max_man then
            current_use_specialists = object_info.max_man
        end
        
        update_dialog()
    end
end

function update_dialog()

    if select_progress then
        select_progress.pos = current_use_specialists
    end

    for i = 1, #m_separators do
        separator_orange = m_separators[i]:find_child("progress_separator_orange", true, false)
        separator_blue = m_separators[i]:find_child("progress_separator_blue", true, false)
        
        if i < current_use_specialists then
            separator_orange.visible = true
            separator_blue.visible = false
        elseif i == current_use_specialists then
            separator_orange.visible = false
            separator_blue.visible = false
        else
            separator_orange.visible = false
            separator_blue.visible = true
        end
     end
    
    local progress_info_bg = dialog:find_child("progress_info_bg", true, false)
    if progress_info_bg then
        local rect = progress_info_bg.rect
        rect[1] = progress_width / object_info.max_man * current_use_specialists - rect[3] / 2
        progress_info_bg.rect = rect
    end
    
    local current_specialists_count = dialog:find_child("current_specialists_count", true, false)
    if current_specialists_count then
        current_specialists_count.caption = string.format(caption_for_selected_count, current_use_specialists, object_info.max_man)
    end
    
    local specialist_count = dialog:find_child("specialist_count", true, false)
    if specialist_count then
        specialist_count.caption = string.format('%d', all_specialists - current_use_specialists)
    end
    
    local time_bg = dialog:find_child("time_bg", true, false)
    local train_btn = dialog:find_child("train_btn", true, false)
            
    if all_specialists == 0 then
        if time_bg then
            time_bg.visible = false
        end
        if train_btn then
            train_btn.visible = true
        end
    else
        if time_bg then
            time_bg.visible = true
        end
        if train_btn then
            train_btn.visible = false
        end
    end

    
    local time_label = dialog:find_child("time_label", true, false)
    if time_label then
        local produce_time  = object_info:get_stage_length_vehicle(framework:object_factory(), current_use_specialists);
        time_label.caption = framework:formats():format_time_as_flash(produce_time/1000, false)
    end
    
    
    local plus_btn = dialog:find_child("plus_btn", true, false)
    if plus_btn then
        if (current_use_specialists == object_info.max_man) or (current_use_specialists == all_specialists) then
            plus_btn.active = false
        else
            plus_btn.active = true
        end
    end
    
    local minus_btn = dialog:find_child("minus_btn", true, false)
    if minus_btn then
        if current_use_specialists == 0 then
            minus_btn.active = false
        else
            minus_btn.active = true
        end
    end

    local start_btn = dialog:find_child("start_btn", true, false)
    if start_btn then
        if current_use_specialists < object_info.min_man then
            start_btn.active = false
        else
            start_btn.active = true
        end
    end

end

function on_start_btn_action()
    if framework:game().coins < contract_cost then
        framework:dialogs():show_not_enough_coins_dialog()
        do return end
    end
        
    local cmd_name = "sqc_produce_bus"
    local cmd_meta = cclasses[cmd_name]
    if not cmd_meta then
       error('not found command class ' .. cmd_name)
    end   
    
    local cmd

    cmd = cmd_meta.new(object_info.type_name, object_id, current_use_specialists, 0)
    print("cmd == ", cmd)
    
    if start_cb then
       cmd:append_complete_callback(start_cb)
    end


    framework:cmd_processor():schedule(cmd)
    
    dialog:end_dialog()
end

function on_start_btn_unactive_action()
    local params={}
    -- 0: sqc_message_box_type_default
    -- 1: sqc_message_box_type_local_error
    -- 2: sqc_message_box_type_server_error
    params.type = 0
    params.dlg_title = framework:strings():load("*CommonBuyError","Error")
    params.dlg_text = framework:strings():load("*CityNotEnoughtSpecialists","Not enough specialists")
    params.button_text = framework:strings():load("*CityOKButton","OK")
    framework:dialogs():show_message_box( params );
end

function on_plus_btn_action()
    current_use_specialists = current_use_specialists + 1
    if current_use_specialists > object_info.max_man then
        current_use_specialists = object_info.max_man
    end

    update_dialog()
end

function on_minus_btn_action()
    current_use_specialists = current_use_specialists - 1
    if current_use_specialists < 0 then
        current_use_specialists = 0
    end
    update_dialog()
end

function on_train_btn_action()
    local field = framework:game():get_field()
    local object_provider = framework:object_factory()
    local education_object = framework.quests_processor:find_object_on_field_by_quest_tag("technical_university_building", field, object_provider)

    framework:windows():close_all_modals()
    if education_object then
        if education_object.object_state == sqc.object_state_standby then
            framework:scene_view():focus_on_object_without_bubble(education_object, true)
            local object_highlight = {}
            framework:country_view():show_contracts_shop(education_object.id, false, object_highlight)
        else
            framework:scene_view():focus_on_object(education_object, true)
        end
    else
        framework:dialogs():show_object_in_shop_dialog("technical_university_city_factory_base")
    end
end

function on_close_btn_action()
	if close_cb then
		close_cb()
	end
    dialog:end_dialog() 
end