--------------- CONSTANTS ----------
local CAPTION_NAME_FROM_BUNDLE = "login_window_caption"

----------------- CONFIG -----------

local use_custom_caption_image=true
local use_custom_background=true
local use_custom_progress_bar=true
local use_custom_city_image=true
local use_custom_progress_bar_text=true
local use_preloader=true

local g_path = ""

local g_bacground_name= g_path .. "login_window_bg"
local g_city_image= g_path .. "login_window_city"

local g_preloader_image= g_path .. "preloader"
local g_preloader_background= g_path .. "preloader_bgr"

-----Caption-------------------------
local caption_image_width_phone=219
local caption_image_height_phone=105

local caption_image_width_tablet=438
local caption_image_height_tablet=211

local g_caption_name= CAPTION_NAME_FROM_BUNDLE

----------------- VARS -------------

local g_background={}
local g_dialog_rect={}
local g_progress=0
local g_stars={}
local g_tr_preloader={}
local g_tr_preloader_string={}
local g_progress_text_widget
local g_progress_bar

local g_progress_image_index=0
local g_progress_bar_widget={}
local g_progress_bar_blick_widget={}
local g_progress_bar_mask_widget={}

local g_last_progress_update_time=0

local g_progress_images={}
g_progress_images[0]=g_path .. "loading_progress_base_new_0"
g_progress_images[1]=g_path .. "loading_progress_base_new_1"
g_progress_images[2]=g_path .. "loading_progress_base_new_2"

local preloader
local l_background
local city_image
local caption
local preloader_str

local mask_offset
local mask_width
local progress_bar_rect

local preloader_image_width
local preloader_image_height    

-----------------------------------
-----------OFFSETS-----------------

local city_image_vertical_offset_from_center=0.0

local caption_image_vertical_offset_from_top=0.01
local caption_image_gorizontal_offset_from_centre=0.02

local progress_bar_vertical_ofset_from_bottom=0.03

------------------------------------

----------Image sizes---------------
--------City------------------------
local city_image_width_phone=480
local city_image_height_phone=320

local city_image_width_tablet=980
local city_image_height_tablet=674

-------------------------------------

-----------Progress bar--------------

local progress_bar_width_phone=205
local progress_bar_height_phone=24

local progress_bar_width_tablet=482
local progress_bar_height_tablet=45

local progress_bar_mask_offset_phone=10
local progress_bar_mask_width_phone=188

local progress_bar_mask_offset_tablet=12
local progress_bar_mask_width_tablet=457

---------------------------------------------

function on_init_dialog()
    print('LUA SPLASH SCREEN FROM SPLASH_SCREEN_IMAGES.ZIP')

    if(not dialog.need_to_show_preloader) then
        use_preloader=false
    end
     
    dialog.use_custom_background=use_custom_background
    dialog.use_custom_progress_bar=use_custom_progress_bar
    dialog.use_custom_caption_image=use_custom_caption_image
    dialog.use_custom_city_image=use_custom_city_image
    dialog.use_custom_progress_bar_text=use_custom_progress_bar_text
    
    g_dialog_rect=framework:windows().desktop.rect
    
    dialog.rect=g_dialog_rect
    
    create_widgets()
end


function on_post_init_dialog()
end


function end_dialog()
    print("[LUA]END OF DIALOG CALLED")
    framework:windows():animation():cancel_animation(g_tr_preloader)
    framework:windows():animation():cancel_animation(g_tr_preloader_string)
end

function create_black_backgroud()
    print("lua drawbackgroud black")
    local rect = g_dialog_rect 

    l_background=framework:json_ui_manager():create_widget(dialog,'milk_image',{0,0,rect[3],rect[4]})
     
    print("background rect: ",rect[1],rect[2],rect[3],rect[4])
    l_background.image_name="black_pattern"
    
    l_background.rotated=false
    l_background.stretch=true

end

function create_widgets()
   
    g_dialog_rect=framework:windows().desktop.rect
	
    if(g_dialog_rect[3] > g_dialog_rect[4]) then
    	print("lua create_widgets")
		if(use_custom_background) then
		   create_backgroud()
		end
   
    
		if(use_custom_caption_image) then
			create_caption_image()
		end
	
		if(use_custom_city_image) then
			create_city_image()
		end
	
	
		if(use_preloader) then
			create_preloader()
		end
	
		if(use_custom_progress_bar) then
			create_progress()
		end
	
	
		if(use_custom_progress_bar_text) then
		--    create_progress_bar_text()
		end
	else
		create_black_backgroud()
	end
end


function get_background_image_name()
    local device = g_device;
    g_background.is_background_rotated=false
    if g_device.is_phone then 
        print("LUA:  get_background_image_name phone")
        local rect=g_dialog_rect

        --if(rect[3] == 480) then
        --     g_background.background_name = g_bacground_name
        --elseif (rect[3] == 568) then
        --     g_background.background_name = g_bacground_name .. "_568h@2x"
        --else
        
        g_background.background_name = g_bacground_name
        
        --end

        g_background.is_background_rotated = true
  
       
    elseif g_device.is_tablet then
        g_background.background_name = g_bacground_name .. "_ipad"
   
    else 
        g_background.background_name = g_bacground_name
    end
end

function create_backgroud()
    print("lua drawbackgroud")
    local rect = g_dialog_rect 
    if (0 == #g_background) then
      get_background_image_name()
      print("LUA: draw_backgroud: backgr: ",g_background.background_name," is_rotated ",g_background.is_background_rotated) 
    end

    --local 
    l_background=framework:json_ui_manager():create_widget(dialog,'milk_image',{0,0,rect[3],rect[4]})
     
    print("background rect: ",rect[1],rect[2],rect[3],rect[4])
    l_background.image_name=g_background.background_name
    
    l_background.rotated=false
    l_background.stretch=true
    
    
    --g_background.is_background_rotated
    
    
end

function create_preloader()
    print("LUA draw preloader")
    local rect = g_dialog_rect 
    dialog.use_preloader=use_preloader
    --local 
    preloader=framework:json_ui_manager():create_widget(dialog,'milk_image',{0,0,rect[3],rect[4]})
    
    preloader.tag="preloader"
    
    preloader.alpha=1
    
    preloader.stretch=true
    
    --g_preloader = preloader
    

    
    if g_device.is_phone then
       preloader_image_width=254
       preloader_image_height=44
    else
       preloader_image_width=505
       preloader_image_height=85
    end
    
    local preloader_str_json="{\"type\": \"milk_image\",\"rect\":[0," .. preloader_image_height/2 .. ",".. preloader_image_width ..",".. preloader_image_height .. "], \"halign\": \"center\",\"valign\": \"center\"}"
    
    --local 
    preloader_str=framework:json_ui_manager():create_from_string( preloader_str_json, "preloader_str", preloader )
    
    --local preloader_str=framework:json_ui_manager():create_widget(preloader,'milk_image',{rect[3]/4,rect[4]/2,rect[3],rect[4]/2})
    
    if g_device.is_phone then
       preloader_str.image_name=g_preloader_image
       preloader.image_name=g_preloader_background
    else
       preloader_str.image_name=g_preloader_image .. "_ipad"
       preloader.image_name=g_preloader_background .. "_ipad"
    end
    
    preloader_str.alpha=1
    
    g_tr_preloader_string=preloader_str:transform()
    g_tr_preloader=preloader:transform()
    
    framework:windows():animation():add_animator(g_tr_preloader_string,
        cclasses.animation_animator_sequency.new(false)
        :add(cclasses.animation_animator_alpha.new( 3, 0, 1 ))
        :add(cclasses.animation_animator_pause.new( 0.5 ))
        :add(cclasses.animation_animator_event.new( 
            function()
                
    			framework:windows():animation():add_animator(g_tr_preloader,
    			    cclasses.animation_animator_sequency.new(false)
    				:add(cclasses.animation_animator_alpha.new( 2, 0, 1 ))
    				:add(cclasses.animation_animator_scale.new( 2, 1.4, 1))
    				:add(cclasses.animation_animator_pause.new( 1 ))
    				:add(cclasses.animation_animator_event.new( 
    			        function()
    					    dialog.preload_finished=true  
    					end
    				))
    			)
                                    
                                    
            end
        ))
    )
   
    print("LUA end of preloader animation")
    
end


function update_progress()
   if(g_dialog_rect[3] > g_dialog_rect[4]) then
	
	   if(not (g_progress_bar_widget.visible) ) then
		   g_progress_bar_widget.visible=true
		   g_progress_bar_mask_widget.visible=false
	   end
   
	--   print("g_progress ",g_progress)
   
	   update_progress_image()
   
		local mask_offset
		local mask_width

		if g_device.is_phone then
		  mask_offset=progress_bar_mask_offset_phone
		  mask_width=progress_bar_mask_width_phone
		else
		  mask_offset=progress_bar_mask_offset_tablet
		  mask_width=progress_bar_mask_width_tablet
		end
   
	   local rect=g_progress_bar_mask_widget.rect
   
	   local old_x=rect[1]
	   rect[1]=mask_offset+mask_width*g_progress
	   if( g_progress < 0.9 ) then
		   rect[3]=rect[3] + (old_x - rect[1])
	   else
		  rect[3]=0
	   end
   
	   g_progress_bar_mask_widget.rect=rect
   
   
	--   print("progres: rect ", rect[1], " rect ",rect[3])
  end
   
end

function update_progress_image()
	if(g_dialog_rect[3] > g_dialog_rect[4]) then
	
    	g_progress_image_index = (g_progress_image_index +1) % #g_progress_images
       
    	local progress_image=add_postfix(g_progress_images[g_progress_image_index])
    	g_progress_bar_widget.texture_name=progress_image
    end

end

function resize_to_screen()
	print("start of resize_to_screen")
	g_dialog_rect=framework:windows().desktop.rect
	g_dialog_rect[4] = g_dialog_rect[4]
	g_dialog_rect[3] = g_dialog_rect[3]

	------------ background, city image, city caption image
	if(use_custom_background) then	
		l_background.rect = g_dialog_rect
	end

	if(g_dialog_rect[3] > g_dialog_rect[4])  then

		------------ preloader image

		if(use_preloader) then
			preloader.rect = g_dialog_rect
	
		------------ preloader string  
		r = preloader_str.rect
		r[1] = (g_dialog_rect[3] - preloader_image_width)/2   
		r[2] = (g_dialog_rect[4] - preloader_image_height)/2 + preloader_image_height/2
		preloader_str.rect=r	
		end
		------------ background, city image, city caption image
		if(use_custom_background) then	
			l_background.rect = g_dialog_rect
		end


		if(use_custom_city_image) then
			r = city_image.rect
			r[1] = (g_dialog_rect[3] - r[3])/2   
			r[2] = (g_dialog_rect[4] - r[4])/2 
			city_image.rect = r
		end

		if(use_custom_caption_image) then
			r = caption.rect
			r[1] = (g_dialog_rect[3] - r[3])/2   
			r[2] = (g_dialog_rect[4] - r[4]) 
			caption.rect = r
		end

		------------ progress
		if (use_custom_progress_bar) then
			r = g_progress_plate_widget.rect
			r[1] =    (g_dialog_rect[3] - progress_bar_rect[3])/2
			r[2] =    (g_dialog_rect[4]*progress_bar_vertical_ofset_from_bottom)
			g_progress_plate_widget.rect=r
		end
	end
end


function on_timer(tick)
   local curr_time=sstl_time_game.tick_count_msec
   if(math.abs(curr_time - g_last_progress_update_time) >= 1000 ) then
   	if(g_dialog_rect[3] > g_dialog_rect[4]) then
       update_progress_image()
    end
       g_last_progress_update_time=curr_time
    
   end

end

function create_progress_font()
    print("LUA: draw progress font")
end

function create_city_image()
    print("LUA: draw city images")
    local rect=g_dialog_rect
    
    local image_width
    local image_height
    
    if g_device.is_phone then
       image_width=city_image_width_phone
       image_height=city_image_height_phone
    else
      image_width=city_image_width_tablet
      image_height=city_image_height_tablet
    end
   
    local city_image_json="{\"type\": \"milk_image\",\"rect\":[0," .. -g_dialog_rect[3]*city_image_vertical_offset_from_center .. ",".. image_width ..",".. image_height .. "], \"halign\": \"center\",\"valign\": \"center\"}"
    
    --local 
    city_image=framework:json_ui_manager():create_from_string( city_image_json, "city_image", dialog )
    
--    print("city_image_size ",city_image.rect[1]," ",city_image.rect[2]," ",city_image.rect[3]," ",city_image.rect[4])
    if g_device.is_phone then
        city_image.image_name=g_city_image
    else
       city_image.image_name=g_city_image .. "_ipad"
    end
end

function create_caption_image()
    print("LUA: draw caption image")
    
    local image_width
    local image_height
    
    if g_device.is_phone then
       image_width=caption_image_width_phone
       image_height=caption_image_height_phone
    else
       image_width=caption_image_width_tablet
       image_height=caption_image_height_tablet
    end
    
    local offset_from_top = g_dialog_rect[3]*caption_image_vertical_offset_from_top;
    local caption_image_json="{\"type\": \"milk_image\",\"rect\":[" .. g_dialog_rect[3]*caption_image_gorizontal_offset_from_centre .. "," .. offset_from_top .. "," .. image_width .. "," .. image_height .. "], \"halign\": \"center\",\"valign\": \"top\"}"
    
    caption=framework:json_ui_manager():create_from_string( caption_image_json, "caption_image", dialog )
    
    if g_device.is_phone then
        caption.image_name=g_caption_name
    else
       caption.image_name=g_caption_name .. "_ipad"
    end
end

function set_progress(progress)
--   print("LUA: set_progress ",progress)
   g_progress=progress
   update_progress()
end 

function set_progress_text(text)
   update_progress_text(text)
end

function update_progress_text(text)
	if(g_dialog_rect[3] > g_dialog_rect[4]) then
  		if(use_custom_progress_bar) then
      		g_progress_text_widget.caption=text
   			update_progress()
  		end
  	end
end

function add_postfix(image_name)
    local image_name2=image_name

    if not g_device.is_phone then
        image_name2=image_name2 .. "_ipad"
    end

    return image_name2
end



function create_progress()
    local width
    local height
    local font_size

    if g_device.is_phone then
      width=progress_bar_width_phone
      height=progress_bar_height_phone
      font_size=5
      mask_offset=progress_bar_mask_offset_phone
      mask_width=progress_bar_mask_width_phone
      
    else
      width=progress_bar_width_tablet
      height=progress_bar_height_tablet
      font_size=12
      mask_offset=progress_bar_mask_offset_tablet
      mask_width=progress_bar_mask_width_tablet
    end 
    
    progress_bar_rect={0,0,width,height}
    
    local progress_json="{\"type\": \"milk_image\", \"text_halign\": \"center\",\"text_valign\": \"center\",\"text_truncation\": \"disabled\",\"color\": [0, 0, 0, 255],\"rect\": [0," .. g_dialog_rect[4]*progress_bar_vertical_ofset_from_bottom .. "," .. width .. "," .. height .. "],\"text_shadow\": true,\"shadow_color\": [0, 0, 0, 76],\"shadow_size\": [-1, 1],\"halign\": \"center\",\"valign\": \"bottom\",\"font\": { \"face\": \"Arial-BoldItalicMT.otf\" }}"
    g_progress_plate_widget=framework:json_ui_manager():create_from_string( progress_json, "progress_bar", dialog )
    g_progress_plate_widget.image_name=add_postfix(g_path .. "loading_progress_plate_new")

    
    local text_json="{\"type\": \"milk_label\", \"outline_type\": \"double\", \"outline_soft\": true, \"rect\": [0,0," .. width .. "," .. height .. "], \"outline_color\": [255, 255, 255, 255 ], \"text_halign\": \"center\",\"text_valign\": \"center\",\"text_truncation\": \"disabled\",\"color\": [0, 0, 0, 255],\"halign\": \"center\",\"valign\": \"center\",\"font\": { \"face\": \"Arial-BoldItalicMT.otf\", \"size\": " .. font_size .. "}}"
    g_progress_text_widget=framework:json_ui_manager():create_from_string( text_json, "progress_bar_text", g_progress_plate_widget )
    g_progress_text_widget.tag="progress_bar_text"
    
    
    local progress_json3="{\"type\": \"sqc_proxy_texture_widget\",  \"rect\": [0,0," .. width .. "," .. height .. "],  \"halign\": \"center\",\"valign\": \"center\" }"
    g_progress_bar_widget=framework:json_ui_manager():create_from_string( progress_json3, "progress_bar_widget", g_progress_plate_widget) 
    g_progress_bar_widget.texture_name=add_postfix(g_progress_images[g_progress_image_index])
    g_progress_bar_widget.visible=false
    
    
    local mask_image_name=add_postfix(g_path .. "plaska_new")
    local progress_json2="{\"type\": \"milk_slice_image\", \"image_name\": \"" .. mask_image_name .. "\", \"rect\": [" .. mask_offset ..",0," .. mask_width .. "," .. height .. "], \"9way_info\": { \"offsets\": [14, 0, 10, 0], \"tile\": \"none\", \"draw_center\": true },  \"halign\": \"center\",\"valign\": \"center\" }"
    g_progress_bar_mask_widget=framework:json_ui_manager():create_from_string( progress_json2, "progress_bar_mask_widget", g_progress_plate_widget )
    g_progress_bar_mask_widget.visible=false
    
   
    local progress_json4="{\"type\": \"milk_image\",  \"rect\": [0,0," .. width .. "," .. height .. "],  \"halign\": \"center\",\"valign\": \"center\" }"
    g_progress_bar_blick_widget=framework:json_ui_manager():create_from_string( progress_json4, "progress_bar_blick_widget", g_progress_plate_widget )
    g_progress_bar_blick_widget.image_name=add_postfix(g_path .. "loading_progress_blick_new")
end


