package.loaded.train_transport_design = nil
train_transport_design = require "train_transport_design"

local transport_image = {
	"bus",
	--"train",
	"airplane",
	"ship",
	"truck",
	"rocket"
}

local transport_button_type = {
	button_cell_0 = "bus",
	--button_cell_1 = "train",
	button_cell_2 = "airplane",
	button_cell_3 = "ship",
	button_cell_4 = "truck",
	button_cell_5 = "rocket"
}

local research_sort_type_bus = {
	"car_mover", "auto_electrics", "car_engine" , "car_body",
	"car_wheels", "onboard_computer", "transmission" , "car_interior",
	"car_tires", "fuel_injection", "blended_fuel" , "conditioners",
	"suspension", "recuperative_braking", "hybrid_engine" , "interior_lighting",
	"car_dampers", "parktronic", "car_exhaust_system" , "car_seats",
	"stabilizer_suspension", "cruise_control", "car_engine_turbine" , "car_airbags"
}

local research_sort_type = { ["bus"] = research_sort_type_bus }


local sort_reserach_list = {}
local research_list = {}
local need_research_list = {}

local num_tick = 0
local process_end = 0 
local timer_reseach_progress_label = ""
local research_idx = -1;
local current_transport_type = "bus";
local visible_info_research = false

local info_research_caption_rect = {}
local info_research_item_rect = {}

local m_page_destroed = false

local progress_widget
local can_force_research = true

function on_timer (tick)
--	if process_end <= 0 then
--		return;
--	end
	
	if research_idx == -1 then
--		print("not research execting")
		return;
	end
	
	if tick > num_tick then
		num_tick = tick + 1000
		process_end = process_end - 1
		
		update_research_progress_timer()
	end
end

function update_research_progress_timer()

--	print("process_end = ", process_end)

	if process_end <= 0  then
		update_page_with_reload()
		return
	end

	timer_reseach_progress_label = framework:formats():format_time(process_end)
	
	local button = page:find_child("transport_button_cell_" .. research_idx, true, false)
	if button then
		local research_progress_timer_label = button:find_child("research_progress_timer_label", true, false)
		if research_progress_timer_label then
			research_progress_timer_label.caption = timer_reseach_progress_label
			research_progress_timer_label.text_adjust_font_size = true
		end
	end
end

function on_destroy_page()
	m_page_destroed = true
end

function show_info_bevel(show)
	local info_bevel = page:find_child("info_bevel", true, false)
	if info_bevel == nil then
    	print("[transport_dlg:show_info_bevel] Can't find info_bevel")
    	return
    end
    
	if show then
		if info_bevel and info_bevel.visible == false then
			info_bevel.visible = true
			info_bevel:layout_controls(framework:strings():load("*TransportResearchTreeNotAvailable", "Available in the next version "))
		end
	else
		if info_bevel and info_bevel.visible == true then
			info_bevel.visible = false
		end
	end
	
end

function show_transport_table(show)
	
    local transport_table = page:find_child('transport_table', true, false)
    if transport_table == nil then
    	print("[transport_dlg:show_transport_table] Can't find transport_table")
    	return
    end
    
	if show then
		transport_table.visible = true
			
		for i = 1,4 do
			local strip = page:find_child("strip"..i, true, false)
			if strip then
				strip.visible = true
			end
		end
		
		transport_table.column_quantity = 4
		transport_table:update_content()
	else
		transport_table.visible = false
			
		for i = 1,4 do
			local strip = page:find_child("strip"..i, true, false)
			if strip then
				strip.visible = false
			end
		end
	end
end

function update_page()

    if train_transport_design.need_update() == false then
    	return
    end

    
	if m_page_destroed then
		return
	end
	
	hide_info_research()
	
	research_idx = -1;
	sort_reserach_list = {}

	if research_sort_type[current_transport_type] and #research_sort_type[current_transport_type] > 0 then
		for i = 1,#research_sort_type[current_transport_type] do
			for j = 1,#research_list do
				if research_sort_type[current_transport_type][i] == research_list[j].contract_name then
					sort_reserach_list[i] = research_list[j];
				end
			end
		end
	else
		sort_reserach_list = research_list;
	end
	
	
--	for i = 1,#sort_reserach_list do
--		print("number 		= ", i)
--		print("name 		= ", sort_reserach_list[i].name)
--		print("image_name 	= ", sort_reserach_list[i].image_name)
--		print("current_level= ", sort_reserach_list[i].current_level)
--		print("need_level	= ", sort_reserach_list[i].need_level)
--		print("research_transport_type = ", sort_reserach_list[i].research_transport_type)
--		print("contract_name= ", sort_reserach_list[i].contract_name)
--		print("cost 		= ", sort_reserach_list[i].cost)
--		print("exp	 		= ", sort_reserach_list[i].exp)
--		print("in_progress 	= ", sort_reserach_list[i].research_in_progress)
--		print("unlocks_for_start size	= ", #sort_reserach_list[i]:unlocks_for_start())
--		for j = 1, #sort_reserach_list[i]:unlocks_for_start() do
--			print("----------", sort_reserach_list[i]:unlocks_for_start()[j])
--		end
--		print("require_buildings size	= ", #sort_reserach_list[i]:require_buildings())
--		for j = 1, #sort_reserach_list[i]:require_buildings() do
--			print("----------", sort_reserach_list[i]:require_buildings()[j])
--			
--			local object_info = framework:object_factory():get_object_info_by_type_name(sort_reserach_list[i]:require_buildings()[j])
--			print("object_info.description = ",object_info.description)
--			print("object_info.product_name = ",object_info.product_name)
--			print("object_info.shop_image_path = ",object_info.shop_image_path)
--		end
--		print("unlocks_complete size	= ", #sort_reserach_list[i]:unlocks_complete())
--		for j = 1, #sort_reserach_list[i]:unlocks_complete() do
--			print("----------", sort_reserach_list[i]:unlocks_complete()[j])
--		end
--		print("---------------------------------------------------")
--	end

	if current_transport_type == "train" then
		show_info_bevel(false)
		show_transport_table(false)
		set_train_controller(controller)
		show_trains(page, true)
	else
		show_trains(page, false)
		if #sort_reserach_list == 0 then
			show_info_bevel(true)
		    show_transport_table(false)
		else
			show_info_bevel(false)
		    show_transport_table(true)
		end
	end
	
end

function update_page_with_reload()
	if progress_widget and progress_widget.is_force_progress_animation then
		progress_widget.finish_callback = function()
			update_page_with_reload()
		end

		return
	end
	
	can_force_research = true

	print("update_page_with_reload(); current_transport_type = ", current_transport_type)
	research_list = controller:fill_research(current_transport_type)
	
	update_page()
end

function on_init_page()

	page:load_content('transport')
	
	local parent = page:get_parent()
	controller:set_correct_balance_widget_type(parent)
	
	current_transport_type = controller.transport_type

	research_list = controller:get_research_items()
	
	local update_dlg_callback = function()
									update_page_with_reload()
								end
	
	controller:set_update_dialog_callabck(update_dlg_callback)
	
	update_page()

	local transport_table = page:find_child('transport_table', true, false)
	if transport_table then
		transport_table:scroll_to_top()
	end

	local button_table = page:find_child('button_table', true, false)
	if button_table then
		button_table:update_content()
	end


	local info_research_caption = page:find_child("research_caption", true, false)
	if info_research_caption then
		info_research_caption_rect = info_research_caption.rect
	end
	
	local info_research_item = page:find_child("research_item", true, false)
	if info_research_item then
		info_research_item_rect = info_research_item.rect
	end
end


function on_cell_select(indx)
	
	for i = 0, 5 do
  		local button_cell = page:find_child('button_cell_'..i, true, false)
  		
  		if button_cell then
  			button_cell.active = true
  		end
	end
	
	
	local button_cell = page:find_child('button_cell_'..indx, true, false)
	if button_cell then
		button_cell.active = false
		
		current_transport_type = transport_button_type["button_cell_" .. indx]
		research_list = controller:fill_research(transport_button_type["button_cell_" .. indx]) 
		
		update_page()
	end
	
end

button_table_delegate = {
	create_cell = function ( self, idx, rect)
		
		local w = self.table:create_child(rect)
		
		framework:json_ui_manager():build_from_resource("button_table_cell",w)
		w.rect = rect
		
		local button = w:find_child('button_cell', true, false)
		if button then
			button.tag = button.tag .. "_" .. idx;
			button.action = function ()
				on_cell_select( idx )
			end
			
			local type_image = button:find_child("type_transport", true, false)
			if type_image then
				type_image.image_name = get_device_texture_name(transport_image[idx+1])
			end
		end

		local button_transport_type = transport_button_type["button_cell_" .. idx]
		if current_transport_type == button_transport_type then
			local button_cell = page:find_child('button_cell_' .. idx, true, false)
			if button_cell then
				button_cell.active = false
			end
		end

		return w
	end,
	
	get_cell_count = function ( )
		return 5
    end
}

function get_device_texture_name(texture_name)
	if g_device.is_tablet then
		return texture_name .. "_ipad"
	end
	return texture_name
end

function set_cell_bg(texture_name, texture_last_row_name, idx)
	
	if idx+4 < #sort_reserach_list then
		return get_device_texture_name(texture_name)
	end
	
	return get_device_texture_name(texture_last_row_name)
end

function set_cell_pressed_bg(texture_pressed_name, texture_last_pressed_name, idx)
	if idx+4 < #sort_reserach_list then
		return get_device_texture_name(texture_pressed_name)
	end
	
	return get_device_texture_name(texture_last_pressed_name)
end

function set_appearence_transport_cell(parent_widget, cell_name, image, last_row_image, pressed_image, last_row_pressed_image, lock_visible, idx)
	
	local transport_button_cell = parent_widget:find_child(cell_name, true, false)
	if transport_button_cell then
		local cell_bg = transport_button_cell:find_child("cell_bg", true, false)
		if cell_bg then	
			cell_bg.image_name = set_cell_bg(image, last_row_image, idx)
			cell_bg.pressed_image = set_cell_pressed_bg(pressed_image, last_row_pressed_image, idx)
		end
		
		local lock_bg = transport_button_cell:find_child("lock_bg", true, false)
		if lock_bg then
			lock_bg.visible = lock_visible
		end
	end
	
end

local_can_complete_unlocks = false

function check_research_diagramm(idx)

	need_research_idx = 1
	need_research_list = {}

	for i = 1, #sort_reserach_list do
		for j = 1, #sort_reserach_list[idx+1]:unlocks_for_start() do
			for k = 1, #sort_reserach_list[i]:unlocks_complete() do
				if sort_reserach_list[idx+1]:unlocks_for_start()[j] == sort_reserach_list[i]:unlocks_complete()[k] then
					local_can_complete_unlocks = true
					need_research_list[need_research_idx] = i-1
					need_research_idx = need_research_idx+1
				end
			end
		end
	end
end

function show_research_diagramm(idx)
	for i = 1, #sort_reserach_list do
		for j = 1, #sort_reserach_list[idx+1]:unlocks_for_start() do
			for k = 1, #sort_reserach_list[i]:unlocks_complete() do
				if sort_reserach_list[idx+1]:unlocks_for_start()[j] == sort_reserach_list[i]:unlocks_complete()[k] then
					local_can_complete_unlocks = true
					need_unloc_idx = i-1
					set_appearence_transport_cell(page, 'transport_button_cell_'..need_unloc_idx, "item_yellow", "item_yellow_4", "item_yellow_1", "item_yellow_5", false, need_unloc_idx)
				end
			end
		end
	end
end

function progect_bus(idx)
	local object_info = framework:object_factory():get_object_info_by_type_name(sort_reserach_list[idx+1]:unlocks_for_start()[1])
	framework:dialogs():city_transport_research(object, object_info.type_name)
end

function build(idx)
	local object_info = framework:object_factory():get_object_info_by_type_name(sort_reserach_list[idx+1]:require_buildings()[1])
	framework:dialogs():action_requied_scriptable_dlg(object_info.type_name,sort_reserach_list[idx+1].contract_name)
end

function start_contract(idx)
	print("start contract idx = ", idx)
	update_page_with_reload()
end

function force_research(idx)
	print("force research idx = ", idx)
	if progress_widget then
		if progress_widget.is_force_progress_animation then
			return
		end
		
		progress_widget:force_progress()
		can_force_research = false
	end
	controller:force_research(sort_reserach_list[idx+1])
end

function try_start_research(idx)
	if research_idx == -1 then		
		controller:start_research(sort_reserach_list[idx+1])				
	else
		close_callback = 	function()
							end
		
		local params={}
		-- 0: sqc_message_box_type_default
		-- 1: sqc_message_box_type_local_error
		-- 2: sqc_message_box_type_server_error
		params.type = 0
		params.dlg_text = framework:strings():load("*TransportResearchTreeAlredyInProcess", "Another research is executing. Wait for completion")
		params.button_text = framework:strings():load("*CityOKButton","OK" )
		params.on_close_callback = close_callback
		framework:dialogs():show_message_box( params );
	end
end

function transport_table_cell_select(idx)

	if visible_info_research == true then
		hide_info_research()
		return
	end

	if sort_reserach_list[idx+1].current_level ==  sort_reserach_list[idx+1].need_level then
		return
	end

	for i = 0, #sort_reserach_list-1 do
		if sort_reserach_list[i+1].research_in_progress == true then
			set_appearence_transport_cell(page, 'transport_button_cell_'..i, "item_blue", "item_blue_4", "item_blue_1", "item_blue_5", true, i)
		else		
			if #sort_reserach_list[i+1]:unlocks_for_start() ~= 0 then
				set_appearence_transport_cell(page, 'transport_button_cell_'..i, "item_grey_2", "item_grey_4", "item_grey_3", "item_grey_5", true, i)
			elseif sort_reserach_list[i+1].current_level <  sort_reserach_list[i+1].need_level then
				set_appearence_transport_cell(page, 'transport_button_cell_'..i, "item_grey", "item_grey_4", "item_grey_1", "item_grey_5", true, i)
			end
		end
	end
	
	if #sort_reserach_list[idx+1]:unlocks_for_start() ~= 0 then
		set_appearence_transport_cell(page, 'transport_button_cell_'..idx, "item_blue_2", "item_blue_4", "item_blue_3", "item_blue_5", false, idx)
	else
		set_appearence_transport_cell(page, 'transport_button_cell_'..idx, "item_blue", "item_blue_4", "item_blue_1", "item_blue_5", false, idx)
	end
	
	
	local_can_complete_unlocks = false


	if sort_reserach_list[idx+1].research_in_progress then
		
		if (progress_widget and progress_widget.is_force_progress_animation) or can_force_research == false then
			return
		end
		
		local level_text = framework:strings():load("*TransportResearchTreeLevelCell", "lev.")
		local next_level  = sort_reserach_list[idx+1].current_level + 1
		
		local research_force_price = controller:research_force_price(sort_reserach_list[idx+1])	

		local object_info = framework:object_factory():get_object_info_by_type_name(sort_reserach_list[idx+1].contract_name)

		local force_dlg = cclasses.sqc_scriptable_dialog.create(framework:windows().desktop, "force_object_msgbox.lua")
	
		if force_dlg and object_info then
			force_dlg.scripting_object.m_object_info = object_info	
			force_dlg.scripting_object.object_name = sort_reserach_list[idx+1].name .. " " .. level_text .. object_info.next_contract_level.."/"..sort_reserach_list[idx+1].need_level
			force_dlg.scripting_object.force_cost = research_force_price
			force_dlg.scripting_object.force_callback = function()
															force_research(idx)
														end
			force_dlg:do_modal()
		end
		return
	end



	
	
	check_research_diagramm(idx)	-- change local_can_complete_unlocks
	
	if local_can_complete_unlocks == false then
	
		if #sort_reserach_list[idx+1]:unlocks_for_start()>0 then

			action_callback = 	function()
										progect_bus(idx)
								end
									
			close_callback = 	function()
									show_research_diagramm(idx)
								end
					
			local level_text = framework:strings():load("*TransportResearchTreeLevelCell", "lev.")
		
			local object_info = framework:object_factory():get_object_info_by_type_name(sort_reserach_list[idx+1]:unlocks_for_start()[1])
			
			
			
			local description_text = framework:strings():load("*TransportResearchTreeAlertRequiredText", "Required:\n %s");
			description_text = string.format(description_text, object_info.description)

			local params={}
            -- 0: sqc_message_box_type_default
            -- 1: sqc_message_box_type_local_error
            -- 2: sqc_message_box_type_server_error
            params.type = 0
			params.dlg_title = sort_reserach_list[idx+1].name .. " " .. level_text .. sort_reserach_list[idx+1].current_level.."/"..sort_reserach_list[idx+1].need_level
			params.dlg_text = description_text
			params.button_text = framework:strings():load("*CityOKButton","OK" )
			params.on_ok_callback = action_callback
			params.on_close_callback = close_callback
			framework:dialogs():show_message_box( params );

			return 
		end
	end


	if #sort_reserach_list[idx+1]:unlocks_for_start() == 0 then
		if #sort_reserach_list[idx+1]:require_buildings() == 0 then			
			try_start_research(idx)
			return
		end
	end

	
	if #need_research_list > 0 then 

		local transport_button_cell = page:find_child("transport_button_cell_"..idx, true, false)
		if transport_button_cell then
			
			local transport_table = page:find_child('transport_table', true, false)
			if transport_table then
			
				down, height, abs_cell_position = calculate_position(idx, transport_table, transport_button_cell)
			
				if check_and_move_scroll(down, height, abs_cell_position, transport_table) then
					down, height, abs_cell_position = calculate_position(idx, transport_table, transport_button_cell)
				end
				
				middle = (down + height)/2
				
				local info_research = page:find_child("info_research" , true, false)
				if info_research then
					info_research.visible = true
					
					middle_info_research = info_research.rect[4]/2
					diff_middle = middle - middle_info_research
					
					rect = info_research.rect
					rect[2] = diff_middle
					
					if g_device.is_phone then
						rect[2] = rect[2] + 10
					end
					
					if idx%4 == 0 then
						rect[1] = transport_button_cell.rect[3]
					elseif idx%4 == 1 then
						rect[1] = transport_button_cell.rect[3] * 2
					elseif idx%4 == 2 then
						rect[1] = transport_button_cell.rect[3] * 2 - rect[3]
						
						if g_device.is_phone then
							rect[1] = rect[1] + 10
						end
					elseif idx%4 == 3 then
						rect[1] = transport_button_cell.rect[3] * 3 - rect[3]
						
						if g_device.is_phone then
							rect[1] = rect[1] + 10
						end
					end
					
					info_research.rect = rect
				end
				
				if idx%4 < 2 then
					info_research.image_name = get_device_texture_name("transport_right")
					info_research.pressed_image = get_device_texture_name("transport_right")
				else
					info_research.image_name = get_device_texture_name("transport_left")
					info_research.pressed_image = get_device_texture_name("transport_left")
				end
				
				
				local info_research_caption = info_research:find_child("research_caption", true, false)
				if info_research_caption then
					info_research_caption.caption = framework:strings():load("*TransportResearchTreeInfoCaption", "Need research:")
					info_research_caption.text_adjust_font_size = true
									
					local rect = {}
					if calculate_info_item_position(info_research_caption_rect, rect, idx) == true then
						info_research_caption.rect = rect
					end
				end
				
				
				local info_research_item = info_research:find_child("research_item", true, false)
				if info_research_item then
					
					local level = framework:strings():load("*TransportResearchTreeInfoLevel", "level")
					local caption = sort_reserach_list[need_research_list[1]+1].name .. " ".. level .. sort_reserach_list[need_research_list[1]+1].current_level + 1
					for i = 2, #need_research_list do
						caption = caption ..'\n' .. sort_reserach_list[need_research_list[i]+1].name .. " ".. level .. sort_reserach_list[need_research_list[i]+1].current_level + 1	
					end
	
					info_research_item.caption = caption
					info_research_item.text_adjust_font_size = true
					
					local rect = {}		
					if calculate_info_item_position(info_research_item_rect, rect, idx) == true then
						info_research_item.rect = rect
					end
				end
				
				
				local info_research_close_button = info_research:find_child("info_research_close_button", true, false)
				if info_research_close_button then
	
					visible_info_research = true
					
					local show = false
					for need_research_idx = 1, #need_research_list do
						if #sort_reserach_list[need_research_list[need_research_idx]+1]:unlocks_for_start() ~= 0 or #sort_reserach_list[need_research_list[need_research_idx]+1]:require_buildings() ~= 0 then
							show = true
						end
					end
						
						
					
					local research_button_label = info_research:find_child("research_button_label", true, false)
					if research_button_label then
						if show then		
							research_button_label.caption = framework:strings():load("*TransportResearchTreeInfoShow", "Show")
						else
							research_button_label.caption = framework:strings():load("*TransportResearchTreeInfoResearch", "Research")
						end
						research_button_label.text_adjust_font_size = true
					end
	
					
					info_research_close_button.action = function()
															info_research_close_button_action(idx, show)
														end
														
					transport_table.set_pre_scroll_begin_callback = function()
																		scroll_begin()
																	end
																	
				end
				
				show_research_diagramm(idx)
				return
				
			end
		end
	end
	

	if #sort_reserach_list[idx+1]:require_buildings()>0 then

		action_callback = 	function()
								build(idx)
							end
		
		close_callback = 	function()
								show_research_diagramm(idx)
							end
													
		local level_text = framework:strings():load("*TransportResearchTreeLevelCell", "lev.")

		local object_info = framework:object_factory():get_object_info_by_type_name(sort_reserach_list[idx+1]:require_buildings()[1])
		
		local description_text = framework:strings():load("*TransportResearchTreeAlertBuildText", "To execute research required: %s. Want to build?");
		description_text = string.format(description_text, object_info.description)

		local params={}
        -- 0: sqc_message_box_type_default
        -- 1: sqc_message_box_type_local_error
        -- 2: sqc_message_box_type_server_error
        params.type = 0
		params.dlg_title = sort_reserach_list[idx+1].name .. " " .. level_text .. sort_reserach_list[idx+1].current_level.."/"..sort_reserach_list[idx+1].need_level
		params.dlg_text = description_text
		params.button_text = framework:strings():load("*CityOKButton","OK" )
		params.on_ok_callback = action_callback
		params.on_close_callback = close_callback
		framework:dialogs():show_message_box( params );
			
		show_research_diagramm(idx)
		return
	end

	show_research_diagramm(idx)
end

function calculate_info_item_position(research_rect, rect, idx)

	if research_rect[1] then
	
		for i, v in pairs(research_rect) do
			rect[i] = v
		end

		if idx%4 < 2 then
			rect[1] = rect[1] + 4
		else
			rect[1] = rect[1] - 4
		end
	else
		return false
	end
	
	return true
end


function calculate_position(idx, transport_table, transport_button_cell)
	
	hight_cell = transport_button_cell.rect[4]
	
	current_cell_row = idx%4
	current_row = (idx - current_cell_row) / 4
	
	quantity_row = #research_list/4 - 1

	
	down = hight_cell *(quantity_row - current_row) - transport_table.scroll_pos[2]
	height = hight_cell *((quantity_row - current_row)+1) - transport_table.scroll_pos[2]
	
	
	return down, height, hight_cell *(quantity_row - current_row)
end

function check_and_move_scroll(down, height, abs_cell_position, transport_table)
	
	if down < 0 then
		pos = transport_table.scroll_pos
		pos[2] = abs_cell_position --hight_cell *(quantity_row - current_row)
		transport_table.scroll_pos = pos
		return true
	end
	
	if height > transport_table.rect[4] then
		pos = transport_table.scroll_pos
		pos[2] = pos[2] + height - transport_table.rect[4]
		
		if g_device.is_phone then
			pos[2] = pos[2] + 15
		end
		
		transport_table.scroll_pos = pos
		return true
	end
	
	return false
end

function hide_info_research()
	local info_research = page:find_child("info_research", true, false)
	if info_research then
		info_research.visible = false
		visible_info_research = false
	end
end

function info_research_close_button_action(idx, show)
	hide_info_research()

	local transport_button_cell = page:find_child("transport_button_cell_"..need_research_list[1], true, false)
	if transport_button_cell then

		local transport_table = page:find_child('transport_table', true, false)
		if transport_table then

			down, height, abs_cell_position = calculate_position(need_research_list[1], transport_table, transport_button_cell)
			check_and_move_scroll(down, height, abs_cell_position, transport_table)
		end
	end
	
	if show == true then
		return
	end
	
	try_start_research(need_research_list[1])
end

function scroll_begin()
	hide_info_research()
end

transport_table_delegate = {
	create_cell = function (  self, idx, rect )
		
		local w = self.table:create_child(rect)
		                
        framework:json_ui_manager():build_from_resource("transport_table_cell",w)
        w.rect = rect
       	
       	local button = w:find_child("transport_button_cell", true, false)
       	if button then
       		button.tag = button.tag .. "_" .. idx
       		button.action = function()
       			transport_table_cell_select(idx)
       		end
       	end
       	       	

		local cell = w:find_child('cell',true,false)
		if cell then

			local cell_bg = cell:find_child("cell_bg", true, false)
			if cell_bg then
					
				cell_bg.action = function()
       				transport_table_cell_select(idx)
       			end
					
				if sort_reserach_list[idx+1].research_in_progress == true then
					cell_bg.image_name = set_cell_bg("item_blue", "item_blue_4", idx)
					cell_bg.pressed_image = set_cell_pressed_bg("item_blue_1", "item_blue_5", idx)
					
					research_idx = idx;
					
					local detail_icon = cell_bg:find_child("detail_icon", true, false)
					if detail_icon then
						detail_icon.alpha = 0.5
					end
					
					local research_progress_bg = cell_bg:find_child("research_progress_bg", true, false)
					if research_progress_bg then
						research_progress_bg.visible = true
						
						local research_progress_label = research_progress_bg:find_child("research_progress_label", true, false)
						if research_progress_label then
							research_progress_label.caption = framework:strings():load("*TransportResearchTreeResearchInProgress", "Research in progress")
							research_progress_label.text_adjust_font_size = true
						end
						
						local level_label = research_progress_bg:find_child("level_label", true, false)
						if level_label then
							local level_text = framework:strings():load("*TransportResearchTreeLevelCell", "lev.")
							local next_level = sort_reserach_list[idx+1].current_level + 1
							level_label.caption = level_text .. next_level.."/"..sort_reserach_list[idx+1].need_level
							level_label.text_adjust_font_size = true
						end
					end
											
					local research_progress_timer_label = cell_bg:find_child("research_progress_timer_label", true, false)
					if research_progress_timer_label then
					
						local research_progress_time = controller:research_in_progress_time(sort_reserach_list[idx+1])
					
						research_progress_timer_label.caption = framework:formats():format_time(research_progress_time/1000)
						research_progress_timer_label.text_adjust_font_size = true
						
						process_end = research_progress_time/1000
					end
					
					progress_widget = cell_bg:find_child("progress_widget", true, false)
					if progress_widget then
						progress_widget.background_image = "development_progress_background"
						progress_widget.sectors_image = "progress_mask_development"
						
						progress_mask = cell_bg:find_child("progress_mask", true, false)
						if progress_mask then
							local progress_animation_size = {progress_mask.rect[3], progress_mask.rect[4]}
							local progress_animation_offset = {progress_mask.rect[1], progress_mask.rect[2]}
							
							progress_widget.image_size = progress_animation_size
							progress_widget.progress_offset = progress_animation_offset
						end

						local current_progress_time = controller:research_in_progress_time(sort_reserach_list[idx+1])
						local all_progress_time = controller:research_length_time(sort_reserach_list[idx+1]) * 1000
						progress_widget.current_progress_time = all_progress_time - current_progress_time
						progress_widget.all_progress_time = all_progress_time

						progress_widget:start_animation()
					end
				else
--					print("is_heed_highlight = ", controller:is_heed_highlight(sort_reserach_list[idx+1]))
					
					if sort_reserach_list[idx+1].current_level ==  sort_reserach_list[idx+1].need_level then
						cell_bg.image_name = set_cell_bg("item_green_0", "item_green_4", idx)
						cell_bg.pressed_image = set_cell_pressed_bg("item_green_1", "item_green_5", idx)
					elseif controller:is_heed_highlight(sort_reserach_list[idx+1]) == true then
						cell_bg.image_name = set_cell_bg("item_blue", "item_blue_4", idx)
						cell_bg.pressed_image = set_cell_pressed_bg("item_blue_1", "item_blue_5", idx)
					else
						cell_bg.image_name = set_cell_bg("item_grey", "item_grey_4", idx)
						cell_bg.pressed_image = set_cell_pressed_bg("item_grey_1", "item_grey_5", idx)
					end
				end
	
				
				local level_research = cell_bg:find_child("level_research", true, false)
				if level_research then
					local level_text = framework:strings():load("*TransportResearchTreeLevelCell", "lev.")
					local level_caption = level_text..sort_reserach_list[idx+1].current_level.."/"..sort_reserach_list[idx+1].need_level
					level_research.caption = level_caption
				end
				
				local button_type_research_icon = cell_bg:find_child("type_research_icon", true, false)
				if button_type_research_icon then
					if sort_reserach_list[idx+1].research_in_progress == true then
						button_type_research_icon.image_name = get_device_texture_name("accelerate_0")
						button_type_research_icon.pressed_image = get_device_texture_name("accelerate_1")
					else
						if sort_reserach_list[idx+1].current_level ==  sort_reserach_list[idx+1].need_level then
							local icon_rect = button_type_research_icon.rect
							if g_device.is_tablet then
								icon_rect[2] = icon_rect[2] + 5
								icon_rect[4] = icon_rect[4] - 5
							else
								icon_rect[2] = icon_rect[2] + 3
								icon_rect[4] = icon_rect[4] - 3
							end
							button_type_research_icon.rect = icon_rect	
						
							button_type_research_icon.image_name = get_device_texture_name("diamonds_2_check")
							button_type_research_icon.pressed_image = get_device_texture_name("diamonds_2_check")
						elseif #sort_reserach_list[idx+1]:unlocks_for_start() == 0 then
							button_type_research_icon.image_name = get_device_texture_name("study_0")
							button_type_research_icon.pressed_image = get_device_texture_name("study_1")
						else
							button_type_research_icon.image_name = get_device_texture_name("see_diagram_0")
							button_type_research_icon.pressed_image = get_device_texture_name("see_diagram_1")
						end
					end
					
					button_type_research_icon.action = function()
       					transport_table_cell_select(idx)
       				end
				end
				
				
				local start_button = cell_bg:find_child("start_button", true, false)
				if start_button then

					local object_info = framework:object_factory():get_object_info_by_type_name(sort_reserach_list[idx+1].contract_name)
					
					if sort_reserach_list[idx+1].current_level == 0 and object_info.show_start_button == true and sort_reserach_list[idx+1].research_in_progress == false then
					
						start_button.visible = true
						
						local start_label = start_button:find_child("start_label", true, false)
						if start_label then
							start_label.caption = framework:strings():load("*TransportResearchTreeStart", "Start")
						end
						
						local level_research_bg = cell_bg:find_child("level_research_bg", true, false)
						if level_research_bg then
							level_research_bg.visible = false
						end
						
						local button_type_research_icon = cell_bg:find_child("type_research_icon", true, false)
						if button_type_research_icon then
							button_type_research_icon.visible = false
						end
					end
					
					start_button.tag = start_button.tag .. "_" .. idx
					
					start_button.action = 	function()
												transport_table_cell_select(idx)
											end
				end
			end
			
			local lock_bg = cell:find_child("lock_bg", true, false)
			if lock_bg then
				lock_bg.visible = false
			end
			
			local lock = cell:find_child("lock", true, false)
			if lock then
				if #sort_reserach_list[idx+1]:unlocks_for_start() == 0 and #sort_reserach_list[idx+1]:require_buildings() == 0 then
					lock.visible = false
					
					local detail = cell_bg:find_child("detail_icon", true, false)
					if detail then
						detail.texture_name = sort_reserach_list[idx+1].image_name
						detail:set_ready_progress_as_indicator()
					end
				else
					local detail = cell_bg:find_child("grayscaled_detail_icon", true, false)
					if detail then
						detail.texture_name = sort_reserach_list[idx+1].image_name
						detail:set_ready_progress_as_indicator()
					end
					
					if controller:is_heed_highlight(sort_reserach_list[idx+1]) == false then
						cell_bg.image_name = set_cell_bg("item_grey_2", "item_grey_4", idx)
						cell_bg.pressed_image = set_cell_pressed_bg("item_grey_3", "item_grey_5", idx)
					end
					
				end
			end
		end

		local cell_label = w:find_child("cell_label", true, false)
		if cell_label then
			cell_label.tag = cell_label.tag..idx
			cell_label.caption = sort_reserach_list[idx+1].name
			cell_label.text_adjust_font_size = true
		end
  
        return w
	end,
	
	get_cell_count = function ( )
		return  #research_list
    end
}
